/* this is the string map for CSV.              */
/* basically its a " followed by hex 1,2 and 4. */
/* hex 1 2 and 4 are registered trademark,      */
/* trademark and copyright                      */
 %macro map;
    %if &sysscp=MVS or &sysscp=CMS %then %do;
       '7F010204'x
       %end;
    %else %do;
       '22010204'x
    %end;
 %mend;

/*----------------------------------------------------------
 * Macro not8 addresses 508 requirements strictly for use
 * with the V9.0 SAS code
 *----------------------------------------------------------*/
 %macro not8(text);
   %if  %substr(&sysver,1,1) ^= 8 %then &text;
   %mend;

/*----------------------------------------------------------
 * Macro not9 addresses 508 requirements strictly for use
 * with the V8.2 SAS code
 *----------------------------------------------------------*/
 %macro not9(text);
   %if  %substr(&sysver,1,1) ^= 9 %then &text;
   %mend;


proc template;

    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    /* Event Map.  Shows all events generated...                       */
    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    define tagset tagsets.event_map;
        notes "This is the event map definition";
        map = '<>&';
        mapsub = '/&lt;/&gt;/&amp;/';
        nobreakspace = ' ';
        split = ' ';
        indent=2;
        default_event = 'basic';
        stacked_columns = yes;
        output_type = 'xml';

                define event doc;
            start:
                put '<?xml version="1.0"';
                putq " encoding=" encoding;
                put "?>" CR CR;
                put "<" EVENT_NAME ;
                putq " title="        TITLE;
                putq " author="       AUTHOR;
                putq " operator="     OPERATOR;
                putq " sasversion="   SASVERSION;
                putq " saslongversion="   SASLONGVERSION;
                putq " date="         DATE;
                putq " time="         TIME;
                putq " encoding="     ENCODING;
                putq " language="     LANGUAGE;
                putq " trantab="      TRANTAB;
                trigger attr_out;
                put ">" CR;
                ndent;
            finish:
                xdent;
                put "</" EVENT_NAME '>';
        end;

                define event basic;
            start:
                put "<" EVENT_NAME ;
                trigger attr_out;
                put "/" / if cmp ("colspecsep", event_name);
                put "/" / if exists(empty);
                put ">" CR;
                break / if cmp ("colspecsep", event_name);
                break / if exists(empty);
                ndent;
            finish:
                break / if exists(empty);
                break / if cmp ("colspecsep", event_name);
                xdent;
                put "</" EVENT_NAME ">" CR;
                end;

        define event attr_out;
            putq " event_name="   EVENT_NAME;
            putq " trigger_name=" TRIGGER_NAME;
            %not8(putq " output_name="  OUTPUT_NAME;)
            %not8(putq " output_label="  OUTPUT_LABEL;)
/*
            %not8(putq " total_page_count="   total_page_count;)
            %not8(putq " page_count="         page_count;)
            %not8(putq " proc_count="   proc_count;)
            %not8(putq " total_proc_count="   total_proc_count;)
            %not8(putq " proc_name="    proc_name;)
*/
            %not8(putq " hidden="       hidden;)
            %not8(putq " dropshadow="     dropshadow;)
            %not8(putq " transparency="   transparency;)
            putq " asis="         asis;
            putq " section="      SECTION;
/*
            putq " state="        STATE;
            putq " empty="        EMPTY;
*/
            putq " class="        HTMLCLASS;
            putq " id="           HTMLID;
            putq " text="         TEXT;
            putq " value="        VALUE;
            putq " rowspan="      ROWSPAN;
            putq " colspan="      COLSPAN;
            putq " row="          ROW;
            %not8(putq " data_row="     DATA_ROW;)
            putq " colcount="     COLCOUNT;
            putq " col="          COLSTART;
            putq " col_id="       COL_ID;
            putq " ref_id="       REF_ID;
            putq " name="         NAME;
            putq " label="        LABEL;
            putq " clabel="       CLABEL;
            putq " type="         TYPE;
            putq " rawvalue="     RAWVALUE;
            putq " missing="      MISSING;
            putq " path="         PATH;
            putq " flyover="      FLYOVER;
            putq " index="        ANCHOR;
            putq ' just='         JUST;
            putq ' vjust='        VJUST;
            putq " font-face="    FONT_FACE;
            putq " font-size="    FONT_SIZE;
            putq " font-weight="  FONT_WEIGHT;
            putq " font-style="   FONT_STYLE;
            putq " foreground="   FOREGROUND;
            putq " background="   BACKGROUND;
            putq " backgroundImage=" BACKGROUNDIMAGE;
            putq " leftmargin="    LEFTMARGIN;
            putq " rightmargin="   RIGHTMARGIN;
            putq " topmargin="     TOPMARGIN;
            putq " bottommargin="  BOTTOMMARGIN;
            putq " BorderColorDark=" BORDERCOLORDARK;
            putq " BorderColorLight=" BORDERCOLORLIGHT;
            putq " bullet="       BULLET;
            putq " outputheight=" OUTPUTHEIGHT;
            putq " outputwidth="  OUTPUTWIDTH;
            putq " tagattr="      TAGATTR;
            putq " htmlstyle="    HTMLSTYLE;
            putq " width="        WIDTH;
            putq " scale="        SCALE;
            putq " precision="    PRECISION;
            putq " url="          URL;
            putq " hreftarget="   HREFTARGET;
        end;
    end;


    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    /*  pyx Format.  Easy format for manipulation                      */
    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    define tagset tagsets.pyx;
        notes "This is the pyx definition";
        default_event = 'basic';
        stacked_columns = yes;
        output_type = 'xml';
        split = '\n-';

                define event basic;
            start:
                put "(" EVENT_NAME CR;
                put "-" VALUE;
                trigger attr_out;
            finish:
                put ")" EVENT_NAME CR;
                end;

        define event attr_out;
            %not8(putq "Ahidden "       hidden CR;)
            %not8(putq "Adropshadow "     dropshadow nl;)
            %not8(putq "Atransparency "   transparency nl;)
            putq "Aasis "         asis nl;
            putq "Asection "      SECTION CR;
            putq "Astate "        STATE CR;
            putq "Aempty "        EMPTY CR;
            putq "Aclass "        HTMLCLASS CR;
            putq "Aid "           HTMLID CR;
            putq "Acol_id "       COL_ID CR;
            putq "Aref_id "       REF_ID CR;
            putq "Arowspan "      ROWSPAN CR;
            putq "Acolspan "      COLSPAN CR;
            putq "Acolcount "     COLCOUNT CR;
            putq "Acol "          COLSTART CR;
            putq "Acol_id "       COL_ID CR;
            putq "Aref_id "       REF_ID CR;
            putq "Aname "         NAME CR;
            putq "Alabel "        LABEL CR;
            putq "Aclabel "       CLABEL CR;
            putq "Atype "         TYPE CR;
            putq "Arawvalue "     RAWVALUE CR;
            putq "Amissing "      MISSING CR;
            putq "Apath "         PATH CR;
            putq "Aflyover "      FLYOVER CR;
            putq "Aindex "        ANCHOR CR;
            putq 'Ajust '         JUST CR;
            putq 'Avjust '        VJUST CR;
            putq "Afont-face "    FONT_FACE CR;
            putq "Afont-size "    FONT_SIZE CR;
            putq "Afont-weight "  FONT_WEIGHT CR;
            putq "Afont-style "   FONT_STYLE CR;
            putq "Aforeground "   FOREGROUND CR;
            putq "Abackground "   BACKGROUND CR;
            putq "AbackgroundImage " BACKGROUNDIMAGE CR;
            putq "Aleftmargin "    LEFTMARGIN CR;
            putq "Arightmargin "   RIGHTMARGIN CR;
            putq "Atopmargin "     TOPMARGIN CR;
            putq "Abottommargin "  BOTTOMMARGIN CR;
            putq "ABorderColorDark " BORDERCOLORDARK CR;
            putq "ABorderColorLight " BORDERCOLORLIGHT CR;
            putq "Abullet "       BULLET CR;
            putq "Aoutputheight " OUTPUTHEIGHT CR;
            putq "Aoutputwidth "  OUTPUTWIDTH CR;
            putq "Atagattr "      TAGATTR CR;
            putq "Ahtmlstyle "    HTMLSTYLE CR;
            putq "Awidth "        WIDTH CR;
            putq "Ascale "        SCALE CR;
            putq "Aprecision "    PRECISION CR;
            putq "Aurl "          URL CR;
            putq "Ahreftarget "   HREFTARGET CR;
        end;

        /* get rid of some pointless events */

        define event colspecsep;
        end;
        define event rowspanfill;
        end;
        define event rowspancolspanfill;
        end;
        define event rowspanfillsep;
        end;
        define event colspanfill;
        end;
        define event colspanfillsep;
        end;
        define event rowspec;
        end;
        define event cellspec;
        end;
        define event cellspecsep;
        end;
        define event cellspecspan;
        end;


    end;

    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    /*  CHTML Format.  Wireless Markup Language for PDA's and phones     */
    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/

    define tagset tagsets.chtml;
        notes "This is the CHTML definition";
        map = '<>&';
        mapsub = '/&lt;/&gt;/&amp;/';
        nobreakspace = '&nbsp;';
        split = '<br>';
        stacked_columns = yes;
        output_type = 'html';

        define event rowcol;
            putq " rowspan=" ROWSPAN;
            putq " colspan=" COLSPAN;
        end;

        define event colspecs;
            put "<p>" CR "<table";
            putq " columns=" COLCOUNT;
            put " cellpadding=2 border=1>" CR;
        end;

        define event table;
            finish:
                put "</table></p>" CR;
        end;

        define event table_head;
            start:
                put "<thead>" CR;
            finish:
                put "</thead>" CR;
        end;

        define event table_body;
            start:
                put "<tbody>" CR;
            finish:
                put "</tbody>" CR;
        end;

        define event table_foot;
            start:
                put "<tfoot>" CR;
            finish:
                put "</tfoot>" CR;
        end;


        define event row;
            start:
                put "<tr>";
            finish:
                put "</tr>" CR;
        end;

        define event verbatim;
            start:
                put "<pre>";
            finish:
                put "</pre>";
        end;


        define event header;
            start:
                put "<th";
                trigger rowcol;
                putq ' align="center"' / when cmp("c", JUST);
                putq ' align="right"' / when cmp("r", JUST);
                putq ' align="right"' / when cmp("d", JUST);
                put ">";
                put VALUE;
            finish:
                put "</th>";
        end;

        define event data;
            start:
                put "<td";
                trigger rowcol;
                putq ' align="center"' / when cmp("c", JUST);
                putq ' align="right"' / when cmp("r", JUST);
                putq ' align="right"' / when cmp("d", JUST);
        put ">";
        put '<pre>' /if exists(asis);
                put VALUE;
            finish:
        put '</pre>' /if exists(asis);
                put "</td>";
        end;

        define event breakline;
            put "<br/>";
        end;

        define event splitline;
            put "<br/>";
        end;

        define event proc_title;
            put "<h2>" VALUE "</h2>" CR;
        end;

        define event system_title;
            put "<h1>" VALUE "</h1>" CR;
        end;

        define event system_footer;
            put "<h1>" VALUE "</h1>" CR;
        end;

        define event byline;
            put "<h2>" VALUE "</h2>" CR;
        end;

        define event note;
            put "<h3>" VALUE "</h3>" CR;
        end;

        define event fatal;
            put "<h3>" VALUE "</h3>" CR;
        end;

        define event error;
            put "<h3>" VALUE "</h3>" CR;
        end;

        define event warning;
            put "<h3>" VALUE "</h3>" CR;
        end;

        define event anchor;
            putq "<a name=" NAME ">";
        end;

        define event dynamic;
            put "Content-Type: text/xml" CR CR CR;
        end;

        define event doc;
            start:
             /*
                put CR
                put '<!DOCTYPE chtml PUBLIC "-//W3C//DTD Compact HTML 1.0 Draft//EN">'
                put CR CR
                */
                put "<html>" CR;
            finish:
                put "</html>" CR;
        end;

        define event doc_head;
            start:
                put "<head>" CR;
                put VALUE CR;
            finish:
                put "</head>" CR;
        end;

        define event doc_title;
               put "<title>";
               put "SAS Output" / if !exists(VALUE);
               put VALUE;
               put "</title>" CR;
        end;

        define event doc_meta;
            put "<meta";
            put ' http-equiv="Content-type" content="' / if any(HTMLCONTENTTYPE, encoding);
            put HTMLCONTENTTYPE;
            put "; " / if exists(HTMLCONTENTTYPE, encoding);
            put " charset=" encoding;
            put '">' CR;
            put "<meta " VALUE ">" nl /if exists(value);
        end;

        define event contents;
            file=CONTENTS;
            start:
                /*
                put CR
                put '<!DOCTYPE chtml PUBLIC "-//W3C//DTD Compact HTML 1.0 Draft//EN">'
                put CR CR
                */
                put "<html>";
                put "<p>";
                put "<ol>" CR;
            finish:
                put "</ol>";
                put "</p>";
                put "</html>" CR;
        end;

        define event hyperlink;
            put '<a href="' URL;
            put '"';
            putq " target=" HREFTARGET;
            put ">" VALUE;
            put "</a>" CR;
        end;

        define event contents_branch;
            file=CONTENTS;
            start:
            put "<li>";
            trigger hyperlink / if any(URL, ANCHOR);
            put VALUE / if !any(URL, ANCHOR);
            put "</li>" CR;
            put "<ul>";
        finish:
            put "</ul>";
        end;

        define event contents_leaf;
            file=CONTENTS;
            put "<li>";
            trigger hyperlink / if any(URL, ANCHOR);
            put VALUE / if !any(URL, ANCHOR);
            put "</li>" CR;
        end;


        define event branch;
        start:
            trigger contents_branch;
        finish:
            trigger contents_branch;
        end;

        define event leaf;
        start:
           trigger contents_leaf;
        end;

        define event image;
            put "<img";
            put ' alt="graph image"';
            putq " src=" URL ">" CR ;
        end;
    end;

    /*proc istore is=sashelp.templat;list;dump;run;*/
    /****************************************************************/
    /****************************************************************/
    /****************************************************************/
    /*  CHTML I-Mode.  CHTML without tables.  for Japan             */
    /****************************************************************/
    /****************************************************************/
    /****************************************************************/


    define tagset tagsets.imode;
        parent=tagsets.chtml;
        notes "This is the CHTML I-Mode definition";

        define event colspecs;
        end;

        define event table_head;
        end;

        define event table_body;
        end;

        define event table_foot;
        end;

        define event table;
          start:
            put '<hr size="3">' CR ;
          finish:
            put '<hr size="3">' CR ;
        end;

        define event row;
            put "<hr>" CR ;
        end;

        define event header;
            start:
                put VALUE;
            finish:
                put "<br>";
        end;

        define event data;
            start:
                put VALUE;
            finish:
                put "<br>";
        end;

        define event breakline;
            put "<br>";
        end;

        define event splitline;
            put "<br>";
        end;

        define event proc_title;
            put "<p>" VALUE;
            put "</p>" CR ;
        end;

        define event system_title;
            put "<p>" VALUE;
            put "</p>" CR ;
        end;

        define event system_footer;
            put "<p>" VALUE;
            put "</p>" CR ;
        end;

        define event byline;
            put "<p>" VALUE;
            put "</p>" CR ;
        end;

        define event note;
            put "<p>" VALUE;
            put "</p>" CR ;
        end;

        define event fatal;
            put "<p>" VALUE;
            put "</p>" CR ;
        end;

        define event error;
            put "<p>" VALUE;
            put "</p>" CR ;
        end;

        define event warning;
            put "<p>" VALUE;
            put "</p>" CR ;
        end;

    end;

    /****************************************************************/
    /****************************************************************/
    /****************************************************************/
    /*  CSV Format.  tables only comma delimited format for EXcel   */
    /****************************************************************/
    /****************************************************************/
    /****************************************************************/

    define tagset tagsets.csv;
        notes "This is the CSV definition";
        map = %map;
        mapsub = '/""/(c)/(r)/(TM)/';
        stacked_columns = no;
        output_type = 'csv';


        define event table;
            start:
                put CR;
            finish:
                put CR CR;
        end;

        define event row;
            put CR;
        end;

        define event header;
          start:
            put ',' / if !cmp(COLSTART, "1");
            put '"';
            put VALUE;
          finish:
            put '"';
        end;

        define event data;
          start:
            put ',' / if !cmp(COLSTART, "1");
            put '"';
            put VALUE;
          finish:
            put '"';
        end;

        define event colspanfill;
            put ',';
        end;

        define event rowspanfill;
            put ',';
        end;

        define event breakline;
            put CR;
        end;

        define event splitline;
            put CR;
        end;

    end;

    /******************************************************/
    /******************************************************/
    /******************************************************/
    /*  CSV Byline Format.  csv with bylines              */
    /******************************************************/
    /******************************************************/
    /******************************************************/

    define tagset tagsets.csvbyline;
       parent=tagsets.csv;

       define event byline;
      putq value;
       end;
    end;

    /******************************************************/
    /******************************************************/
    /******************************************************/
    /*  CSV ALL Format.  csv with titles and bylines      */
    /******************************************************/
    /******************************************************/
    /******************************************************/

    define tagset tagsets.csvall;
        parent= tagsets.csv;
        notes "This is the CSV with titles and bylines definition";

        define event proc_title;
            put VALUE CR;
        end;

        define event system_title;
            put VALUE CR CR;
        end;

        define event system_footer;
            put VALUE CR;
        end;

        define event byline;
            put VALUE CR;
        end;

        define event note;
            put VALUE CR;
        end;

        define event fatal;
            put VALUE CR;
        end;

        define event error;
            put VALUE CR;
        end;

        define event warning;
            put VALUE CR;
        end;

    end;

    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    /*  WML Format.  Wireless Markup Language for PDA's and phones     */
    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/

    define tagset tagsets.wml;
        notes "This is the WML definition";
        map = '<>&';
        mapsub = '&lt;/&gt;/&amp;';
        nobreakspace = '&nbsp;';
        split = '<br>';
        stacked_columns = yes;
        output_type = 'wml';

        define event colspecs;
            put "<p>" CR;
            put "<table";
            putq " columns=" COLCOUNT;
            put ">" CR;
        end;

        define event table;
            finish:
                put "</table>" CR;
                put "</p>" CR;
        end;

        define event row;
            start:
                put "<tr>";
            finish:
                put "</tr>" CR;
        end;

        define event header;
            start:
                put "<td><strong>";
                put VALUE;
            finish:
                put "</strong></td>";
        end;

        define event data;
            start:
                put "<td>";
        put '<pre>' /if exists(asis);
                put VALUE;
            finish:
        put '</pre>' /if exists(asis);
                put "</td>";
        end;

        define event colspanfill;
            put "<td/>";
        end;

        define event rowspanfill;
            put "<td/>";
        end;

        define event breakline;
            put "<br/>";
        end;

        define event splitline;
            put "<br/>";
        end;

        define event proc_title;
            put "<p>" VALUE;
            put "</p>" CR;
        end;

        define event system_title;
            put "<p>" VALUE;
            put "</p>" CR;
        end;

        define event system_footer;
            put "<p>" VALUE;
            put "</p>" CR;
        end;

        define event byline;
            put "<p>" VALUE;
            put "</p>" CR;
        end;

        define event note;
            put "<p>" VALUE;
            put "</p>" CR;
        end;

        define event fatal;
            put "<p>" VALUE;
            put "</p>" CR;
        end;

        define event error;
            put "<p>" VALUE;
            put "</p>" CR;
        end;

        define event warning;
            put "<p>" VALUE;
            put "</p>" CR;
        end;

        define event anchor;
            put "</card>" CR;
            put "<card";
            putq " id=" NAME;
            put ">" CR;
        end;

        define event dynamic;
            put "Content-Type: text/xml" CR CR CR;
        end;

                define event verbatim;
                        start:
                            put "<pre>";
                        finish:
                            put "</pre>";
                end;

        define event doc;
            start:
                put '<?xml version="1.0"';
                putq " encoding=" encoding;
                put "?>" CR CR;
                put '<!DOCTYPE wml PUBLIC "-//WAPFORUM//DTD WML 1.1//EN" "http://www.wapforum.org/DTD/wml_1.1.xml">' CR CR;
                put "<wml>" CR;
                put "<template>" CR;
                put '  <do type="accept" label="Back">' CR;
                put "    <prev/>" CR;
                put "   </do>" CR;
                put "</template>" CR;
                put "<card>" CR;
            finish:
                put "</card>" CR;
                put "</wml>" CR;
        end;

        define event contents;
            file=CONTENTS;
            start:
                put '<?xml version="1.0"';
                putq " encoding=" encoding;
                put "?>" CR CR;
                putl '<!DOCTYPE wml PUBLIC "-//WAPFORUM//DTD WML 1.1//EN" "http://www.wapforum.org/DTD/wml_1.1.xml">';
                put CR;
                put "<wml>" CR;
                put "<card>" CR;
                put "<p>" CR;
                put "<select>" CR;
            finish:
                put "</select>" CR;
                put "</p>" CR;
                put "</card>" CR;
                put "</wml>" CR;
        end;

        define event branch;
            file=CONTENTS;
            start:
                put "<optgroup";
                putq " title=" value;
                put ">" CR;
            finish:
                put "</optgroup>" CR;
        end;

        define event leaf;
            file=CONTENTS;
            put '<option onpick="';
            put URL;
            put '">' value;
            put "</option>" CR;
        end;

        define event image;
            put "<img";
            put ' alt="graph image"';
            putq " src=" URL;
            put "/>" CR;
        end;
    end;

    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    /*  WML Format.  This one uses on option list for contents         */
    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/

    define tagset tagsets.wmlolist;
        parent = tagsets.wml;
        notes "This is WML with an option list directory";

        define event contents;
            file=CONTENTS;
            start:
                put '<?xml version="1.0"';
                putq " encoding=" encoding;
                put "?>" CR CR;
                put '<!DOCTYPE wml PUBLIC "-//WAPFORUM//DTD WML 1.1//EN" "http://www.wapforum.org/DTD/wml_1.1.xml">' CR CR;
                put "<wml>" CR;
                put "<card>" CR;
                put "<p>" CR;
            finish:
                put "</p>" CR;
                put "</card>" CR;
                put "</wml>" CR;
        end;

        define event leaf;
            file=CONTENTS;
            putq "<a href=" URL;
            put ">" value;
            put "</a>" CR;
        end;

    end;

    /******************************************************/
    /******************************************************/
    /******************************************************/
    /*  Plain Jane HTML definition                        */
    /******************************************************/
    /******************************************************/
    /******************************************************/
    define tagset tagsets.phtml;
        notes "This is the plain HTML definition";
        %not8(%quote(parent=tagsets.graph;))
        /* until inheritance is fixed */
        %let  map =<>%nrstr(&)%str(%')%str(%");
        map="&map";
        mapsub = '/&lt;/&gt;/&amp;/&#39;/&quot;/';
        /*  old map
        map = '<>&';
        mapsub = '/&lt;/&gt;/&amp;/';
        */
        nobreakspace = '&nbsp;';
        split = '<br>';
        stacked_columns = yes;
        output_type = 'html';


        define event dynamic;
            put "Content-Type: text/html" CR CR CR;
        end;

        define event stylesheet_link;
            putq '<link rel="STYLESHEET" type="text/css" href=' URL '>' CR / if exists(url);
        end;

        define event contents_stylesheet_link;
            putq '<link rel="STYLESHEET" type="text/css" href=' URL '>' CR / if exists(url);
        end;

        define event top_file;
            start:
                put HTMLDOCTYPE CR CR CR;
                put "<html>" CR;
                put "<!-- Generated by SAS Software -->" CR;
                put "<!-- Http://www.sas.com -->" CR;
            finish:
                put "</html>" CR;
        end;

        define event top_title;
            put "<title>";
            put "SAS Output Frame"  / if !exists(value);
            put VALUE;
            put "</title>" CR;
        end;

        define event top_code;
            start:
                put "<frameset frameborder=";

                put "YES"  / if !exists(FRAMEBORDER);
                put FRAMEBORDER;
                put " framespacing=";

                put '"3"'  / if !exists(FRAMESPACING);
                putq FRAMESPACING;

                /*  not horizontal */
                put ' cols="'  / if cmp(colcount, "2");
                /*  horizontal */
                put ' rows="' / if cmp(colcount, "1");

                /* content_frameset if content_first */
                trigger content_frameset / if cmp(type, "f");

                /* body_frameset if not content_first */
                trigger body_frameset  / if cmp(type,"l");

                put ',';

                /* body_frameset if content_first */
                trigger body_frameset / if cmp(type, "f");

                /* content_frameset if not content_first */
                trigger content_frameset  / if cmp(type, "l");

                put '">' CR;
            finish:
                put "</frameset>" CR;
        end;

        define event content_frameset;
            put "23%"  / if !exists(CONTENTSIZE);
            put CONTENTSIZE;
        end;

        define event body_frameset;
            put "*"  / if !exists(BODYSIZE);
            put BODYSIZE;
        end;

        define event content_frame;
            put '<frame marginwidth="4" marginheight="0"';
            putq " src=" URL;
            put '" name="contents" scrolling=';
            put "auto"  / if !exists(CONTENTSCROLLBAR);
            put CONTENTSCROLLBAR;
            put ">" CR;
        end;

        define event body_frame;
            put '<frame marginwidth="9" marginheight="0"';
            putq " src=" URL;
            put '" name="body" scrolling=';
            put "auto"  / if !exists(BODYSCROLLBAR);
            put BODYSCROLLBAR;
            put ">" CR;
        end;

        define event doc;
            start:
                put "<html>" CR;
                put "<!-- Generated by SAS Software -->" CR;
                put "<!-- Http://www.sas.com -->" CR;
            finish:
                put "</html>" CR;
        end;

        define event doc_head;
            start:
                put "<head>" CR;
                put VALUE CR;
                put '<style>' CR '<!--' CR;
                trigger alignstyle;
                put '-->' CR '</style>' CR;
            finish:
                put "</head>" CR;
        end;

        define event contents_head;
            start:
                trigger doc_head;
            finish:
                trigger doc_head;
        end;

        define event top_head;
            start:
                put "<head>" CR;
                put VALUE CR;
            finish:
                put "</head>" CR;
        end;

        define event doc_title;
               put "<title>";
               put "SAS Output" / if !exists(VALUE);
               put VALUE;
               put "</title>" CR;
        end;

        define event doc_meta;
            put "<meta";
            put ' http-equiv="Content-type" content="' / if any(HTMLCONTENTTYPE, encoding);
            put HTMLCONTENTTYPE;
            put "; " / if exists(HTMLCONTENTTYPE, encoding);
            put " charset=" encoding;
            put '">' CR;
            put "<meta " VALUE ">" nl /if exists(value);
        end;

        define event top_meta;
            put "<meta";
            put ' http-equiv="Content-type" content="' / if any(HTMLCONTENTTYPE, encoding);
            put HTMLCONTENTTYPE;
            put "; " / if exists(HTMLCONTENTTYPE, encoding);
            put " charset=" encoding;
            put '">' CR;
            put "<meta " VALUE ">" nl /if exists(value);
        end;


        define event doc_body;
            start:
                put '<body onload="startup()"';
                put ' onunload="shutdown()"';
                put ' bgproperties="Fixed"' / exists(WATERMARK);
                trigger style_inline;
                put ">" CR;
                put '<SCRIPT LANGUAGE="JavaScript">' CR;
                put "<!-- " CR;
                put "// This script is to load all object onLoad() functions " CR;
                put "function startup(){}" CR;
                put "function shutdown(){}" CR;
                put " "         CR;
                put "//-->"     CR;
                put "</SCRIPT>" CR;
                put          CR;
            finish:
                put "</body>" CR;
        end;

        define event doc_foot;
            start:
                put "<foot>" CR;
            finish:
                put "</foot>" CR;
        end;

        define event javascript;
            start:
                put '<SCRIPT LANGUAGE="JavaScript">' CR;
                put "<!-- " CR;
                put "// This script is to load all object onLoad() functions " CR;
            finish:
                put CR "//-->"  CR;
                put "</SCRIPT>" CR CR;
        end;

        define event startup_function;
            start:
                put "function startup(){" CR CR;
            finish:
                put TAGATTR CR;
                put "}" CR;
        end;

        define event shutdown_function;
            start:
                put "function shutdown(){" CR CR;
            finish:
                put TAGATTR CR;
                put "}" CR;
        end;

        define event windowload;
            put VALUE CR;
        end;

        define event contents;
            start:
                put "<html>" CR;
            finish:
                put "</html>" CR;
        end;

        define event contents_body;
            start:
                put "<body";
                putq " class=" HTMLCLASS;
                put ">" CR;
            finish:
                put "</body>" CR;
        end;

        define event verbatim;
            start:
                put "<pre>";
            finish:
                put "</pre>";
        end;

        define event contents_title;
            put PREHTML CR;
            put PREIMAGE CR;
            put PRETEXT CR;
            put POSTIMAGE CR;
            put POSTTEXT CR;
            put POSTHTML CR;
        end;

        define event stylesheetclass;
            put "  font-family: " FONT_FACE;
            put ";" CR  / exists(FONT_FACE);
            put "  font-size: " FONT_SIZE;
            put ";" CR  / exists(FONT_SIZE);
            put "  font-weight: " FONT_WEIGHT;
            put ";" CR  / exists(FONT_WEIGHT);
            put "  font-style: " FONT_STYLE;
            put ";" CR  / exists(FONT_STYLE);
            put "  color: " FOREGROUND;
            put ";" CR / exists(FOREGROUND);
            put "  background-color: " BACKGROUND;
            put ";" CR  / exists(BACKGROUND);
            put '  background-image: url("' BACKGROUNDIMAGE '")' /if exists(backgroundimage);
            put ";" CR  / exists(BACKGROUNDIMAGE);
            put "  margin-left: " LEFTMARGIN;
            put ";" CR  / exists(LEFTMARGIN);
            put "  margin-right: " RIGHTMARGIN;
            put ";" CR  / exists(RIGHTMARGIN);
            put "  margin-top: " TOPMARGIN;
            put ";" CR  / exists(TOPMARGIN);
            put "  margin-bottom: " BOTTOMMARGIN;
            put ";" CR  / exists(BOTTOMMARGIN);

            trigger Border_shadow / if exists(BORDERCOLORDARK, BORDERCOLORLIGHT );

            trigger Border / if !exists(BORDERCOLORDARK, BORDERCOLORLIGHT );

            put "  list-style-type: " BULLET;
            put  ";" CR  / exists(BULLET);
            put "  height: " OUTPUTHEIGHT;
            put  ";" CR  / exists(OUTPUTHEIGHT);
            put "  width: " OUTPUTWIDTH;
            put  ";" CR  / exists(OUTPUTWIDTH);
        end;

        define event Border_shadow;
            put " border-left: " BORDERWIDTH;
            put " outset: " / exists(BORDERCOLORLIGHT);
            put ";" CR  / exists(BORDERCOLORLIGHT);
            put " border-top: " BORDERWIDTH;
            put " outset: " / exists(BORDERCOLORLIGHT);
            put ";" CR  / exists(BORDERCOLORLIGHT);
            put " border-right: " BORDERWIDTH;
            put " outset: " / exists(BORDERCOLORDARK);
            put ";" CR  / exists(BORDERCOLORDARK);
            put " border-bottom: " BORDERWIDTH;
            put " outset: " / exists(BORDERCOLORDARK);
            put ";" CR  / exists(BORDERCOLORDARK);
        end;

        define event Border;
            put " border: " BORDERWIDTH;
            put " outset " / exists(BORDERWIDTH);
            put ";" CR  / exists(BORDERWIDTH);
        end;


        define event style_inline;
            break / if !any(font_face, font_size, font_weight, font_style,
                            foreground, background, backgroundimage, leftmargin,
                            rightmargin, topmargin, bottommargin, bordercolordark,
                            bordercolorlight, bullet, outputheight, outputwidth);
            put ' style="';
            put " font-family: " FONT_FACE;
            put  ";" / exists(FONT_FACE);
            put " font-size: " FONT_SIZE;
            put  ";" / exists(FONT_SIZE);
            put " font-weight: " FONT_WEIGHT;
            put  ";" / exists(FONT_WEIGHT);
            put " font-style: " FONT_STYLE;
            put  ";" / exists(FONT_STYLE);
            put " color: " FOREGROUND;
            put  ";" / exists(FOREGROUND);
            put " background-color: " BACKGROUND;
            put  ";" / exists(BACKGROUND);
            put '  background-image: url("' BACKGROUNDIMAGE '")' /if exists(backgroundimage);
            put  ";" / exists(BACKGROUNDIMAGE);
            put " margin-left: " LEFTMARGIN;
            put  ";" / exists(LEFTMARGIN);
            put " margin-right: " RIGHTMARGIN;
            put  ";" / exists(RIGHTMARGIN);
            put " margin-top: " TOPMARGIN;
            put  ";" / exists(TOPMARGIN);
            put " margin-bottom: " BOTTOMMARGIN;
            put  ";" / exists(BOTTOMMARGIN);

            trigger Border_shadow_inline / if exists(BORDERCOLORDARK, BORDERCOLORLIGHT );

            trigger Border_inline / if !exists(BORDERCOLORDARK, BORDERCOLORLIGHT );

            put " list_style_type: " BULLET;
            put  ";" / exists(BULLET);
            put " height: " OUTPUTHEIGHT;
            put  ";" / exists(OUTPUTHEIGHT);
            put " width: " OUTPUTWIDTH;
            put  ";" / exists(OUTPUTWIDTH);
            put '"';

        end;

        define event Border_shadow_inline;
            put " border-left: " BORDERWIDTH;
            put " outset: " / exists(BORDERCOLORLIGHT);
            put  ";" / exists(BORDERWIDTH);
            put " border-top: " BORDERWIDTH;
            put " outset: " / exists(BORDERCOLORLIGHT);
            put  ";" / exists(BORDERWIDTH);
            put " border-right: " BORDERWIDTH;
            put " outset: " / exists(BORDERCOLORDARK);
            put  ";" / exists(BORDERWIDTH);
            put " border-bottom: " BORDERWIDTH;
            put " outset: " / exists(BORDERCOLORDARK);
            put  ";" / exists(BORDERWIDTH);
        end;

        define event Border_inline;
            put " border: " BORDERWIDTH;
            put " outset " / exists(BORDERWIDTH);
            put  ";" / exists(BORDERWIDTH);
        end;

        define event style;
            put "<style>" CR;
        finish:
            put "</style>" CR;
        end;

        define event shortstyles;
             /*    put "<style type=""text/css"">" CR;
            put "<!--" CR; */
            trigger bodystyle;
            trigger titlestyle;
            trigger proctitlestyle;
            trigger tablestyle;
            trigger tdstyle;
            trigger thstyle;
             /*put "-->" CR;
            put "</style>" CR;*/
        end;

        define event alignstyle ;
            putl '#l {text-align: left }';
            putl '#c {text-align: center }';
            putl '#r {text-align: right }';
            putl '#d {text-align: "." }';
            putl '#lb {text-align: left;  vertical-align: bottom }';
            putl '#cb {text-align: center;vertical-align: bottom }';
            putl '#rb {text-align: right; vertical-align: bottom }';
            putl '#db {text-align: ".";   vertical-align: bottom }';
            putl '#lc {text-align: left;  vertical-align: center }';
            putl '#cc {text-align: center;vertical-align: center }';
            putl '#rc {text-align: right; vertical-align: center }';
            putl '#dc {text-align: ".";   vertical-align: center }';
            putl '#lt {text-align: left;  vertical-align: top }';
            putl '#ct {text-align: center;vertical-align: top }';
            putl '#rt {text-align: right; vertical-align: top }';
            putl '#dt {text-align: ".";   vertical-align: top }';
            putl '#t {vertical-align: top }';
            putl '#b {vertical-align: bottom }';
        end;

        define event bodystyle;
            style="body";
            put "body {" CR;
            trigger stylesheetclass;
            put "}" CR;
        end;

        define event titlestyle;
            style = "systemtitle";
            put "h1 {" CR;
            trigger stylesheetclass;
            put "}" CR;
        end;

        define event proctitlestyle;
            style = "proctitle";
            put "h2, h3, h4, h5, h6 {" CR;
            trigger stylesheetclass;
            put "}" CR;
        end;

        define event tablestyle;
            style = "table";
            put "table {" CR;
            trigger stylesheetclass;
            put "}" CR;
        end;

        define event tdstyle;
            style = "data";
            put "td {" CR;
            trigger stylesheetclass;
            put "}" CR;
        end;

        define event thstyle;
            style = "header";
            put "th {" CR;
            trigger stylesheetclass;
            put "}" CR;
        end;

        define event list;
            start:
                put "<ul";
                putq " class=" HTMLCLASS;
                put ">" CR;
            finish:
                put "</ul>" CR;
        end;

        define event list_entry;
            put "<li";
            putq " class=" HTMLCLASS;
            put ">" CR;
            put VALUE;
            put "</li>" CR;
        end;

        define event anchor;
            putq "<a name=" NAME ">" CR / exists(NAME);
        end;

        define event breakline;
            put "<br>";
        end;

        define event splitline;
            put "<br>";
        end;

        define event line;
            put "<hr>" CR;
        end;

        define event pagebreak;
            start:
                put PAGEBREAKHTML CR;
        end;

        define event map;
            start:
                put "<map";
                putq " name=" NAME ">" CR;
            finish:
                put "</map>" CR;
        end;

        define event map_area;
            start:
                put "<area";
                putq " shape=" @SHAPE CR;
               /*HREF STUFF GOES in HERE*/
                put 'coords="';
            finish:
                put '"/>' CR;
        end;

        define event area_coordinate;
            put VALUE CR;
        end;

        define event image;
            put "<img";
            put ' src="';
            put BASENAME / if !exists(NOBASE);
            put URL;
            put '"';
            putq " border=" BORDERWIDTH;
            put ' usemap="#' @CLIENTMAP;
            put  '"' CR  / if exists(@CLIENTMAP);
            putq " class=" HTMLCLASS;
            putq " id="    HTMLID;
            trigger align /if !exists(HTMLID);
            trigger style_align /if exists(HTMLID);
            put ">" CR;
        end;

        define event style_align;
            break /if !any(just, vjust);
            put ' style="';
            trigger inline_just /if exists(just) ;
            trigger inline_vjust /if exists(just) ;
            put '"';
        end;

        define event inline_just;
            put ' text-align: ';
            put ' center;'  / when cmp("c", JUST);
            put ' right;'   / when cmp("r", JUST);
            put ' left;'   / when cmp("l", JUST);
        end;

        define event inline_vjust;
            put ' vertical-align: ';
            put ' top;'  / when cmp("t", VJUST);
            put ' middle;'   / when cmp("m", VJUST);
            put ' bottom;'   / when cmp("b", VJUST);
        end;

        define event paragraph;
            put "<para>" CR;
        finish:
            put "</para>" CR;
        end;

        define event table;
            start:
                put "<div";
                trigger align;
                put ">" CR;
                put "<table";
                putq " border=" BORDERWIDTH;
                put  ' border="1"'  / if !exists(BORDERWIDTH);
                putq " cellspacing=" CELLSPACING;
                putq " cellpadding=" CELLPADDING;
                putq " rules=" RULES;
                putq " frame=" FRAME;
                put ">" CR;
            finish:
                put "</table>" CR;
                put "</div>" CR;
                put "<br>" CR;
        end;

        define event table_head;
            put "<thead>" CR;
        finish:
            put "</thead>" CR;
        end;

        define event table_body;
            put "<tbody>" CR;
        finish:
            put "</tbody>" CR;
        end;

        define event table_foot;
            put "<tfoot>" CR;
        finish:
            put "</tfoot>" CR;
        end;

        define event colgroup;
            put "<colgroup>" CR;
        finish:
            put "</colgroup>" CR;
        end;

        define event colspec_entry;
            put "<col>" CR;
        end;

        define event row;
            put "<tr>" CR;
        finish:
            put "</tr>" CR;
        end;

        define event rowcol;
            putq " rowspan=" ROWSPAN;
            putq " colspan=" COLSPAN;
        end;

        define event align;
            break / when !any(JUST, VJUST);
            trigger valign / when !exists(JUST);
            trigger halign / when !exists(VJUST);
            break / when !exists(JUST, VJUST);
            trigger valign / when cmp("l", JUST);
            trigger halign / when cmp("c", VJUST);
            break / when cmp("l", JUST);
            break / when cmp("c", VJUST);
            put ' id="' JUST;
            put VJUST;
            put '"';
        end;

        define event halign;
            putq ' id=' JUST / when !cmp("l", JUST);
        end;

        define event valign;
            putq ' id=' VJUST / when !cmp("c", VJUST);
        end;

        define event headalign;
            break / when !any(JUST, VJUST);
            trigger valign / when !exists(JUST);
            trigger hhalign / when !exists(VJUST);
            break / when !exists(JUST, VJUST);
            trigger valign / when cmp("l", JUST);
            trigger hhalign / when cmp("c", VJUST);
            break / when cmp("l", JUST);
            break / when cmp("c", VJUST);
            put ' id="' JUST / when !cmp("d", JUST);
            put ' id="l' / when cmp("d", JUST);
            put VJUST;
            put '"';
        end;

        define event hhalign;
            putq ' id="l"' / when cmp("d", JUST);
            putq ' id=' JUST / when !cmp("d", JUST);
        end;

        define event header;
            start:
                put "<th";
                trigger rowcol;
                trigger headalign;
                put ">";
                put VALUE;
            finish:
                put "</th>" CR;
        end;

        define event data;
            start:
                put "<td";
                trigger rowcol;
                trigger align;
                put ">";
                put '<pre>' /if exists(asis);
                put VALUE;
            finish:
                put '</pre>' /if exists(asis);
                put "</td>" CR;
        end;

        define event cell_is_empty;
            put '&nbsp;';
        end;


        define event association;
            put "<table>";
            put "<tr>" CR;
        finish:
            put "</tr>" CR;
            put "</table>" CR;
        end;

        define event assoc_end_got_capt;
            put "</td>";
        end;

        define event caption;
            put "<td>";
            put TEXT;
        finish:
            put "</td>" CR;
            put "</tr><tr><td>" / if cmp(TYPE, "T");
            put "</td><td>" / if cmp(TYPE, "L");
        end;

        /*==========ODA==========*/

        define event proc;
            put "<div class=branch>" CR;
        finish:
            put "</div>" CR;
        end;

        define event output;
            put "<div>" CR;
        finish:
            put "</div>" CR;
        end;

        define event align_output;
            put "<div ";
            trigger align;
            put ">" CR;
        finish:
            put "</div>" CR;
        end;

        define event byline;
            put "<h1";
            trigger align;
            put ">";
            put VALUE;
            put "</h1>" CR;
        end;

        define event proc_title;
            put "<h2";
            trigger align;
            put ">";
            put VALUE;
            put "</h2>" CR;
        end;

        define event system_title;
            put "<h1";
            trigger align;
            put ">";
            put VALUE;
            put "</h1>" CR;
        end;

        define event system_footer;
            put "<h1";
            trigger align;
            put ">";
            put VALUE;
            put "</h1>" CR;
        end;

        define event note;
            put "<h3";
            trigger align;
            put ">";
            put VALUE;
            put "</h3>" CR;
        end;

        define event warning;
            put "<h3";
            trigger align;
            put ">";
            put VALUE;
            put "</h3>" CR;
        end;

        define event error;
            put "<h3";
            trigger align;
            put ">";
            put VALUE;
            put "</h3>" CR;
        end;


        define event fatal;
            put "<h3";
            trigger align;
            put ">";
            put VALUE;
            put "</h3>" CR;
        end;

        define event contents_branch;
            file=CONTENTS;
            start:
            put "<li";
            putq " class=" HTMLCLASS;
            put ">";
            trigger hyperlink / if any(URL, ANCHOR);
            put VALUE / if !any(URL, ANCHOR);
            put "</li>" CR;
            put "<ul>";
        finish:
            put "</ul>";
        end;

        define event hyperlink;
            put '<a href="' URL;
            /*put "#" ANCHOR;*/
            put '"';
            putq " target=" HREFTARGET;
            put ">" VALUE;
            put "</a>" CR;
        end;

        define event contents_leaf;
            file=CONTENTS;
            put "<li";
            putq " class=" HTMLCLASS;
            put ">";
            trigger hyperlink / if any(URL, ANCHOR);
            put VALUE / if !any(URL, ANCHOR);
            put "</li>" CR;
        end;


        define event branch;
        start:
            trigger contents_branch;
        finish:
            trigger contents_branch;
        end;

        define event leaf;
        start:
           trigger contents_leaf;
        end;
    end;

    /******************************************************/
    /******************************************************/
    /******************************************************/
    /*  HTML4                                             */
    /******************************************************/
    /******************************************************/
    /******************************************************/

    define tagset tagsets.html4;
        notes "This is HTML pop up styles.";
        parent=tagsets.htmlcss;
        %not8(%quote( embedded_stylesheet=yes; ))

        define event embedded_stylesheet;
           start:
              put "<style>" nl "<!--" nl;
           finish:
              put "-->" nl "</style>" nl;
        end;

    end;

    /******************************************************/
    /******************************************************/
    /******************************************************/
    /*  HTML pop up styles                                */
    /******************************************************/
    /******************************************************/
    /******************************************************/

    define tagset tagsets.style_popup;
        notes "This is HTML pop up styles.";
        parent=tagsets.htmlcss;

/* We were writing a list out to the code file but                */
/* but that didn't work for version 8 so we are                   */
/* now writing out 2 class definitions for each style.            */
/* The first one has the name of the style that follows.          */
/*                                                                */
/* All this because IE allows us to look through the stylesheet   */
/* but gives us no way to see the name of the style class.        */

        define event style_class;
            put "." HTMLCLASS " {font-family: " HTMLCLASS "}" CR;
            put "." HTMLCLASS CR;
            put "{" CR;
            trigger stylesheetclass;
            put "}" CR;
        end;

        define event doc_head;
            start:
                put "<head>" CR;
                put VALUE CR;
                put '<style>' CR '<!--' CR;
                trigger alignstyle;
                put '-->' CR '</style>' CR;
            finish:
                trigger popup_script;
                put "</head>" CR CR;
        end;


        define event popup_script;
                put "<script language=""javascript"">" CR;
                put "<!--" CR;
                put "var css = document.styleSheets(1).rules;" CR;
                put "" CR;
                put "function idAlignment(name) {" CR;
                put "   var align = '';" CR;
                put "   var valign = '';" CR;
                put "   var s = '';" CR;
                put "   if (name == 'l') align = 'left';" CR;
                put "   if (name == 'c') align = 'center';" CR;
                put "   if (name == 'r') align = 'right';" CR;
                put "   if (name == 'd') align = 'right';" CR;
                put "   if (name == 'lb') {align = 'left'; valign = 'bottom';}" CR;
                put "   if (name == 'cb') {align = 'center'; valign = 'bottom';}" CR;
                put "   if (name == 'rb') {align = 'right'; valign = 'bottom';}" CR;
                put "   if (name == 'db') {align = 'right'; valign = 'bottom';}" CR;
                put "   if (name == 'lc') {align = 'left'; valign = 'middle';}" CR;
                put "   if (name == 'cc') {align = 'center'; valign = 'middle';}" CR;
                put "   if (name == 'rc') {align = 'right'; valign = 'middle';}" CR;
                put "   if (name == 'dc') {align = 'right'; valign = 'middle';}" CR;
                put "   if (name == 'lt') {align = 'left'; valign = 'top';}" CR;
                put "   if (name == 'ct') {align = 'center'; valign = 'top';}" CR;
                put "   if (name == 'rt') {align = 'right'; valign = 'top';}" CR;
                put "   if (name == 'dt') {align = 'right'; valign = 'top';}" CR;
                put "   if (name == 't') valign = 'top';" CR;
                put "   if (name == 'b') valign = 'bottom';" CR;
                put "   if (align != '') s = s + '   <span class=""property"">JUST</span> = <span class=""value"">' + align + '</span>\n';" CR;
                put "   if (valign != '') s = s + '   <span class=""property"">VJUST</span> = <span class=""value"">' + valign + '</span>\n';" CR;
                put "   return s" CR;
                put "}" CR;
                put "" CR;
                put "function popUpStyles() {" CR;
                put "   var element = window.event.srcElement;" CR;
                put "   var styles = element.style;" CR;
                put "   var classname = element.className;" CR;
                put "   var foundClass = 0;" CR;
                put "   for (var i = 0; i < css.length; i = i + 2) {" CR;
                put "      if (classname == css[i].style.fontFamily) {" CR;
                put "         var current = css[i+1].style;" CR;
                put "         foundClass = 1;" CR;
                put "         var s = '';" CR;
                put "         s = s + '<h3 class=""header"">Style Definition</h3>\n';" CR;
                put "         s = s + '<pre>\n';" CR;
                put "         s = s + '<span class=""template"">STYLE</span> <span class=""styleid"">' + classname + '</span> /\n';" CR;
                put "         s = s + fontFace(current);" CR;
                put "         s = s + fontSize(current);" CR;
                put "         s = s + fontWeight(current);" CR;
                put "         s = s + fontStyle(current);" CR;
                put "         // Handle overrides for text-align for non-table elements here." CR;
                put "         // Overrides within table elements are generally handled in the" CR;
                put "         // Column, Table, and Header definitions." CR;
                put "         if (classname != 'RowHeader' && classname != 'Header' && " CR;
                put "             classname != 'Data') {" CR;
                put "            if (element.id) s = s + idAlignment(element.id);" CR;
                put "         } " CR;
                put "         s = s + verticalAlign(current);" CR;
                put "         s = s + foreground(current);" CR;
                put "         s = s + background(current);" CR;
                put "         s = s + width(current);" CR;
                put "         s = s + topMargin(current);" CR;
                put "         s = s + bottomMargin(current);" CR;
                put "         s = s + leftMargin(current);" CR;
                put "         s = s + rightMargin(current);" CR;
                put "         s = s + border(current);" CR;
                put "         s = s + borderAttrs(element);" CR;
                put "         s = s + '<span class=""template"">;</span>\n';" CR;
                put "         s = s + '</pre>\n';" CR;
                put "" CR;
                put "         if (classname == 'RowHeader' || classname == 'Header' ||" CR;
                put "             classname == 'Data') {" CR;
                put "            var h = '';" CR;
                put "            h = h + fontFace(element.style);" CR;
                put "            h = h + fontSize(element.style);" CR;
                put "            h = h + fontWeight(element.style);" CR;
                put "            h = h + fontStyle(element.style);" CR;
                put "            if (element.id) h = h + idAlignment(element.id);" CR;
                put "//          h = h + textAlign(element.style);" CR;
                put "//          h = h + verticalAlign(element.style);" CR;
                put "// I can't do colors here since we override them in this script to do" CR;
                put "// fancy flyovers in the HTML." CR;
                put "//          h = h + foreground(element.style);" CR;
                put "//          h = h + background(element.style);" CR;
                put "            h = h + width(element.style);" CR;
                put "            h = h + topMargin(element.style);" CR;
                put "            h = h + bottomMargin(element.style);" CR;
                put "            h = h + leftMargin(element.style);" CR;
                put "            h = h + rightMargin(element.style);" CR;
                put "            h = h + border(element.style);" CR;
                put "            if (h != '') {" CR;
                put "               s = s + '<h3 class=""header"">';" CR;
                put "               if (classname == 'RowHeader' || classname == 'Header') {" CR;
                put "                  s = s + 'Header';" CR;
                put "               } else {" CR;
                put "                  s = s + 'Column';" CR;
                put "               }" CR;
                put "               s = s + ' Attributes</h3>\n';" CR;
                put "               s = s + '<pre>\n';" CR;
                put "               s = s + h;" CR;
                put "               s = s + '</pre>\n';" CR;
                put "            }" CR;
                put "         }" CR;
                put "" CR;
                put "         popUpWindow(s);" CR;
                put "         break;" CR;
                put "      }" CR;
                put "   }" CR;
                put "   if (foundClass != 1) {" CR;
                put "      popUpWindow('<h3 class=""header"">No Style Definition Exists</h3>');" CR;
                put "   }" CR;
                put "   window.event.cancelBubble = 1" CR;
                put "}" CR;
                put "" CR;
                put "// Proc Template syntax window." CR;
                put "var remote = '';" CR;
                put "" CR;
                put "function inspect(obj) {" CR;
                put "   var temp = '';" CR;
                put "   for (x in obj)" CR;
                put "   temp += x + ': ' + obj[x] + '\n';" CR;
                put "   popUpWindow('<pre>'+temp+'</pre>');" CR;
                put "}" CR;
                put "" CR;
                put "function popUpWindow(s) {" CR;
                put "   doc = '<html>\n<head>\n<title>PROC TEMPLATE Syntax</title>\n<style>\n<!--\n';" CR;
                put "   doc = doc + 'body{font-family:verdana,arial,helvetica}';" CR;
                put "   doc = doc + '.header{color:#ffffff;background-color:#404080;width:100%;padding:5px;font-size:normal}'" CR;
                put "   doc = doc + '.hexprefix{color:#000080;font-weight:medium;}\n';" CR;
                put "   doc = doc + '.styleid{color:#000080;font-weight:bold;}\n';" CR;
                put "   doc = doc + '.sas{color:#000000;font-weight:bold;}\n';" CR;
                put "   doc = doc + '.template{color:#660066;font-weight:bold;}\n';" CR;
                put "   doc = doc + '.property{color:#006600;font-weight:bold;}\n';" CR;
                put "   doc = doc + '.value{font-style:italic;}\n';" CR;
                put "   doc = doc + '-->\n</style>\n';" CR;
                put "   doc = doc + '</head>\n<body bgcolor=""#f0e8d8"">\n';" CR;
                put "   doc = doc + s;" CR;
                put "   doc = doc + '\n</body>\n</html>';" CR;
                put "" CR;
                put "   if (remote != '' && !remote.closed) {" CR;
                put "      remote.document.open()" CR;
                put "      remote.document.write(doc)" CR;
                put "      remote.document.close()" CR;
                put "   } else {" CR;
                put "      remote = window.open('','PROCTEMPLATE','width=400,height=500,status=no,toolbar=no,menubar=no,location=no,resizable=yes,scrollbars=yes');" CR;
                put "      remote.document.open()" CR;
                put "      remote.document.write(doc)" CR;
                put "      remote.document.close()" CR;
                put "   }" CR;
                put "}" CR;
                put "" CR;
                put "function border(style) {" CR;
                put "   var b = style.border;" CR;
                put "   if (!b) return '';" CR;
                put "   if (b == '0px') return '';" CR;
                put "   var b = b.split(' ');" CR;
                put "// var color = replace(b[0], '#', '<span class=""hexprefix"">cx</span>');" CR;
                put "   var width = parseInt(b[0]);" CR;
                put "   s = '';" CR;
                put "   if (b[0])" CR;
                put "      s = s + '   <span class=""property"">BORDERWIDTH</span> = <span class=""value"">' + width + '</span>\n';" CR;
                put "// if (b[0])" CR;
                put "//    s = s + '   <span class=""property"">BORDERCOLOR</span> = <span class=""value"">' + color + '</span>\n';" CR;
                put "   return s;" CR;
                put "}" CR;
                put "" CR;
                put "function borderAttrs(style) {" CR;
                put "   s = ''" CR;
                put "   if (style.cellSpacing) " CR;
                put "      s = s + '   <span class=""property"">CELLSPACING</span> = <span class=""value"">' + style.cellSpacing + '</span>\n';" CR;
                put "   if (style.cellPadding) " CR;
                put "      s = s + '   <span class=""property"">CELLPADDING</span> = <span class=""value"">' + style.cellPadding + '</span>\n';" CR;
                put "   if (style.frame) " CR;
                put "      s = s + '   <span class=""property"">FRAME</span> = <span class=""value"">' + style.frame.toUpperCase() + '</span>\n';" CR;
                put "   if (style.rules) " CR;
                put "      s = s + '   <span class=""property"">RULES</span> = <span class=""value"">' + style.rules.toUpperCase() + '</span>\n';" CR;
                put "   return s" CR;
                put "}" CR;
                put "" CR;
                put "function textAlign(style) {" CR;
                put "   var align = style.textAlign;" CR;
                put "   if (!align) return '';" CR;
                put "   return '   <span class=""property"">JUST</span> = <span class=""value"">' + align + '</span>\n';" CR;
                put "}" CR;
                put "" CR;
                put "function verticalAlign(style) {" CR;
                put "   var align = style.verticalAlign;" CR;
                put "   if (!align) return '';" CR;
                put "   return '   <span class=""property"">VJUST</span> = <span class=""value"">' + align + '</span>\n';" CR;
                put "}" CR;
                put "" CR;
                put "function topMargin(style) {" CR;
                put "   var margin = style.margin;" CR;
                put "   if (!margin) return '';" CR;
                put "   return '   <span class=""property"">TOPMARGIN</span> = <span class=""value"">' + margin + '</span>\n';" CR;
                put "}" CR;
                put "" CR;
                put "function bottomMargin(style) {" CR;
                put "   var margin = style.margin;" CR;
                put "   if (!margin) return '';" CR;
                put "   return '   <span class=""property"">BOTTOMMARGIN</span> = <span class=""value"">' + margin + '</span>\n';" CR;
                put "}" CR;
                put "" CR;
                put "function leftMargin(style) {" CR;
                put "   var margin = style.margin;" CR;
                put "   if (!margin) return '';" CR;
                put "   return '   <span class=""property"">LEFTMARGIN</span> = <span class=""value"">' + margin + '</span>\n';" CR;
                put "}" CR;
                put "" CR;
                put "function rightMargin(style) {" CR;
                put "   var margin = style.margin;" CR;
                put "   if (!margin) return '';" CR;
                put "   return '   <span class=""property"">RIGHTMARGIN</span> = <span class=""value"">' + margin + '</span>\n';" CR;
                put "}" CR;
                put "" CR;
                put "function width(style) {" CR;
                put "   var width = style.width;" CR;
                put "   if (!width) return '';" CR;
                put "   return '   <span class=""property"">WIDTH</span> = <span class=""value"">' + width + '</span>\n';" CR;
                put "}" CR;
                put "" CR;
                put "function fontFace(style) {" CR;
                put "   var font = style.fontFamily;" CR;
                put "   if (!font) return '';" CR;
                put "   return '   <span class=""property"">FONT_FACE</span> = <span class=""value"">""' + font + '""</span>\n';" CR;
                put "}" CR;
                put "" CR;
                put "function fontSize(style) {" CR;
                put "   var size = style.fontSize;" CR;
                put "   if (!size) return '';" CR;
                put "   if (size == 'x-small') size = 2;" CR;
                put "   if (size == 'small') size = 3;" CR;
                put "   if (size == 'medium') size = 4;" CR;
                put "   if (size == 'large') size = 5;" CR;
                put "   return '   <span class=""property"">FONT_SIZE</span> = <span class=""value"">' + size + '</span>\n'" CR;
                put "}" CR;
                put "" CR;
                put "function fontWeight(style) {" CR;
                put "   var weight = style.fontWeight;" CR;
                put "   if (!weight) return '';" CR;
                put "   if (weight == 'normal') weight = 'medium';" CR;
                put "   return '   <span class=""property"">FONT_WEIGHT</span> = <span class=""value"">' + weight + '</span>\n'" CR;
                put "}" CR;
                put "" CR;
                put "function fontStyle(style) {" CR;
                put "   var style = style.fontStyle;" CR;
                put "   if (!style) return '';" CR;
                put "   if (style == 'normal') style = 'roman';" CR;
                put "   return '   <span class=""property"">FONT_STYLE</span> = <span class=""value"">' + style + '</span>\n'" CR;
                put "}" CR;
                put "" CR;
                put "function foreground(style) {" CR;
                put "   var color = style.color;" CR;
                put "   if (!color) return '';" CR;
                put "   return '   <span class=""property"">FOREGROUND</span> = <span class=""value"">' + replace(color, '#', '<span class=""hexprefix"">cx</span>') + '</span>\n';" CR;
                put "}" CR;
                put "" CR;
                put "function background(style) {" CR;
                put "   var color = style.backgroundColor;" CR;
                put "   if (!color) return '';" CR;
                put "   return '   <span class=""property"">BACKGROUND</span> = <span class=""value"">' + replace(color, '#', '<span class=""hexprefix"">cx</span>') + '</span>\n';" CR;
                put "}" CR;
                put "" CR;
                put "function replace(s, t, u) {" CR;
                put "   i = s.indexOf(t);" CR;
                put "   var r = '';" CR;
                put "   if (i == -1) return s;" CR;
                put "   r += s.substring(0,i) + u;" CR;
                put "   if ( i + t.length < s.length)" CR;
                put "     r += replace(s.substring(i + t.length, s.length), t, u);" CR;
                put "   return r;" CR;
                put "}" CR;
                put "" CR;
                put "function overStyle() {" CR;
                put "   var element = window.event.srcElement;" CR;
                put "   element.style.backgroundColor = '#ff6666';" CR;
                put "   element.style.color = 'white';" CR;
                put "   element.title = element.className;" CR;
                put "   window.event.cancelBubble = 1;" CR;
                put "}" CR;
                put "" CR;
                put "function outStyle() {" CR;
                put "   var element = window.event.srcElement;" CR;
                put "   element.style.backgroundColor = '';" CR;
                put "   element.style.color = '';" CR;
                put "   element.title = '';" CR;
                put "   window.event.cancelBubble = 1;" CR;
                put "}" CR;
                put "" CR;
                put "document.onclick = popUpStyles" CR;
                put "document.onmouseover = overStyle" CR;
                put "document.onmouseout = outStyle" CR;

                put CR "//-->"  CR;
                put "</script>" CR CR;
        end;


    end;

    /******************************************************/
    /******************************************************/
    /******************************************************/
    /*  Style Template display                            */
    /******************************************************/
    /******************************************************/
    /******************************************************/

    define tagset tagsets.style_display;
        notes "This is HTML with full CSS support";
        parent=tagsets.style_popup;

        define event doc_body;
            put '<body onload="startup()"';
            put ' onunload="shutdown()"';
            put  ' bgproperties="Fixed"' / exists(WATERMARK);
            putq " class=" HTMLCLASS;
            putq " background=" BACKGROUNDIMAGE;
            trigger style_inline;
            put ">" CR;
            trigger pre_post;
            put '<SCRIPT LANGUAGE="JavaScript">' CR;
            put "<!-- " CR;
            put "// This script is to load all object onLoad() functions " CR;
            put "function startup(){}" CR;
            put "function shutdown(){}" CR;
            put " "         CR;
            put "//-->"     CR;
            put "</SCRIPT>" CR;
            put          CR;
        finish:
            trigger sample;
            trigger pre_post;
            put "</body>" CR;
        end;

        define event sample;
            trigger pagebreak;
            trigger sample_page;
            trigger sample_Contentspage;
            trigger pagebreak;
            trigger style_output;
            trigger pagebreak;
        end;

        define event sample_page;
            trigger sample_title;
            trigger sample_proc_title;
            trigger sample_byline;
            trigger sample_table;
            trigger sample_batch;
            trigger sample_notes;
            trigger sample_footnote;
            trigger pagebreak;
        end;

        define event sample_Contentspage;
            style="Contents";
            put '<table class=Contents width="100%">' CR;
            put '<td class=contents>' CR ;
            trigger sample_content_title start;
            trigger list start;
            trigger sample_content_procname start;
            trigger sample_content_Folder start;
            trigger sample_content_Item;
            trigger sample_content_Item;
            trigger sample_branch finish;
            trigger sample_content_Item;
            trigger sample_content_procname finish;
            trigger list finish;
            trigger pagebreak;
            put '</td>';
            put '</table>';
        end;


        define event sample_content_procname;
            style="ContentProcName";
            start:
                trigger sample_proc_branch;
            finish:
                trigger sample_proc_branch;
        end;

        define event list;
            start:
                put "<ul";
                putq " class=" HTMLCLASS;
                put ">" CR;
            finish:
                put "</ul>" CR;
        end;

        define event list_entry;
            start:
                put "<li";
                putq " class=" HTMLCLASS;
                put ">" CR;
            finish:
                put "</li>" CR;
        end;

        define event sample_proc_branch;
        start:
            trigger list_entry start;
            trigger pre_post start;
            put "Sample";
            trigger pre_post finish;
            trigger list_entry finish;
            trigger list start;
        finish:
            trigger list finish;
        end;

        define event sample_Content_title;
        style="ContentTitle";
        start:
            trigger pre_post start;
            trigger pre_post finish;
        end;

        define event sample_branch;
        start:
            trigger list_entry start;
            trigger pre_post start;
            put "This is a Content Folder";
            trigger pre_post finish;
            trigger list_entry finish;
            trigger list start;
        finish:
            trigger list finish;
        end;

        define event sample_leaf;
            trigger list_entry start;
            trigger pre_post start;
            put "This is a Content Item";
            trigger pre_post finish;
            trigger list_entry finish;
        end;

        define event sample_content_folder;
            style="ContentFolder";
            start:
                put "Folder";
                trigger sample_branch;
            finish:
                trigger sample_branch;
        end;

        define event sample_content_item;
            style="ContentItem";
            trigger sample_leaf;
        end;

        define event sample_title;
            style="SystemTitle";
            trigger pre_post start;
            put "<h1";
            putq " class=" HTMLCLASS;
            trigger align;
            trigger style_inline;
            put ">";
            put "This is a System Title";
            put "</h1>" CR;
            trigger pre_post finish;
        end;

        define event sample_footnote;
            style="SystemFooter";
            trigger pre_post start;
            put "<h1";
            putq " class=" HTMLCLASS;
            trigger align;
            trigger style_inline;
            put ">";
            put "This is a System Footnote";
            put "</h1>" CR;
            trigger pre_post finish;
        end;


        define event sample_proc_title;
            style="ProcTitle";
            trigger pre_post start;
            put "<h2";
            putq " class=" HTMLCLASS;
            trigger align;
            trigger style_inline;
            put ">";
            put "This is a Proc Title";
            put "</h2>" CR;
            trigger pre_post finish;
        end;

        define event sample_byline;
            style="Byline";
            trigger pre_post start;
            put "<h2";
            putq " class=" HTMLCLASS;
            trigger align;
            trigger style_inline;
            put ">";
            put "This is a Byline";
            put "</h2>" CR;
            trigger pre_post finish;
        end;

        define event sample_table;
        style="Table";
            trigger table start;
            put "<tr>";
            put '<th class="Header">Element</th>';
            put '<th class="Header" colspan="3">Proportional Fonts</th>';
            put '<th class="Header">Empty</th>';
            put '<th class="Header" colspan="3">Fixed Fonts</th>';
            put "</tr>";
            put "<tr>";
            put '<th class="RowHeader">Header</th>';
            trigger sample_headers;
            put '</tr>';
            put '<th class="RowHeader">Row Header</th>';
            trigger sample_Rowheaders;
            put '</tr>';
            put '<th class="RowHeader">Data</th>';
            trigger sample_data;
            put '</tr>';
            trigger table finish;
        end;

        define event sample_headers;
            trigger sample_r_header;
            trigger sample_s_header;
            trigger sample_e_header;
            trigger sample_empty_header;
            trigger sample_rf_header;
            trigger sample_sf_header;
            trigger sample_ef_header;
        end;

        define event sample_rowheaders;
            trigger sample_r_rowheader;
            trigger sample_s_rowheader;
            trigger sample_e_rowheader;
            trigger sample_empty_rowheader;
            trigger sample_rf_rowheader;
            trigger sample_sf_rowheader;
            trigger sample_ef_rowheader;
        end;

        define event sample_data;
            trigger sample_r_data;
            trigger sample_s_data;
            trigger sample_e_data;
            trigger sample_empty_data;
            trigger sample_rf_data;
            trigger sample_sf_data;
            trigger sample_ef_data;
        end;

        define event sample_r_header;
            style="Header";
            trigger header start;
            put "Regular";
            trigger header finish;
        end;

        define event sample_s_header;
            style="HeaderStrong";
            trigger header start;
            put "Strong";
            trigger header finish;
        end;

        define event sample_e_header;
            style="HeaderEmphasis";
            trigger header start;
            put "Emphasis";
            trigger header finish;
        end;

        define event sample_empty_header;
            style="HeaderEmpty";
            trigger header start;
            trigger header finish;
        end;

        define event sample_rf_header;
            style="HeaderFixed";
            trigger header start;
            put "Regular";
            trigger header finish;
        end;

        define event sample_sf_header;
            style="HeaderStrongFixed";
            trigger header start;
            put "Strong";
            trigger header finish;
        end;

        define event sample_ef_header;
            style="HeaderEmphasisFixed";
            trigger header start;
            put "Emphasis";
            trigger header finish;
        end;


        define event sample_r_rowheader;
            style="RowHeader";
            trigger header start;
            put "Regular";
            trigger header finish;
        end;

        define event sample_s_Rowheader;
        style="RowHeaderStrong";
            trigger header start;
            put "Strong";
            trigger header finish;
        end;

        define event sample_e_Rowheader;
        style="RowHeaderEmphasis";
            trigger header start;
            put "Emphasis";
            trigger header finish;
        end;

        define event sample_empty_Rowheader;
            style="RowHeaderEmpty";
            trigger header start;
            trigger header finish;
        end;

        define event sample_rf_Rowheader;
            style="RowHeaderFixed";
            trigger header start;
            put "Regular";
            trigger header finish;
        end;

        define event sample_sf_Rowheader;
            style="RowHeaderStrongFixed";
            trigger header start;
            put "Strong";
            trigger header finish;
        end;

        define event sample_ef_Rowheader;
            style="RowHeaderEmphasisFixed";
            trigger header start;
            put "Emphasis";
            trigger header finish;
        end;


        define event sample_r_data;
        style="Data";
            trigger Data start;
            put "Regular";
            trigger Data finish;
        end;

        define event sample_s_Data;
            style="DataStrong";
            trigger Data start;
            put "Strong";
            trigger Data finish;
        end;

        define event sample_e_Data;
            style="DataEmphasis";
            trigger Data start;
            put "Emphasis";
            trigger Data finish;
        end;

        define event sample_empty_Data;
            style="DataEmpty";
            trigger Data start;
            trigger Data finish;
        end;

        define event sample_rf_Data;
            style="DataFixed";
            trigger Data start;
            put "Regular";
            trigger Data finish;
        end;

        define event sample_sf_Data;
            style="DataStrongFixed";
            trigger Data start;
            put "Strong";
            trigger Data finish;
        end;

        define event sample_ef_Data;
        style="DataEmphasisFixed";
            trigger Data start;
            put "Emphasis";
            trigger Data finish;
        end;

        define event sample_batch;
        style="Batch";
           trigger table start;
           trigger tbody start;
           trigger data start;
           put "<pre>";
           put "This is Batch Output * * * * * * * | ** | * |" CR;
           put "                     * * * * * * * | ** | * |" CR;
           put "</pre>";
           trigger data finish;
           trigger tbody finish;
           trigger table finish;
        end;

        define event GNContent;
            put "<td";
            putq " class=" HTMLCLASS;
            trigger align;
            trigger style_inline;
            put ">";
            trigger pre_post start;
            put "This is the textual content";
            trigger pre_post finish;
            put "</td>";
        end;

        define event Banner;
           start:
            put "<td" CR;
            putq " class=" HTMLCLASS;
            trigger align;
            trigger style_inline;
            put ">" CR;
           finish:
            put "</td>" CR;
        end;

        define event noteBanner;
            style="NoteBanner";
            trigger Banner start;
            trigger pre_post start;
            trigger pre_post finish;
            trigger Banner finish;
        end;

        define event warnBanner;
            style="warnBanner";
            trigger Banner start;
            trigger pre_post start;
            trigger pre_post finish;
            trigger Banner finish;
        end;

        define event ErrorBanner;
            style="ErrorBanner";
            trigger Banner start;
            trigger pre_post start;
            trigger pre_post finish;
            trigger Banner finish;
        end;

        define event FatalBanner;
            style="FatalBanner";
            trigger Banner start;
            trigger pre_post start;
            trigger pre_post finish;
            trigger Banner finish;
        end;

        define event sample_notes;
           trigger note;
           trigger Warning;
           trigger Error;
           trigger Fatal;
        end;

        define event style_output;
            putl '<p>';
            putl '<h1 class="SystemTitle">Inheritance diagrams</h2>';
            putl '<h1 class="SystemTitle">Based on the ods styles which ship with SAS.</h2>';
            putl '';
            putl '<h2 class="ProcTitle">The basic document styles.</h2>';
            putl '<table border=1 class="Container">';
            putl '<tr>';
            putl '<td class="Container"> This is the Container style Element.  Parent of ALL elements</td>';
            putl '</tr>';
            putl '<tr>';
            putl '<td>';
            putl '<table border=1 class="document">';
            putl '<td colspan=3 class="document">The document class, Abstract Parent</td>';
            putl '</tr>';
            putl '<tr>';
            putl '<td class="body"> The Body file style</td>';
            putl '<td class="contents"> The Contents file style</td>';
            putl '<td class="frame"> The Frame file style</td>';
            putl '</tr>';
            putl '</table>';
            putl '</td>';
            putl '<tr>';
            putl '</table>';
            putl '<tr>';
            putl '</table>';
            putl '';
            putl '<p>';
            putl '';
            putl '<h2 class="ProcTitle">Containers For everything. Used by [ods html]</h2>';
            putl '<table border=1 class="Container">';
            putl '<tr>';
            putl '<td class="Container"> This is the Container style Element.  Parent of ALL elements</td>';
            putl '</tr>';
            putl '';
            putl '<tr>';
            putl '<td>';
            putl '';
            putl '<table border=1 class="SysTitleAndFooterContainer">';
            putl '<td colspan=3 class="SysTitleAndFooterContainer">The Sys Title And Footer Container style</td>';
            putl '<tr>';
            putl '<td>';
            putl '<table class="TitleAndNoteContainer">';
            putl '<td class="TitleAndNoteContainer">The Title And Note Container style</td>';
            putl '</table>';
            putl '<table class="BylineContainer">';
            putl '<td class="BylineContainer">The Byline Container style</td>';
            putl '</table>';
            putl '<table class="TitlesAndFooters">';
            putl '<td class="TitlesAndFooters">The Titles And Footers style, Abstract.</td>';
            putl '</table>';
            putl '</td>';
            putl '</tr>';
            putl '</table>';
            putl '';
            putl '</td>';
            putl '<tr>';
            putl '</table>';
            putl '';
            putl '<p>';
            putl '<h2 class="ProcTitle">Table of Contents</h2>';
            putl '<table border=1 class="Container">';
            putl '<tr>';
            putl '<td class="Container"> This is the Container style Element.  Parent of ALL elements</td>';
            putl '</tr>';
            putl '';
            putl '<tr>';
            putl '<td>';
            putl '';
            putl '<table border=1 class="IndexItem">';
            putl '<td colspan=3 class="IndexItem">Index Item style, Abstract</td>';
            putl '<tr>';
            putl '<td>';
            putl '<ul class="ContentFolder">';
            putl '<li class="ContentFolder">The Content Folder style</li>';
            putl '<ul class="BylineFolder">';
            putl '<li class="BylineFolder">The Byline Folder style</li>';
            putl '</ul>';
            putl '</ul>';
            putl '</td>';
            putl '<td>';
            putl '<ul class="ContentItem">';
            putl '<li class="ContentItem">The Contents Item style</li>';
            putl '</ul>';
            putl '<ul class="PagesItem">';
            putl '<li class="PagesItem">The Pages Item style, Abstract.</li>';
            putl '</ul>';
            putl '</td>';
            putl '</tr>';
            putl '</table>';
            putl '';
            putl '</td>';
            putl '<tr>';
            putl '</table>';
            putl '';
            putl '<p>';
            putl '';
            putl '<h2 class="ProcTitle">Proc name in Table of Contents</h2>';
            putl '<table border=1 class="Container">';
            putl '<tr>';
            putl '<td class="Container"> This is the Container style Element.  Parent of ALL elements</td>';
            putl '</tr>';
            putl '';
            putl '<tr>';
            putl '<td>';
            putl '';
            putl '<table border=1 class="Index">';
            putl '<td colspan=3 class="Index">Index style, Abstract</td>';
            putl '<tr>';
            putl '<td>';
            putl '<ul class="IndexProcNome">';
            putl '<li class="IndexProcNome">The Index Proc Name style, Abstract</li>';
            putl '<ul class="ContentProcName">';
            putl '<li class="ContentProcName">The Content Proc Name style</li>';
            putl '<ul class="ContentProcLabel">';
            putl '<li class="ContentProcLabel">The Content Proc Label style</li>';
            putl '</ul>';
            putl '<li class="PagesProcName">The Pages Proc Name style</li>';
            putl '<ul class="PagesProcLabel">';
            putl '<li class="PagesProcLabel">The Pages Proc Label style</li>';
            putl '</ul>';
            putl '</ul>';
            putl '</td>';
            putl '</tr>';
            putl '</table>';
            putl '';
            putl '</td>';
            putl '<tr>';
            putl '</table>';
            putl '';
            putl '<p>';
            putl '<h2 class="ProcTitle">Misc Contents styles.</h2>';
            putl '<table border=1 class="Container">';
            putl '<tr>';
            putl '<td class="Container"> This is the Container style Element.  Parent of ALL elements</td>';
            putl '</tr>';
            putl '';
            putl '<tr>';
            putl '<td>';
            putl '';
            putl '<table border=1 class="Index">';
            putl '<tr>';
            putl '<td class="Index">The Index style, Abstract</td>';
            putl '</tr>';
            putl '<tr>';
            putl '<td>';
            putl '<table border=1 class="IndexTitle">';
            putl '<tr>';
            putl '<td class="IndexTitle">The IndexTitle style, Abstract.';
            putl '<table border=1 class="IndexTitle">';
            putl '<tr>';
            putl '<td class="ContentTitle">The Content Title style</td>';
            putl '<td class="PagesTitle">The Pages Title style, Abstract.</td>';
            putl '</tr>';
            putl '</table>';
            putl '</td>';
            putl '</tr>';
            putl '</table>';
            putl '</td>';
            putl '</tr>';
            putl '</table>';
            putl '';
            putl '</td>';
            putl '</tr>';
            putl '</table>';
            putl '';
            putl '<p>';
            putl '';
            putl '<h2 class="ProcTitle">Date styles.</h2>';
            putl '<table border=1 class="Container">';
            putl '<tr>';
            putl '<td class="Container"> This is the Container style Element.  Parent of ALL elements</td>';
            putl '</tr>';
            putl '<tr>';
            putl '<td>';
            putl '<table border=1 class="Date">';
            putl '<td colspan=3 class="Date">The Date class, Abstract Parent</td>';
            putl '</tr>';
            putl '<tr>';
            putl '<td class="BodyDate"> The Body file Date style</td>';
            putl '<td class="ContentsDate"> The Contents file Date style</td>';
            putl '<td class="PagesDate"> The Pages file Date style</td>';
            putl '</tr>';
            putl '</table>';
            putl '</td>';
            putl '<tr>';
            putl '</table>';
            putl '<tr>';
            putl '</table>';
            putl '';
            putl '<p>';
            putl '';
            putl '<h2 class="ProcTitle">Titles, FootNotes, and Bylines.</h2>';
            putl '';
            putl '<table border=1 class="Container">';
            putl '<tr>';
            putl '<td class="Container"> This is the Container style Element.  Parent of ALL elements</td>';
            putl '</tr>';
            putl '<tr>';
            putl '<td>';
            putl '<table border=1 class="TitlesAndFooters">';
            putl '<td colspan=5 class="TitlesAndFooters">The TitlesAndFooters style, Abstract Parent</td>';
            putl '</tr>';
            putl '<tr>';
            putl '<td class="SystemTitle"> The System Title style</td>';
            putl '<td class="SystemFooter"> The system footnote style</td>';
            putl '<td class="ProcTitle"> The Proc Title style</td>';
            putl '<td class="ProcTitleFixed"> The Proc Title fixed Font style</td>';
            putl '<td class="Byline"> The Byline style</td>';
            putl '</tr>';
            putl '</table>';
            putl '</td>';
            putl '<tr>';
            putl '</table>';
            putl '';
            putl '<p>';
            putl '';
            putl '';
            putl '<h2 class="ProcTitle">The three types of output.</h2>';
            putl '';
            putl '<table border=1 class="Container">';
            putl '<tr>';
            putl '<td class="Container"> This is the Container style Element.  Parent of ALL elements</td>';
            putl '</tr>';
            putl '<tr>';
            putl '<td>';
            putl '<table border=1 class="Output">';
            putl '<td colspan=3 class="Output">The Output style, Abstract Parent</td>';
            putl '</tr>';
            putl '<tr>';
            putl '<td>';
            putl '<table class="Table">';
            putl '<td colspan=5 class="Table">The Tabular Output style</td>';
            putl '</table>';
            putl '</td>';
            putl '<td>';
            putl '<table class="Graph">';
            putl '<td colspan=5 class="Graph">The Graph Output style</td>';
            putl '</table>';
            putl '</td>';
            putl '<td>';
            putl '<table class="Batch">';
            putl '<td colspan=5 class="Batch">The Batch Output style</td>';
            putl '</table>';
            putl '</td>';
            putl '</tr>';
            putl '';
            putl '</td>';
            putl '</tr>';
            putl '</table>';
            putl '';
            putl '</td>';
            putl '<tr>';
            putl '</table>';
            putl '';
            putl '<p>';
            putl '';
            putl '<h2 class="ProcTitle">All the types and parts of Notes.</h2>';
            putl '';
            putl '<table border=1 class="Container">';
            putl '<tr>';
            putl '<td class="Container"> This is the Container style Element.  Parent of ALL elements</td>';
            putl '</tr>';
            putl '<tr>';
            putl '<td>';
            putl '<table border=1 class="Note">';
            putl '<td colspan=2 class="Document">The Note style, Parent</td>';
            putl '<table border=1 class="Note">';
            putl '<tr>';
            putl '<td class="NoteBanner">The Note Banner style</td>';
            putl '<td class="NoteContent">The Note Content style';
            putl '<table border=1>';
            putl '<td class="NoteContentFixed">The Note Content Fixed Font style </td>';
            putl '</table>';
            putl '</td>';
            putl '</tr>';
            putl '<tr>';
            putl '<td class="WarnBanner">The Warning Banner style</td>';
            putl '<td class="WarnContent">The Warning Content style';
            putl '<table border=1>';
            putl '<td class="WarnContentFixed">The Warning Content Fixed Font style </td>';
            putl '</table>';
            putl '</td>';
            putl '</tr>';
            putl '<tr>';
            putl '<td class="ErrorBanner">The Error Banner style</td>';
            putl '<td class="ErrorContent">The Error Content style';
            putl '<table border=1>';
            putl '<td class="ErrorContentFixed">The Error Content Fixed Font style </td>';
            putl '</table>';
            putl '</td>';
            putl '</tr>';
            putl '<tr>';
            putl '<td class="FatalBanner">The FatalBanner style</td>';
            putl '<td class="FatalContent">The FatalContent style';
            putl '<table border=1>';
            putl '<td class="FatalContentFixed">The Fatal Content Fixed Font style </td>';
            putl '</table>';
            putl '</td>';
            putl '</tr>';
            putl '</table>';
            putl '</td>';
            putl '</td>';
            putl '</tr>';
            putl '</table>';
            putl '</td>';
            putl '</tr>';
            putl '</table>';
            putl '';
            putl '<p>';
            putl '';
            putl '<h2 class="ProcTitle">Table Cells.</h2>';
            putl '';
            putl '<table border=1 class="Container">';
            putl '<tr>';
            putl '<td class="Container"> This is the Container style Element.  Parent of ALL elements</td>';
            putl '</tr>';
            putl '<tr>';
            putl '<td>';
            putl '<table  border=1class="Cell"';
            putl '<td colspan=3 class="Cell"The Cell style, Abstract Parent';
            putl '<table border=1 class="Data">';
            putl '<td class="Data">The Data style';
            putl '<table border=1>';
            putl '<td class="DataFixed">The Data Fixed style</td>';
            putl '<td class="DataStrong">The Data Strong style';
            putl '<table  border=1class="DataStrang">';
            putl '<td class="DataStrongFixed">The Data Strong Fixed Font style</td>';
            putl '</table>';
            putl '</td>';
            putl '<td class="DataEmphasis">The Data Emphasis style';
            putl '<table  border=1 class="DataEmphasis">';
            putl '<td class="DataEmphasisFixed">The Data Emphasis Fixed Font style</td>';
            putl '</table>';
            putl '</td>';
            putl '</table>';
            putl '<td>';
            putl '</table>';
            putl '<table border=1 class="HeadersAndFooters">';
            putl '<td colspan=2 class="HeadersAndFooters">The HeadersAndFooters style, Abstract</td>';
            putl '<tr>';
            putl '<td>';
            putl '<table border=1 class="Header">';
            putl '<td colspan=2 class="Header">The Header style';
            putl '<table border=1 >';
            putl '<td class="HeaderFixed">The Header Fixed style</td>';
            putl '<td class="HeaderStrong">The Header Strong style';
            putl '<table border=1 class=HeaderStrang>';
            putl '<td class="HeaderStrongFixed">The Header Strong Fixed style</td>';
            putl '</table>';
            putl '</td>';
            putl '<td class="HeaderEmphasis">The Header Emphasis style';
            putl '<table border=1 class="HeaderEmphasis">';
            putl '<td class="HeaderEmphasisFixed">The Header Emphasis Fixed style</td>';
            putl '</table>';
            putl '</td>';
            putl '</td>';
            putl '<td>';
            putl '<td class="RowHeader">The Row Header style';
            putl '<table border=1 >';
            putl '<td class="RowHeaderFixed">The Row Header Fixed style</td>';
            putl '<td class="RowHeaderStrong">The Row Header Strong style';
            putl '<table border=1 class="RowHeaderStrang">';
            putl '<td class="RowHeaderStrongFixed">The Row Header Fixed font style</td>';
            putl '</table>';
            putl '</td>';
            putl '<td class="RowHeaderEmphasis">The Row Header Emphasis style';
            putl '<table border=1 class="RowHeaderEmphasis">';
            putl '<td class="RowHeaderEmphasisFixed">The Row Header Emphasis fixed font style</td>';
            putl '</table>';
            putl '</td>';
            putl '</table>';
            putl '</td>';
            putl '</td>';
            putl '</tr>';
            putl '</table>';
            putl '</td>';
            putl '</table>';
            putl '</td>';
            putl '</tr>';
            putl '</table>';
            putl '</td>';
            putl '</table>';
            putl '</td>';
            putl '</table>';
        end;

    end;

    /******************************************************/
    /******************************************************/
    /******************************************************/
    /*  Clean HTML with ODS defined CSS                   */
    /******************************************************/
    /******************************************************/
    /******************************************************/

    define tagset tagsets.htmlcss;
        notes "This is HTML with full CSS support";
        parent=tagsets.phtml;

        define event shortstyles;
        end;

        define event style_class;
            put "." HTMLCLASS CR;
            put "{" CR;
            trigger stylesheetclass;
            put "}" CR;
        end;

        define event head1;
            trigger pre_post start;
            put "<h1";
            putq " class=" HTMLCLASS;
            trigger align;
            trigger style_inline;
            put ">";
            put VALUE;
            put "</h1>" CR;
            trigger pre_post finish;
           end;

        define event head2;
            trigger pre_post start;
            put "<h2";
            putq " class=" HTMLCLASS;
            trigger align;
            trigger style_inline;
            put ">";
            put VALUE;
            put "</h2>" CR;
            trigger pre_post finish;
           end;

        define event head3;
            trigger pre_post start;
            put "<h3";
            putq " class=" HTMLCLASS;
            trigger align;
            trigger style_inline;
            put ">";
            put VALUE;
            put "</h3>" CR;
            trigger pre_post finish;
           end;


        define event doc_body;
            put '<body onload="startup()"';
            put ' onunload="shutdown()"';
            put  ' bgproperties="Fixed"' / exists(WATERMARK);
            putq " class=" HTMLCLASS;
            putq " background=" BACKGROUNDIMAGE;
            trigger style_inline;
            put ">" CR;
            trigger pre_post;
            put '<SCRIPT LANGUAGE="JavaScript">' CR;
            put "<!-- " CR;
            put "// This script is to load all object onLoad() functions " CR;
            put "function startup(){}" CR;
            put "function shutdown(){}" CR;
            put " "         CR;
            put "//-->"     CR;
            put "</SCRIPT>" CR;
            put          CR;
        finish:
            trigger pre_post;
            put "</body>" CR;
        end;

        define event table;
            start:
                put "<div" CR;
                trigger align;
                put ">" CR;
                trigger pre_post;
                put "<table";
                putq " class=" HTMLCLASS;
                trigger style_inline;
                putq " border=" BORDERWIDTH;
                put  ' border="1"'  / if !exists(BORDERWIDTH);
                putq " cellspacing=" CELLSPACING;
                putq " cellpadding=" CELLPADDING;
                putq " rules=" RULES;
                putq " frame=" FRAME;
                put ">" CR;
            finish:
                put "</table>" CR;
                trigger pre_post;
                put "</div>" CR;
                put "<br>" CR;
        end;

        define event header;
            start:
                put "<th";
                trigger pre_post;
                putq " class=" HTMLCLASS;
                trigger headalign;
                trigger style_inline;
                trigger rowcol;
                put ">";
                put VALUE;
            finish:
                trigger pre_post;
                put "</th>" CR;
        end;

        define event data;
            put "<td";
            trigger pre_post;
            putq " class=" HTMLCLASS;
            trigger align;
            trigger style_inline;
            trigger rowcol;
            put ">";
            put '<pre>' /if exists(asis);
            put VALUE;
        finish:
            trigger pre_post;
            put '</pre>' /if exists(asis);
            put "</td>" CR;
        end;

        define event list;
            start:
                put "<ul";
                putq " class=" HTMLCLASS;
                put ">" CR;
            finish:
                put "</ul>" CR;
        end;

        define event list_entry;
            start:
                put "<li";
                putq " class=" HTMLCLASS;
                put ">" CR;
                trigger hyperlink / if any(URL, ANCHOR);
                put value / if !any(URL, ANCHOR);
            finish:
                put "</li>" CR;
        end;

        define event contents_branch;
            file=CONTENTS;
        start:
            trigger list_entry start;
            trigger list_entry finish;
            trigger list;
        finish:
            trigger list;
        end;

        define event hyperlink;
            put '<a href="' URL;
            put '"';
            putq " target=" HREFTARGET;
            put ">" ;
            put value;
            put "</a>" CR;
        end;

        define event contents_leaf;
            file=CONTENTS;
            trigger list_entry start;
            trigger list_entry finish;
        end;

        /*==========ODA==========*/

        define event byline;
            trigger head2;
        end;

        define event proc_title;
            trigger head2;
        end;

        define event system_title;
            trigger head1;
        end;

        define event system_footer;
            trigger head1;
        end;

        define event Gnote;
            start:
                put "<div";
                trigger align;
                put ">";
                put "<table>";
                put "<tr>" CR;
            finish:
                put "</tr>" CR;
                put "</table>" CR;
                put "</div>";
        end;

        define event GBanner;
            put "<td" CR;
            putq " class=" HTMLCLASS;
            trigger align;
            trigger style_inline;
            put ">" CR;
            trigger pre_post;
            put "</td>" CR;
        end;

        define event GNContent;
            put "<td";
            putq " class=" HTMLCLASS;
            trigger align;
            trigger style_inline;
            put ">";
            trigger pre_post start;
            put VALUE;
            trigger pre_post finish;
            put "</td>";
        end;

        define event noteBanner;
            style="NoteBanner";
            trigger GBanner;
        end;

        define event NoteContent;
            style="NoteContent";
            trigger GNContent;
        end;

        define event note;
            trigger Gnote start;
            trigger noteBanner;
            trigger noteContent;
            trigger Gnote finish;
        end;

        define event WarnBanner;
            style="WarnBanner";
            trigger GBanner;
        end;

        define event WarnContent;
            style="WarnContent";
            trigger GNContent;
        end;

        define event Warning;
            trigger Gnote start;
            trigger WarnBanner;
            trigger WarnContent;
            trigger Gnote finish;
        end;

        define event ErrorBanner;
        style="ErrorBanner";
            trigger GBanner;
        end;

        define event ErrorContent;
        style="ErrorContent";
           trigger GNContent;
        end;

        define event Error;
            trigger Gnote start;
            trigger ErrorBanner;
            trigger ErrorContent;
            trigger Gnote finish;
        end;

        define event FatalBanner;
            style="FatalBanner";
            trigger GBanner;
        end;

        define event FatalContent;
            style="FatalContent";
            trigger GNContent;
        end;

        define event Fatal;
            trigger Gnote start;
            trigger FatalBanner;
            trigger FatalContent;
            trigger Gnote finish;
        end;

        define event pagebreak;
            put pagebreakhtml CR;
        end;

        define event pre_post;
            start:
                put PREHTML;
                putq '<img src=' PREIMAGE '>' / if exists(PREIMAGE);
                put PRETEXT;
            finish:
                put POSTTEXT;
                putq '<img src=' POSTIMAGE '>' / if exists(POSTIMAGE);
                put POSTHTML;
        end;

    end;
    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    /*  Default XML format.  ODS XML                                   */
    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/

    define tagset tagsets.default;
        notes "This is the default definition";
        parent=tagsets.htmlcss;
        map = '<>&';
        mapsub = '/&lt;/&gt;/&amp;/';
        nobreakspace = ' ';
        split = '<br/>';
        output_type = 'xml';

        define event top_file;
        end;

        define event top_title;
        end;

        define event top_meta;
        end;

        define event cell_is_empty;
        end;

        define event top_head;
        end;

        define event doc_meta;
        end;

        define event javascript;
        end;

        define event startup_function;
        end;

        define event shutdown_function;
        end;

        define event windowload;
        end;

        define event content_frame;
        end;

        define event body_frame;
        end;

        define event spanning;
              put "  <style>" CR;
              putq "    <span" " rows=" ROWSPAN " columns=" COLSPAN "/>" CR;
              put "  </style>" CR;
        end;

        define event attr_out;
            putq " name="     NAME;
            putq " label="    LABEL;
            putq " clabel="   CLABEL;
            putq " type="     TYPE;
            putq " function=" @FUNCTION;
            putq " path="     PATH;
            putq " title="    FLYOVER;
            putq " class="    HTMLCLASS;
            putq ' id='       HTMLID;
            %not8(putq " hidden="   hidden;)
/*          put  ' align="'   JUST VJUST '"' / when any(JUST, VJUST);*/
        end;

        define event dynamic;
            put "Content-Type: text/xml" CR CR CR;
        end;

        define event stylesheet_link;
            putq "<css file=" URL "/>" CR / if exists(url);
        end;

        define event contents_stylesheet_link;
            putq '<css file=' URL '>' CR / if exists(url);
        end;

        define event doc;
            start:
                put '<?xml version="1.0"';
                putq " encoding=" encoding;
                put "?>" CR CR;
                put "<odsxml>" CR;
            finish:
                put "</odsxml>" CR;
        end;

        define event auth_oper;
            put "<meta" / if any(AUTHOR, OPERATOR);
            putq " author=" AUTHOR;
            putq " operator=" OPERATOR;
            put "/>" CR  / if any(AUTHOR, OPERATOR);
        end;

        define event doc_title;
            put "<title>" / exists(VALUE);
            put VALUE;
            put "</title>" CR  / exists(VALUE);
        end;

        define event doc_head;
           start:
             put "<head>" CR;
           finish:
             put "</head>" CR;
        end;

        define event doc_body;
            start:
                put "<body>" CR;
            finish:
                put "</body>" CR;
        end;

        define event doc_foot;
            start:
                put "<foot>" CR;
            finish:
                put "</foot>" CR;
        end;

        define event stylesheet;
        end;

        define event styles;
        end;


        define event list;
            start:
                put "<ul>" CR;
            finish:
                put "</ul>" CR;
        end;

        define event list_entry;
            put "<li>";
            put VALUE;
            put "</li>" CR;
        end;

        define event anchor;
            put "<label";
            putq " name=" anchor;
            put "/>" CR;
        end;

        define event breakline;
            put "<br/>";
        end;

        define event splitline;
            put "<br/>" CR;
        end;

        define event line;
            put "<hr/>" CR;
        end;

        define event pagebreak;
            put "<page/>" CR;
        end;


        define event map;
            start:
                put "<map";
                putq " name=" NAME ">" CR;
            finish:
                put "</map>" CR;
        end;

        define event map_area;
            start:
                put "<area";
                putq " shape=" @SHAPE CR;
               /*HREF STUFF GOES in HERE*/
                put 'coords="';
            finish:
                put '"/>' CR;
        end;

        define event area_coordinate;
            put VALUE CR;
        end;

        define event image;
            put "<img";
            put ' src="';
            put BASENAME / if !exists(NOBASE);
            put URL;
            put '"';
            putq " border=" BORDERWIDTH;
            put ' usemap="#' @CLIENTMAP;
            put  '"' CR  / if exists(@CLIENTMAP);
            putq " class=" HTMLCLASS;
            putq " id="    HTMLID;
            put "/>" CR;
        end;

        define event output_object;
            start:
                put "<output-object";
                trigger attr_out;
                put ">" CR;
            finish:
                put "</output-object>" CR;
        end;

        define event paragraph;
            start:
                put "<para>" CR VALUE / if exists(VALUE);
            finish:
                put "</para>" CR / if exists(VALUE);
        end;

        define event table;
            start:
                put "<output-object";
                trigger attr_out;
                put ">" CR CR;
                put "  <style>" CR;
                put "    <border";
                putq " spacing=" CELLSPACING;
                putq " padding=" CELLPADDING;
                putq " rules=" RULES;
                putq " frame=" FRAME;
                put "/>" CR;
                put "  </style>" CR;
            finish:
                put "</output-object>" CR;
        end;

        define event table_head;
            start:
                put "<output-head>" CR;
            finish:
                put "</output-head>" CR;
        end;

        define event table_body;
            start:
                put "<output-body>" CR;
            finish:
                put "</output-body>" CR;
        end;

        define event table_foot;
            start:
                put "<output-foot>" CR;
            finish:
                put "</output-foot>" CR;
        end;

        define event colspecs;
            start:
                put "<colspecs";
                putq " columns=" COLCOUNT;
                put ">" CR;
            finish:
                put "</colspecs>" CR;
        end;

        define event colgroup;
            start:
                put "<colgroup>" CR;
            finish:
                put "</colgroup>" CR;
        end;

        define event colspec_entry;
           start:
            put "<colspec";
            putq " name=" COL_ID;
            putq " name=" COLSTART /if !exists(COL_ID);
            putq " width=" WIDTH;
            putq ' align="center"'  / when cmp("c", JUST);
            putq ' align="right"'   / when cmp("r", JUST);
            putq ' align="decimal"' / when cmp("d", JUST);
            putq ' align="justify"' / when cmp("j", JUST);
            putq " type=" TYPE;
            put "/>" CR;
        end;


        define event row;
            start:
                put "<row>" CR;
            finish:
                put "</row>" CR;
        end;

        define event rowcol;
          putq " row=" ROW;
          putq " column=" COLSTART;
          putq " column-end=" COLEND;
        end;

        define event header;
            start:
                put "<header";
                trigger attr_out;
                trigger rowcol;

                put ">";
                put VALUE CR;
                trigger spanning / if any(COLSPAN, ROWSPAN);
            finish:
                put "</header>" CR;
        end;

        define event data;
            start:
                put "<data";
                putq " raw-value=" RAWVALUE;
                putq " missing-value=" MISSING;

                trigger attr_out;
                trigger rowcol;

                put ">";
                put VALUE CR;

                trigger spanning / if any(COLSPAN, ROWSPAN);

            finish:
                put "</data>" CR;
        end;


        define event association;
            start:
                put "<association";
                trigger attr_out;
                put ">" CR;
            finish:
                put "</association>" CR;
        end;

        define event caption;
            start:
                put "<caption";
                trigger attr_out;
                put ">" CR;
                put TEXT;
            finish:
                put "</caption>" CR;
        end;

        define event assoc_end_got_capt;
        end;

        /*
        define event odstag;
            put "<om";
            putq " type=" TYPE;
            putq " id=" ID;
            putq " path=" PATH;
            putq " function=" FUNCTION;
            put "/>";
        end;
        */

        /*==========ODA==========*/

        define event proc;
            start:
                put "<proc";
                trigger attr_out;
                put ">" CR;
            finish:
                put "</proc>" CR;
        end;

        define event output;
            start:
                put "<output";
                trigger attr_out;
                put ">" CR;
            finish:
                put "</output>" CR;
        end;

        define event bygroup;
            start:
                put "<bygroup>" CR;
            finish:
                put "</bygroup>" CR;
        end;

        define event byline;
            put "<byline";
            trigger attr_out;
            putq " toc-level="  TOC_LEVEL;
            put ">";
            put VALUE;
            put "</byline>" CR;
        end;

        define event proc_title;
            put "<proc-title";
            trigger attr_out;
            putq " toc-level="  TOC_LEVEL;
            put ">";
            put VALUE;
            put "</proc-title>" CR;
        end;

        define event system_title;
            put "<title";
            trigger attr_out;
            putq " toc-level="  TOC_LEVEL;
            put ">";
            put VALUE;
            put "</title>" CR;
        end;

        define event system_footer;
            put "<footnote";
            trigger attr_out;
            putq " toc-level="  TOC_LEVEL;
            put ">";
            put VALUE;
            put "</footnote>" CR;
        end;

        define event note;
            put "<note";
            trigger attr_out;
            putq " toc-level="  TOC_LEVEL;
            put ">";
            put VALUE;
            put "</note>" CR;
        end;

        define event warning;
            put "<warning";
            trigger attr_out;
            putq " toc-level="  TOC_LEVEL;
            put ">";
            put VALUE;
            put "</warning>" CR;
        end;

        define event error;
            put "<error";
            trigger attr_out;
            putq " toc-level="  TOC_LEVEL;
            put ">";
            put VALUE;
            put "</error>" CR;
        end;


        define event fatal;
            put "<fatal";
            trigger attr_out;
            putq " toc-level="  TOC_LEVEL;
            put ">";
            put "fatal" VALUE;
            put "</fatal>" CR;
        end;

        define event branch;
            start:
                put "<branch";
                trigger attr_out;
                putq " toc-level="  TOC_LEVEL;
                putq " label="  VALUE;
                put ">" CR;
            finish:
                put "</branch>" CR;
        end;

        define event leaf;
            start:
                put "<leaf";
                trigger attr_out;
                putq " toc-level="  TOC_LEVEL;
                putq " label="  VALUE;
                put ">" CR;
            finish:
                put "</leaf>" CR;
        end;

        define event code_file;
            putl '<?xml version="1.0"?>';
            putl '<xsl:stylesheet version="1.0"';
            putl '  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"';
            putl '  xmlns="http://www.w3.org/TR/REC-html40"';
            putl '>';
            put  CR;
            putl '<xsl:output method="html"/>';
            put  CR;
        end;

        define event code_stylesheet_link;
           putq '      <LINK REL="STYLESHEET" HREF=' url '>' CR /if exists(url);
        end;

        define event code_head;
            putl '<xsl:template match="odsxml">';
            putl '  <HTML>';
            putl '    <HEAD>';
            putl '      <TITLE><xsl:value-of select="proc/title"/></TITLE>';
        finish:
            putl '    </HEAD>';
            putl '    <BODY CLASS="Body">';
            putl '      Table of Contents<HR/>';
            putl '      <xsl:for-each select="body/proc">';
            putl '        <xsl:apply-templates mode="toc"/>';
            putl '      </xsl:for-each>';
            putl '      <P><HR/></P>';
            putl '      <xsl:apply-templates/>';
            putl '    </BODY>';
            putl '  </HTML>';
            putl '</xsl:template>';
            put  CR;
        end;


        define event code;
           putl '<xsl:template mode="toc" match="*"></xsl:template>';
           put  CR;
           putl '<xsl:template mode="toc" match="proc">';
           putl '  <DL>';
           putl '    <xsl:apply-templates mode="style" select="style"/>';
           putl '    <xsl:if test="@class">';
           putl '      <xsl:attribute name="CLASS"><xsl:value-of select="@class"/></xsl:attribute>';
           putl '    </xsl:if>';
           putl '    <DT>';
           putl '      <xsl:if test="@class">';
           putl '        <xsl:attribute name="CLASS"><xsl:value-of select="@class"/></xsl:attribute>';
           putl '      </xsl:if>';
           putl '      The <xsl:value-of select="proc-title"/> Procedure';
           putl '    </DT>';
           putl '    <xsl:apply-templates mode="toc" select="branch|leaf"/>';
           putl '  </DL>';
           putl '</xsl:template>';
           put  CR;
           putl '<xsl:template mode="toc" match="branch">';
           putl '  <DL>';
           putl '    <xsl:apply-templates mode="style" select="style"/>';
           putl '    <xsl:if test="@class">';
           putl '      <xsl:attribute name="CLASS"><xsl:value-of select="@class"/></xsl:attribute>';
           putl '    </xsl:if>';
           putl '    <DT>';
           putl '      <xsl:if test="@class">';
           putl '        <xsl:attribute name="CLASS"><xsl:value-of select="@class"/></xsl:attribute>';
           putl '      </xsl:if>';
           putl '      <xsl:value-of select="@label"/>';
           putl '    </DT>';
           putl '    <xsl:apply-templates mode="toc" select="branch|leaf"/>';
           putl '  </DL>';
           putl '</xsl:template>';
           put  CR;
           putl '<xsl:template mode="toc" match="leaf">';
           putl '  <DD>';
           putl '    <xsl:apply-templates mode="style" select="style"/>';
           putl '    <xsl:if test="@class">';
           putl '      <xsl:attribute name="CLASS"><xsl:value-of select="@class"/></xsl:attribute>';
           putl '    </xsl:if>';
           putl '    <A>';
           putl '      <xsl:attribute name="HREF">#<xsl:value-of select="generate-id(output/output-object)"/></xsl:attribute>';
           putl '      <xsl:value-of select="@label"/>';
           putl '    </A>';
           putl '  </DD>';
           putl '</xsl:template>';
           put  CR;
           putl '<xsl:template match="label">';
           putl '  <A NAME="{@name}"></A>';
           putl '</xsl:template>';
           put  CR;
           putl '<xsl:template match="output-object">';
           putl '  <xsl:choose>';
           putl '    <xsl:when test="string(@type)=string(''table'')">';
           putl '      <DIV ALIGN="CENTER">';
           putl '      <A NAME="{generate-id()}"></A>';
           putl '      <TABLE>';
           putl '      <xsl:apply-templates mode="style" select="style"/>';
           putl '      <xsl:if test="@class">';
           putl '        <xsl:attribute name="CLASS"><xsl:value-of select="@class"/></xsl:attribute>';
           putl '      </xsl:if>';
           putl '      <xsl:apply-templates select="output-head|output-body|output-foot|row"/>';
           putl '      </TABLE>';
           putl '      </DIV>';
           putl '      <BR/>';
           putl '    </xsl:when>';
           putl '  </xsl:choose>';
           putl '</xsl:template>';
           put  CR;
           putl '<xsl:template match="output-head">';
           putl '  <THEAD>';
           putl '    <xsl:if test="@class">';
           putl '      <xsl:attribute name="CLASS"><xsl:value-of select="@class"/></xsl:attribute>';
           putl '    </xsl:if>';
           putl '    <xsl:apply-templates select="row"/>';
           putl '  </THEAD>';
           putl '</xsl:template>';
           put  CR;
           putl '<xsl:template match="output-body">';
           putl '  <TBODY>';
           putl '    <xsl:if test="@class">';
           putl '      <xsl:attribute name="CLASS"><xsl:value-of select="@class"/></xsl:attribute>';
           putl '    </xsl:if>';
           putl '    <xsl:apply-templates select="row"/>';
           putl '  </TBODY>';
           putl '</xsl:template>';
           put  CR;
           putl '<xsl:template match="row">';
           putl '  <TR>';
           putl '    <xsl:apply-templates mode="style" select="style"/>';
           putl '    <xsl:if test="@class">';
           putl '      <xsl:attribute name="CLASS"><xsl:value-of select="@class"/></xsl:attribute>';
           putl '    </xsl:if>';
           putl '    <xsl:apply-templates select="header|data"/>';
           putl '  </TR>';
           putl '</xsl:template>';
           put  CR;
           putl '<xsl:template match="data">';
           putl '  <TD>';
           putl '    <xsl:apply-templates mode="style" select="style"/>';
           putl '    <xsl:if test="@class">';
           putl '      <xsl:attribute name="CLASS"><xsl:value-of select="@class"/></xsl:attribute>';
           putl '    </xsl:if>';
           putl '    <xsl:apply-templates/>';
           putl '  </TD>';
           putl '</xsl:template>';
           put  CR;
           putl '<xsl:template match="header">';
           putl '  <TH>';
           putl '    <xsl:apply-templates mode="style" select="style"/>';
           putl '    <xsl:if test="@class">';
           putl '      <xsl:attribute name="CLASS"><xsl:value-of select="@class"/></xsl:attribute>';
           putl '    </xsl:if>';
           putl '    <xsl:apply-templates/>';
           putl '  </TH>';
           putl '</xsl:template>';
           put  CR;
           putl '<xsl:template match="proc-title">';
           putl '  <P>';
           putl '    <xsl:apply-templates mode="style" select="style"/>';
           putl '    <xsl:if test="@class">';
           putl '      <xsl:attribute name="CLASS"><xsl:value-of select="@class"/></xsl:attribute>';
           putl '    </xsl:if>';
           putl '    <xsl:apply-templates/>';
           putl '  </P>';
           putl '</xsl:template>';
           put  CR;
           putl '<xsl:template match="title">';
           putl '  <P>';
           putl '    <xsl:apply-templates mode="style" select="style"/>';
           putl '    <xsl:if test="@class">';
           putl '      <xsl:attribute name="CLASS"><xsl:value-of select="@class"/></xsl:attribute>';
           putl '    </xsl:if>';
           putl '    <xsl:apply-templates/>';
           putl '  </P>';
           putl '</xsl:template>';
           put  CR;
           putl '<xsl:template match="style" mode="style">';
           putl '  <xsl:attribute name="style">';
           putl '  <xsl:for-each select="color">';
           putl '    <xsl:if test="@background">background:<xsl:value-of select="@background"/>;</xsl:if>';
           putl '    <xsl:if test="@foreground">color:<xsl:value-of select="@foreground"/>;</xsl:if>';
           putl '  </xsl:for-each>';
           putl '  <xsl:for-each select="font">';
           putl '    <xsl:if test="@weight">font-weight:<xsl:value-of select="@weight"/>;</xsl:if>';
           putl '    <xsl:if test="@family">font-family:<xsl:value-of select="@family"/>;</xsl:if>';
           putl '    <xsl:if test="@italic">font-style:italic;</xsl:if>';
           putl '  </xsl:for-each>';
           putl '  <xsl:for-each select="align">';
           putl '    <xsl:if test="@horiz">text-align:<xsl:value-of select="@horiz"/>;</xsl:if>';
           putl '  </xsl:for-each>';
           putl '  <xsl:for-each select="border">';
           putl '    <xsl:if test="@type">border-style:<xsl:value-of select="@type"/>;</xsl:if>';
           putl '    <xsl:if test="@color">border-color:<xsl:value-of select="@color"/>;</xsl:if>';
           putl '    <xsl:if test="@thickness">border-width:<xsl:value-of select="@thickness"/>;</xsl:if>';
           putl '  </xsl:for-each>';
           putl '  </xsl:attribute>';
           put  CR;
           putl '  <xsl:for-each select="border">';
           putl '    <xsl:if test="@padding"><xsl:attribute name="CELLPADDING"><xsl:value-of select="@padding"/></xsl:attribute></xsl:if>';
           putl '    <xsl:if test="@spacing"><xsl:attribute name="CELLSPACING"><xsl:value-of select="@spacing"/></xsl:attribute></xsl:if>';
           putl '    <xsl:if test="@frame"><xsl:attribute name="FRAME"><xsl:value-of select="@frame"/></xsl:attribute></xsl:if>';
           putl '    <xsl:if test="@rules"><xsl:attribute name="RULES"><xsl:value-of select="@rules"/></xsl:attribute></xsl:if>';
           putl '  </xsl:for-each>';
           put  CR;
           putl '  <xsl:for-each select="span">';
           putl '    <xsl:if test="@columns"><xsl:attribute name="COLSPAN"><xsl:value-of select="@columns"/></xsl:attribute></xsl:if>';
           putl '    <xsl:if test="@rows"><xsl:attribute name="ROWSPAN"><xsl:value-of select="@rows"/></xsl:attribute></xsl:if>';
           putl '  </xsl:for-each>';
           putl '</xsl:template>';
           put  CR;
           putl '<xsl:template match="message">';
           putl '  <DIV ALIGN="CENTER">';
           putl '  <TABLE>';
           putl '    <xsl:if test="@class">';
           putl '      <xsl:attribute name="CLASS"><xsl:value-of select="@class"/></xsl:attribute>';
           putl '    </xsl:if>';
           putl '    <xsl:attribute name="WIDTH">90%</xsl:attribute>';
           putl '    <TR><TD><xsl:apply-templates/></TD></TR>';
           putl '  </TABLE>';
           putl '  </DIV>';
           putl '</xsl:template>';
           put  CR;
           putl '<xsl:template match="styles|style|colspec|page">';
           putl '</xsl:template>';
           put  CR;
           putl '<xsl:template match="branch|leaf|output|proc">';
           putl '  <xsl:apply-templates/>';
           putl '</xsl:template>';
           put  CR;
           putl '<xsl:template match="br">';
           putl '  <BR/>';
           putl '</xsl:template>';
           put  CR;
           putl '</xsl:stylesheet>';
        end;

        define event top_code;
           putl '<!ELEMENT odsxml (head?,body)>';
           put  CR;
           putl '<!ELEMENT head (meta|css)*>';
           put  CR;
           putl '<!ELEMENT body ((label|page)*|proc)+>';
           put  CR;
           putl '<!ELEMENT meta EMPTY>';
           putl '<!ATTLIST meta';
           putl '          operator  CDATA  #IMPLIED';
           putl '          author    CDATA  #IMPLIED>';
           put  CR;
           putl '<!ELEMENT css EMPTY>';
           putl '<!ATTLIST css';
           putl '          file  CDATA  #IMPLIED>';
           put  CR;
           putl '<!ELEMENT label EMPTY>';
           putl '<!ATTLIST label ';
           putl '          name      ID    #IMPLIED>';
           put  CR;
           putl '<!ELEMENT proc (title|proc-title|note|page|label|style|branch|output)*>';
           putl '<!ATTLIST proc';
           putl '          class    CDATA    #IMPLIED>';
           put  CR;
           putl '<!ELEMENT title (#PCDATA|it|b|ul|br|style)*>';
           putl '<!ATTLIST title';
           putl '          class     CDATA    #IMPLIED';
           putl '          toc-level CDATA    #IMPLIED>';
           put  CR;
           putl '<!ELEMENT proc-title (#PCDATA|it|b|ul|br|style)*>';
           putl '<!ATTLIST proc-title';
           putl '          class     CDATA    #IMPLIED';
           putl '          toc-level CDATA    #IMPLIED>';
           put  CR;
           putl '<!ELEMENT note (#PCDATA|it|b|ul|br|style)*>';
           putl '<!ATTLIST note';
           putl '          class     CDATA    #IMPLIED';
           putl '          toc-level CDATA    #IMPLIED';
           putl '          label     CDATA    #IMPLIED>';
           put  CR;
           putl '<!ELEMENT branch';
           putl '          (branch|leaf|page|label|title|proc-title|note|message|style|output|byl)+>';
           putl '<!ATTLIST branch';
           putl '          class     CDATA    #IMPLIED';
           putl '          label     CDATA    #IMPLIED';
           putl '          toc-level CDATA    #IMPLIED>';
           put  CR;
           putl '<!ELEMENT leaf';
           putl '         (label|page|association|proc-title|title|style|output|output-object)*>';
           putl '<!ATTLIST leaf';
           putl '          class     CDATA    #IMPLIED';
           putl '          label     CDATA    #IMPLIED';
           putl '          toc-level CDATA    #IMPLIED>';
           put  CR;
           putl '<!ELEMENT association (caption|style|output-object)*>';
           put  CR;
           putl '<!ELEMENT caption (#PCDATA|it|b|ul|output-object|style)*>';
           putl '<!ATTLIST caption ';
           putl '          class    CDATA    #IMPLIED>';
           put  CR;
           putl '<!ELEMENT message (#PCDATA|it|b|ul|style)*>';
           putl '<!ATTLIST message ';
           putl '          type     (Note|Error|FatalError|Warning)   "Note" ';
           putl '          class    CDATA    #IMPLIED>';
           put  CR;
           putl '<!ELEMENT output';
           putl '     (output-object|style|message|label|page|byl|branch|para|title|proc-title|note)*>';
           putl '<!ATTLIST output';
           putl '          name    CDATA    #IMPLIED';
           putl '          label   CDATA    #IMPLIED';
           putl '          clabel  CDATA    #IMPLIED>';
           put  CR;
           putl '<!ELEMENT output-object (colspecs?|output-head?|output-foot?|style*|output-body|row)+>';
           putl '<!ATTLIST output-object';
           putl '          class    CDATA    #IMPLIED';
           putl '          index    CDATA    #IMPLIED';
           putl '          type     (table)  #REQUIRED>';
           put  CR;
           putl '<!ELEMENT output-head (row|style*)+>';
           put  CR;
           putl '<!ELEMENT output-body (row|style*)+>';
           put  CR;
           putl '<!ELEMENT output-foot (row|style*)+>';
           put  CR;
           putl '<!ELEMENT row (header|data|style*)+>';
           put  CR;
           putl '<!ELEMENT para (output-object|style|message|label|page|byl|branch|para)*>';
           put  CR;
           putl '<!ELEMENT byl (#PCDATA|it|b|ul|br|style)*>';
           putl '<!ATTLIST byl';
           putl '          class    CDATA    #IMPLIED';
           putl '          name     CDATA    #IMPLIED';
           putl '          label    CDATA    #IMPLIED';
           putl '          dname    CDATA    #IMPLIED>';
           put  CR;
           putl '<!ELEMENT header (#PCDATA|it|b|ul|br|style)*>';
           putl '<!ATTLIST header';
           putl '          class    CDATA    #IMPLIED';
           putl '          name     CDATA    #IMPLIED';
           putl '          label    CDATA    #IMPLIED';
           putl '          dname    CDATA    #IMPLIED';
           putl '          type     CDATA    #IMPLIED';
           putl '          row      CDATA    #IMPLIED';
           putl '          column   CDATA    #IMPLIED';
           putl '          column-end CDATA  #IMPLIED';
           putl '          raw-value  CDATA  #IMPLIED>';
           put  CR;
           putl '<!ELEMENT data (#PCDATA|it|b|ul|br|style)*>';
           putl '<!ATTLIST data';
           putl '          class    CDATA    #IMPLIED';
           putl '          name     CDATA    #IMPLIED';
           putl '          label    CDATA    #IMPLIED';
           putl '          dname    CDATA    #IMPLIED ';
           putl '          type     CDATA    #IMPLIED';
           putl '          row      CDATA    #IMPLIED';
           putl '          column   CDATA    #IMPLIED';
           putl '          column-end CDATA  #IMPLIED';
           putl '          column_end CDATA  #IMPLIED';
           putl '          raw-value  CDATA  #IMPLIED';
           putl '          missing-value  CDATA  #IMPLIED>';
           put  CR;
           putl '<!ELEMENT colspecs (colgroup)+>';
           putl '<!ATTLIST colspecs';
           putl '          columns  CDATA    #IMPLIED>';
           put  CR;
           putl '<!ELEMENT colspec (col)*>';
           putl '<!ATTLIST colspec';
           putl '          name     CDATA    #IMPLIED';
           putl '          width    CDATA    #IMPLIED';
           putl '          type     CDATA    #IMPLIED';
           putl '          align    (left|center|right|justify|decimal)  "left">';
           put  CR;
           putl '<!ELEMENT colgroup (colspec)+>';
           put  CR;
           putl '<!ELEMENT col EMPTY> ';
           putl '<!ATTLIST col ';
           putl '          alignchar  CDATA                                #IMPLIED';
           putl '          align      (left|center|right|char|justify|decimal)     "left">';
           put  CR;
           putl '<!ELEMENT br EMPTY>';
           putl '<!ELEMENT page EMPTY>';
           put  CR;
           putl '<!ELEMENT b (#PCDATA|it|b|ul)*>';
           putl '<!ELEMENT ul (#PCDATA|it|b|ul)*>';
           putl '<!ELEMENT it (#PCDATA|it|b|ul)*>';
           put  CR;
           putl '<!ELEMENT style (span|align|border)*>';
           put  CR;
           putl '<!ELEMENT span EMPTY>';
           putl '<!ATTLIST span';
           putl '          columns    CDATA    #IMPLIED';
           putl '          rows       CDATA    #IMPLIED>';
           put  CR;
           putl '<!ELEMENT align EMPTY>';
           putl '<!ATTLIST align';
           putl '          horiz  (left|center|right|justify)    "left">';
           put  CR;
           putl '<!ELEMENT border EMPTY>';
           putl '<!ATTLIST border ';
           putl '          rules    (NONE|GROUPS|ROWS|COLS|ALL)    #IMPLIED';
           putl '          frame    (VOID|ABOVE|BELOW|HSIDES|LHS|RHS|VSIDES|BOX|BORDER) #IMPLIED';
           putl '          padding  CDATA                          #IMPLIED';
           putl '          spacing  CDATA                          #IMPLIED>';
        end;
    end;

    /******************************************************/
    /******************************************************/
    /******************************************************/
    /*  DOCBOOK definition                                */
    /******************************************************/
    /******************************************************/
    /******************************************************/

    define tagset tagsets.docbook;
        notes "This is the DOCBOOK definition";
        map = '<>&';
        mapsub = '/&lt;/&gt;/&amp;/';
        nobreakspace = '&nbsp;';
        split = '<br>';
        stacked_columns = yes;
        output_type = 'xml';


        define event dynamic;
            put "Content-Type: text/xml" CR CR CR;
        end;

        define event doc;
            start:
                put '<?xml version="1.0"';
                putq " encoding=" encoding;
                put "?>" CR CR;
                put "<article>" CR;
            finish:
                put "</article>" CR;
        end;

        define event doc_head;
            start:
                put "<artheader>" CR;
            finish:
                put "</artheader>" CR;
        end;

        define event list;
            start:
                put "<ul>" CR;
            finish:
                put "</ul>" CR;
        end;

        define event list_entry;
            put "<li>";
            put VALUE;
            put "</li>" CR;
        end;

        define event map;
            start:
                put "<map";
                putq " name=" NAME CR ">" CR;
            finish:
                put "</map>" CR;
        end;

        define event map_area;
            start:
                put "<area";
                putq " shape=" @SHAPE CR;
               /*HREF STUFF GOES in HERE*/
                put 'coords="';
        finish:
                put '"/>' CR;
        end;

        define event area_coordinate;
            put VALUE CR;
        end;

        define event image;
            put "<img";
            put ' src="';
            put BASENAME / if !exists(NOBASE);
            put URL;
            put '"';
            putq " border=" BORDERWIDTH;
            put ' usemap="#' @CLIENTMAP;
            put  '"' CR  / if exists(@CLIENTMAP);
            putq " class=" HTMLCLASS;
            putq " id="    HTMLID;
            put "/>" CR;
        end;

        define event output_object;
            start:
                put "<output-object" ;
                trigger attr_out;
                put ">" CR;
            finish:
                put "</output-object>" CR;
        end;

        define event paragraph;
            start:
                put "<para>" CR;
            finish:
                put "</para>" CR;
        end;

        define event table;
            start:
                put "<para>" CR;
                put "<informaltable";
                put ' colsep="1" rowsep="1"';
                put ' frame="all">' CR;
            finish:
                put "</tgroup>" CR;
                put "</informaltable>" CR;
                put "</para>" CR;
        end;

        define event table_head;
            start:
                put "<thead>" CR;
            finish:
                put "</thead>" CR;
        end;

        define event table_body;
            start:
                put "<tbody>" CR;
            finish:
                put "</tbody>" CR;
        end;

        define event table_foot;
            start:
                put "<tfoot>" CR;
            finish:
                put "</tfoot>" CR;
        end;

        define event colspecs;
            put "<tgroup";
            putq " cols=" COLCOUNT;
            put ">" CR;
        end;

        define event colspec_entry;
            put "<colspec";
            put ' colname="col' COLSTART;
            put '"';
            put ' colwidth="' WIDTH;
            put '*"/>' CR;
        end;

        define event row;
            start:
                put "<row>" CR;
            finish:
                put "</row>" CR;
        end;

        define event rowcol;
            putq ' morerows=' ROWSPAN;
            put  ' namest="col' COLSTART / if exists(COLSPAN );
            put  '"' / if exists(COLSPAN,COLSTART) ;
            put  ' nameend="col' COLEND;
            put  '"' / if exists(COLEND) ;
        end;

        define event header;
            start:
                put "<entry";
                trigger rowcol;
                put ">";
                put VALUE;
            finish:
                put "</entry>" CR;
        end;

        define event data;
            start:
                put "<entry";
                trigger rowcol;
                put ">";
                put VALUE;
            finish:
                put "</entry>" CR;
        end;

        define event cell_is_empty;
            put '&nbsp;';
        end;

        define event verbatim;
            start:
                put "<pre>";
            finish:
                put "</pre>";
        end;


        define event association;
            start:
                put "<association>" CR;
            finish:
                put "</association>" CR;
        end;

        define event caption;
            start:
                put "<caption>" CR;
            finish:
                put "</caption>" CR;
        end;

        /*==========ODA==========*/

        define event byline;
            put "<title>";
            put VALUE;
            put "</title>" CR;
        end;

        define event proc_title;
            put "<title>";
            put VALUE;
            put "</title>" CR;
        end;

        define event system_title;
            put "<title>";
            put VALUE;
            put "</title>" CR;
        end;

        define event system_footer;
            put "<title>";
            put VALUE;
            put "</title>" CR;
        end;

        define event note;
            put "<!--";
            put VALUE;
            put "-->" CR;
        end;

        define event warning;
            put "<!--";
            put VALUE;
            put "-->" CR;
        end;

        define event error;
            put "<!--";
            put VALUE;
            put "-->" CR;
        end;


        define event fatal;
            put "<!--";
            put VALUE;
            put "-->" CR;
        end;

        define event branch;
            start:
                put "<sect" TOC_LEVEL;
                put ">" CR;
                put "<title>";
                put VALUE;
                put "</title>" CR;
            finish:
                put "</sect" TOC_LEVEL;
                put ">" CR;
        end;

        define event leaf;
            start:
                put "<sect" TOC_LEVEL;
                put ">" CR;
                put "<title>";
                put VALUE;
                put "</title>" CR;
            finish:
                put "</sect" TOC_LEVEL;
                put ">" CR;
        end;

        define event splitline;
            put CR;
        end;
    end;


    /******************************************************/
    /******************************************************/
    /******************************************************/
    /*  LaTeX definition                                  */
    /******************************************************/
    /******************************************************/
    /******************************************************/

    define tagset tagsets.latex;
        notes 'This is the LaTeX definition';
        stacked_columns = no;
        output_type = 'latex';
        map = '%$&{}~^#<>_|';
        mapsub= '/\%/\$/\&/\{/\}/\~/\^/\#/{\textless}/{\textgreater}/{\textunderscore}/{\textbar}/'
        nobreakspace = '~';
        split='\linebreak ';


        define event doc;
           start:
               put CR '\documentclass[10pt]{article}' CR CR;
               put '%    Generated by SAS' CR;
               put '%    http://www.sas.com' CR;
           finish:
               put '\end{document}' CR;
        end;

        define event contents;
           start:
               put CR '\documentclass[10pt]{article}' CR CR;
               put '%    Generated by SAS' CR;
               put '%    http://www.sas.com' CR;
           finish:
               put '\end{document}' CR;
        end;

        define event stylesheet_link;
            put CR '\input{';
            put URL;
            put '}' CR CR;
        end;

        define event doc_head;
            finish:
                put '\begin{document}' CR CR;
        end;

        define event list;
           start:
              put '\begin{itemize}' /if exists(bullet);
              put '\begin{deflist}' /if !exists(bullet);
           finish:
              put '\end{itemize}' CR;
        end;


        define event list_entry;
            put ']' / if !exists(bullet);
            put '\newline ' CR;
        end;

        define event image;
            put '\epsfig{file=';
            put BASENAME / if !exists(NOBASE);
            put URL;
            put '}' CR;
        end;

        define event line;
            put '\rule{\linewidth}{' width;
            put 'pt}' CR;
        end;

        define event paragraph;
            start:
                put '\par ' CR;
        end;


        define event preformat;
            start:
                put '{\tt ' CR;
            finish:
                put '}' CR;
        end;

        define event center;
            start:
                put '\begin{center}' CR;
            finish:
                put '\end{center}' CR;
        end;

        define event styles;
            start:
                put CR;
                put '\usepackage{times}' CR;
                put '\usepackage{array}' CR CR;
            finish:
                put CR '% Set cell padding' CR;
                put '\renewcommand{\arraystretch}{1.3}' CR CR;
                put '% Headings' CR;
                put '\newcommand{\sasheading}[2]{\csname sas#1\endcsname #2}' CR;
                put '\newcommand{\sasproctitle}[2]{\csname sas#1\endcsname #2}' CR CR;
                put '% Declare new column type' CR;
                put '\newcolumntype{S}[2]{>{\csname sas#1\endcsname}#2}' CR CR;
                put '% Set warning box style' CR;
                put '\newcommand{\sasmsg}[2]{\fbox{%' CR;
                put '   \csname sas#1\endcsname%' CR;
                put '   \begin{minipage}{\textwidth}#2\end{minipage}}%' CR;
                put '}' CR CR;
        end;


       define event style_class;
           start:
               put '\def\sas'  HTMLCLASS;
               put '{' ;
               put FONT_SIZE;
               put FONT_WEIGHT;
               put FONT_STYLE;
               put FONT_FACE;
           finish:
               put '}' CR;
       end;



       define event caption;
           start:
               put '\sasheading{Caption}{{' / if cmp(TYPE, 'T');
               put '\marginpar{\sasCaption{' / if cmp(TYPE, 'L');
           finish:
               put '}}' CR / if cmp(TYPE, 'T');
               put '}}' CR / if cmp(TYPE, 'L');
        end;

       define event table;
         start:
             trigger block_just;
             put '\begin{tabular}' CR;
         finish:
             put '\end{tabular}' CR;
             trigger block_just;
             put '\vskip\baselineskip' /if cmp(just, 'c');
         end;

        define event colspecs;
            start:
                put '{';
            finish:
                put '}\hline' CR;
        end;

        define event colspec_entry;
            put just / if !cmp(just, 'd');
            put 'r' / if cmp(just, 'd');
        end;

        define event row;
            finish:
                put CR '\\\hline' CR;
        end;

        define event rowspanfillsep;
            put ' & ' CR;
        end;

        define event rowspancolspanfill;
            put '   ';
            put '\multicolumn{';
            put colspan;
            put '1' /if !exists(colspan);
            put '}{|l|}{~}';
        end;

        define event header;
            start:
               trigger data;
            finish:
               trigger data;
        end;

        define event data;
            start:

                put ' & ' CR / if !cmp(COLSTART, '1') ;

                /* Print cell formatting including class name and alignment. */
                put '   ';
                put '\multicolumn{';
                put colspan;
                put '1' / if !exists(colspan);
                put '}';
                put '{|S{';
                put HTMLCLASS;
                put '}{';
                put just / if !cmp(just, 'd');
                put 'r' / if cmp(just, 'd');
                put '}|}';
                put '{';
                put VALUE;

            finish:
                put '}';
        end;

        define event pagebreak;
            put '\pagebreak';
        end;


        define event byline;
            put '\sasbyl{';
            put VALUE;
            put '}';
        end;

        define event block_just;
            start:
                put '\begin{';
                put 'center' /if cmp(just, 'c');
                put 'raggedleft' /if cmp(just, 'd');
                put 'raggedleft' /if cmp(just, 'r');
                put 'raggedright' /if cmp(just, 'l');
                put '}';
            finish:
                put '\linebreak' /if !cmp(just, 'c');
                put '\end{';
                put 'center' /if cmp(just, 'c');
                put 'raggedleft' /if cmp(just, 'd');
                put 'raggedleft' /if cmp(just, 'r');
                put 'raggedright' /if cmp(just, 'l');
                put '}' CR;
        end;

        define event proc_title;
                trigger block_just start;
                put '\sasheading{ProcTitle}{';
                put VALUE;
                put '}';
                trigger block_just finish;
        end;

        define event note;
                trigger block_just start;
                put '\sasmsg{NoteBanner}{';
                put VALUE;
                put '}';
                trigger block_just finish;
        end;
        define event Error;
                trigger block_just start;
                put '\sasmsg{ErrorBanner}{';
                put VALUE;
                put '}';
                trigger block_just finish;
        end;
        define event Warn;
                trigger block_just start;
                put '\sasmsg{WarnBanner}{';
                put VALUE;
                put '}';
                trigger block_just finish;
        end;
        define event Fatal;
                trigger block_just start;
                put '\sasmsg{FatalBanner}{';
                put VALUE;
                put '}';
                trigger block_just finish;
        end;

        define event system_title;
                trigger block_just start;
                put '\sasheading{SystemTitle}{';
                put VALUE;
                put '}';
                trigger block_just finish;
        end;

        define event system_footer;
                trigger block_just start;
                put '\sasheading{SystemFooter}{';
                put VALUE;
                put '}';
                trigger block_just finish;
        end;

        define event leaf;
        end;

        define event branch;
        end;

    end;

    define tagset tagsets.colorlatex;
        notes 'This is the color LaTeX definition';
        stacked_columns = no;
        output_type = 'latex';
        map = '%$&{}~^#<>_|';
        mapsub= '/\%/\$/\&/\{/\}/\~/\^/\#/{\textless}/{\textgreater}/{\textunderscore}/{\textbar}/'
        nobreakspace = '~';
        split='\linebreak ';


        define event doc;
           start:
               put CR '\documentclass[10pt]{article}' CR CR;
               put '%    Generated by SAS' CR;
               put '%    http://www.sas.com' CR;
           finish:
               put '\end{document}' CR;
        end;

        define event contents;
           start:
               put CR '\documentclass[10pt]{article}' CR CR;
               put '%    Generated by SAS' CR;
               put '%    http://www.sas.com' CR;
           finish:
               put '\end{document}' CR;
        end;

        define event stylesheet_link;
            put CR '\input{';
            put URL;
            put '}' CR CR;
        end;

        define event doc_head;
            finish:
                put '\begin{document}' CR;
                put '\tableofcontents' CR;
                put '\pagebreak' CR CR;
        end;

        define event list;
           start:
              put '\begin{itemize}' /if exists(bullet);
              put '\begin{deflist}' /if !exists(bullet);
           finish:
              put '\end{itemize}' CR;
        end;


        define event list_entry;
            put ']' / if !exists(bullet);
            put '\newline ' CR;
        end;

        define event image;
            put '\epsfig{file=';
            put BASENAME / if !exists(NOBASE);
            put URL;
            put '}' CR;
        end;

        define event line;
            put '\rule{\linewidth}{' width;
            put 'pt}' CR;
        end;

        define event paragraph;
            start:
                put '\par ' CR;
        end;


        define event preformat;
            start:
                put '{\tt ' CR;
            finish:
                put '}' CR;
        end;

        define event center;
            start:
                put '\begin{center}' CR;
            finish:
                put '\end{center}' CR;
        end;

        define event styles;
            start:
                put CR;
                put '% Check for PDFLaTex' CR;
                put '\newif\ifpdf' CR;
                put '\ifx\pdfoutput\undefined' CR;
                put '  \pdffalse' CR;
                put '\else' CR;
                put '  \pdfoutput=1' CR;
                put '  \pdftrue' CR;
                put '\fi' CR;
                put '' CR;
                put '\usepackage{times}' CR;
                put '\usepackage{array}' CR;
                put '' CR;
                put '\ifpdf' CR;
                put '  \RequirePackage[pdftex,colorlinks]{hyperref}' CR;
                put '  \RequirePackage[pdftex]{colortbl}' CR;
                put '\else' CR;
                put '  \RequirePackage[dvips,pageanchor=false]{hyperref}' CR;
                put '  \RequirePackage[dvips]{colortbl}' CR;
                put '\fi' CR CR;
                put '% Define styles' CR CR;
                put '\makeatletter' CR;
            finish:
                put CR '% Set cell padding' CR;
                put '\renewcommand{\arraystretch}{1.3}' CR CR;
                put '% Declare new column type' CR;
                put '\newcolumntype{C}[4]{>{\csname sas#1\endcsname\sas@fgcolor{#3}\columncolor[rgb]{#4}}#2}' CR CR;
                put '% Cell color macros' CR;
                put '\definecolor{gray}{rgb}{0.9,0.9,0.9}' CR;
                put '\definecolor{}{rgb}{1,1,1}' CR;
                put '\newcommand{\sas@fgcolor}[1]{\sas@@fgcolor#1,\relax}' CR;
                put '\def\sas@@fgcolor#1,#2\relax{%' CR;
                put '  \ifx\relax#2\relax%' CR;
                put '    \ifx\relax#1\relax\else\color{#1}\fi' CR;
                put '  \else' CR;
                put '    \sas@@@fgcolor#1,#2\relax' CR;
                put '  \fi}' CR;
                put '\def\sas@@@fgcolor#1,#2,#3,\relax{%' CR;
                put '  \color[rgb]{#1,#2,#3}' CR;
                put '}' CR CR;
                put '% Set warning box style' CR;
                put '\newcommand{\sasmsg}[2]{\fcolorbox{black}{gray}{%' CR;
                put '   \csname sas#1\endcsname%' CR;
                put '   \begin{minipage}{\textwidth}#2\end{minipage}}%' CR;
                put '}' CR CR;
                put '% Table of contents commands' CR;
                put '\newcommand{\sasleaf}[2]{\sas@dotoc{#1}{#2}}' CR;
                put '\newcommand{\sasnode}[2]{\sas@dotoc{#1}{#2}}' CR CR;
                put '% Headings' CR;
                put '\newcommand{\sasheading}[2]{\csname sas#1\endcsname #2}' CR;
                put '\newcommand{\sasproctitle}[2]{\csname sas#1\endcsname #2}' CR CR;
                put '\newcount\target' CR;
                put '\target=0' CR;
                put '\newcommand{\sas@dotoc}[2]{%' CR;
                put '   \advance\target by 1' CR;
                put '   \def\currentTarget{\jobname.\the\target}' CR;
                put '   \hypertarget{\currentTarget}{}' CR;
                put '   \ifnum #1 = 0' CR;
                put '      \addtocontents{toc}{\protect\contentsline{part}{#2}{\thepage}{\currentTarget}}' CR;
                put '      \pdfbookmark[0]{#2}{\currentTarget}' CR;
                put '   \else\ifnum #1 = 1' CR;
                put '      \addtocontents{toc}{\protect\contentsline{section}{#2}{\thepage}{\currentTarget}}' CR;
                put '      \pdfbookmark[1]{#2}{\currentTarget}' CR;
                put '   \else\ifnum #1 = 2' CR;
                put '      \addtocontents{toc}{\protect\contentsline{subsection}{#2}{\thepage}{\currentTarget}}' CR;
                put '      \pdfbookmark[2]{#2}{\currentTarget}' CR;
                put '   \else\ifnum #1 = 3' CR;
                put '      \addtocontents{toc}{\protect\contentsline{subsubsection}{#2}{\thepage}{\currentTarget}}' CR;
                put '      \pdfbookmark[3]{#2}{\currentTarget}' CR;
                put '   \else\ifnum #1 = 4' CR;
                put '      \addtocontents{toc}{\protect\contentsline{paragraph}{#2}{\thepage}{\currentTarget}}' CR;
                put '      \pdfbookmark[4]{#2}{\currentTarget}' CR;
                put '   \else\ifnum #1 = 5' CR;
                put '      \addtocontents{toc}{\protect\contentsline{subparagraph}{#2}{\thepage}{\currentTarget}}' CR;
                put '      \pdfbookmark[5]{#2}{\currentTarget}' CR;
                put '   \fi\fi\fi\fi\fi\fi' CR;
                put '}' CR;
        end;


       define event style_class;
           start:
               put '\def\sas'  HTMLCLASS;
               put '{' ;
               put FONT_SIZE;
               put FONT_WEIGHT;
               put FONT_STYLE;
               put FONT_FACE;
               put '\sas@fgcolor{' FOREGROUND '}' / if exists(foreground);
           finish:
               put '}' CR;
       end;



       define event caption;
           start:
               put '\sasheading{Caption}{{' / if cmp(TYPE, 'T');
               put '\marginpar{\sasCaption{' / if cmp(TYPE, 'L');
           finish:
               put '}}' CR / if cmp(TYPE, 'T');
               put '}}' CR / if cmp(TYPE, 'L');
        end;

       define event table;
         start:
             trigger block_just;
             put '\begin{tabular}' CR;
         finish:
             put '\end{tabular}' CR;
             trigger block_just;
             put '\vskip\baselineskip' /if cmp(just, 'c');
         end;

        define event colspecs;
            start:
                put '{';
            finish:
                put '}\hline' CR;
        end;

        define event colspec_entry;
            put just / if !cmp(just, 'd');
            put 'r' / if cmp(just, 'd');
        end;

        define event row;
            finish:
                put CR '\\\hline' CR;
        end;

        define event rowspanfillsep;
            put ' & ' CR;
        end;

        define event rowspancolspanfill;
            put '   ';
            put '\multicolumn{';
            put colspan;
            put '1' /if !exists(colspan);
            put '}{|c|}{~}';
        end;

        define event header;
            start:
               trigger data;
            finish:
               trigger data;
        end;

        define event data;
            start:

                 put ' & ' CR / if !cmp(COLSTART, '1') ;

                /* Print cell formatting including class name, alignment,
                 * foreground color, and background color.
                 */
                put '   ';
                put '\multicolumn{';
                put colspan;
                put '1' / if !exists(colspan);
                put '}';
                put '{|C{';
                put HTMLCLASS;
                put '}{';
                put just / if !cmp(just, 'd');
                put 'r' / if cmp(just, 'd');
                put '}{';
                put FOREGROUND;
                put '}{';
                put BACKGROUND;
                put '}|}';
                put '{';
                put VALUE;

            finish:
                put '}';
        end;

        define event pagebreak;
            put '\pagebreak';
        end;


        define event byline;
            put '\sasbyl{';
            put VALUE;
            put '}';
        end;

        define event block_just;
            start:
                put '\begin{';
                put 'center' /if cmp(just, 'c');
                put 'raggedleft' /if cmp(just, 'd');
                put 'raggedleft' /if cmp(just, 'r');
                put 'raggedright' /if cmp(just, 'l');
                put '}';
            finish:
                put '\linebreak' /if !cmp(just, 'c');
                put '\end{';
                put 'center' /if cmp(just, 'c');
                put 'raggedleft' /if cmp(just, 'd');
                put 'raggedleft' /if cmp(just, 'r');
                put 'raggedright' /if cmp(just, 'l');
                put '}' CR;
        end;

        define event proc_title;
                trigger block_just start;
                put '\sasheading{ProcTitle}{';
                put VALUE;
                put '}';
                trigger block_just finish;
        end;

        define event note;
                trigger block_just start;
                put '\sasmsg{';
                put 'NoteBanner}{';
                put VALUE;
                put '}';
                trigger block_just finish;
        end;
        define event Error;
                trigger block_just start;
                put '\sasmsg{';
                put 'ErrorBanner}{';
                put VALUE;
                put '}';
                trigger block_just finish;
        end;
        define event Warn;
                trigger block_just start;
                put '\sasmsg{';
                put 'WarnBanner}{';
                put VALUE;
                put '}';
                trigger block_just finish;
        end;
        define event Fatal;
                trigger block_just start;
                put '\sasmsg{';
                put 'FatalBanner}{';
                put VALUE;
                put '}';
                trigger block_just finish;
        end;

        define event system_title;
                trigger block_just start;
                put '\sasheading{SystemTitle}{';
                put VALUE;
                put '}';
                trigger block_just finish;
        end;

        define event system_footer;
                trigger block_just start;
                put '\sasheading{SystemFooter}{';
                put VALUE;
                put '}';
                trigger block_just finish;
        end;

        define event leaf;
              put '\sasleaf{' toc_level '}{';
              put VALUE;
              put '}' CR;
        end;

        define event branch;
              put '\sasnode{' toc_level '}{';
              put VALUE;
              put '}' CR;
        end;

    end;

    /***********************************************************************/
    /***********************************************************************/
    /***********************************************************************/
    /*    Troff tagset                                                     */
    /*    This command works for me on Linux - Eric                        */
    /*                groff -s -t -mm -b -Tps foo.tr > foo.ps              */
    /*    This one also works...  -T is the device type...                 */
    /*        soelim foo.tr | tbl | groff -mm -Tdvi > foo.dvi              */
    /***********************************************************************/
    /***********************************************************************/
    /***********************************************************************/
    define tagset tagsets.troff;
        notes 'This is the Troff definition';
        stacked_columns = no;
        output_type = 'troff';
        map = %map;
        mapsub = '/"/\(co/\(rg/\(tm/';
        split='\n.br\n';
        nobreakspace = '\~';


        define event doc;
           start:
               put ".de TM" CR;
               put ".sp .75i" CR;
               put ".." CR;
               put ".de BM" CR;
               put ".bp" CR;
               put ".." CR;
               put ".wh 0 TM" CR;
               put ".wh -.1i BM " CR;
               put ".ll 7i" CR;
               put ".po .75i" CR;
               put '.PH "';
               put "'''\*(DT'";
               put '"' CR;
               put '.PF "';
               put "''Page % ''";
               put '"' CR;
           finish:
               put '.ps' CR;
               put '.vs' CR;
               put '\fP' CR;
               put '.ad' CR;
        end;

        define event stylesheet_link;
            put ".so " URL CR;
        end;

        define event shortstyles;
            trigger bodystyle;
            trigger titlestyle;
            trigger proctitlestyle;
            trigger bylinestyle;
        end;

        define event titlestylesheetclass;
            put ".B" CR /if cmp(FONT_WEIGHT, "bold");
            put ".I" CR /if cmp(FONT_STYLE, "italic");
            put ".ad \\$1" CR;
            put "\\$2" CR;
            put ".ad" CR;
            put ".R" CR;
            put ".ps" CR;
            put ".vs" CR;
        end;

        define event bodystyle;
            style="body";
            put ".de BS" CR;
            put ".ps 9" CR;
            put ".vs 11" CR;
            put ".B" CR /if cmp(FONT_WEIGHT, "bold");
            put ".I" CR /if cmp(FONT_STYLE, "italic");
            put ".ad \\$1" CR;
            put ".." CR;
        end;

        define event titlestyle;
            style = "systemtitle";
            put ".de ST" CR;
            put ".ps 15" CR;
            put ".vs 17" CR;
            trigger titlestylesheetclass;
            put ".sp 1n" CR;
            put ".." CR;
        end;

        define event proctitlestyle;
            style = "proctitle";
            put ".de PT" CR;
            put ".ps 12" CR;
            put ".vs 14" CR;
            trigger titlestylesheetclass;
            put ".sp 1n" CR;
            put ".." CR;
        end;

        define event bylinestyle;
            style = "byline";
            put ".de BY" CR;
            put ".ps 12" CR;
            put ".vs 14" CR;
            trigger titlestylesheetclass;
            put ".sp 1n" CR;
            put ".." CR;
        end;

        define event verbatim;
            start:
                put '.nf' CR;
            finish:
                put '.fi' CR;
        end;

        define event block_just;
            start:
                put '.ad ';
                put just CR /if !cmp(just, 'd');
                put 'r' CR /if cmp(just, 'd');
            finish:
                put '.ad' CR;
        end;


        define event alt_systitle;
            put '.PH "';
            put "'";
            put VALUE / if cmp('l', just);
            put "''";
            put VALUE / if cmp('c', just);
            put "''";
            put VALUE / if cmp('r', just);
            put "'" CR;
        end;

        define event system_title;
            put ".ST ";
            put JUST ' "' VALUE '"' CR;
        end;

        define event system_footer;
            put ".ST ";
            put JUST ' "' VALUE '"' CR;
        end;

        define event proc_title;
            put ".PT ";
            put JUST ' "' VALUE '"' CR;
        end;

        define event byline;
            put ".BY ";
            put JUST ' "' VALUE '"' CR;
        end;

        define event msg;
            start:
                trigger block_just;
                /*put ".B1" CR;*/
                put ".B" CR;
                put ".VL 10" CR;
            finish:
                put ".R" CR;
                put VALUE CR;
                put ".LE" CR;
                put ".sp 1n" CR;
                /*put ".B2" CR;*/
                trigger block_just;
        end;

        define event note;
            trigger msg start;
            put ".LI Note:" CR;
            trigger msg finish;
        end;

        define event warning;
            trigger msg start;
            put ".LI Warning:" CR;
            trigger msg finish;
        end;

        define event error;
            trigger msg start;
            put ".LI Error:" CR;
            trigger msg finish;
        end;


        define event fatal;
            trigger msg start;
            put ".LI Fatal:" CR;
            trigger msg finish;
        end;

        define event table;
            start:
                put ".TS H" CR;
                put "allbox";
                put " center" / if cmp(just, "c");
                put " expand" / if cmp(width, "100%");
                put " doublebox" / if cmp(frame, "box");
                put " tab(@);" CR;
            finish:
                put ".TE" CR;
                put ".sp" CR;
        end;

        define event colspecs;
            finish:
                put "." CR;
        end;

        define event colspecsep;
            put ' ';
        end;

        define event colspec_entry;
            put just / if !cmp(just, 'd');
            put 'n' / if cmp(just, 'd');
        end;

        define event cellspec;
            put just / if !cmp(just, 'd');
            put 'n' / if cmp(just, 'd');
            put 'B' ;  /* cellspecs will only come out for heading rows... */
        end;

        define event cellspecspan;
             put " s";
        end;

        define event cellspecsep;
             put " ";
        end;

        define event rowspec;
            finish:
                put CR;
        end;


        define event row;
            finish:
                put CR;
        end;

        define event rowspanfillsep;
            put ' @ ' CR;
        end;

        define event rowspanfill;
            put '^';
        end;

        define event table_head;
            finish:
                put "_" CR;
        end;

        define event table_body;
            start:
                put ".TH" CR;
        end;

        define event header;
            start:
               trigger data;
            finish:
               trigger data;
        end;

        define event data;
            start:

                put ' @ ' / if !cmp(COLSTART, '1') ;
                put VALUE;
        end;

        define event pagebreak;
            put '.bp' CR;
        end;

    end;


    /*******************************************************/
    /*******************************************************/
    /*******************************************************/
    /*  GRAPH -- XML output to render graphs in HTML, etc. */
    /*******************************************************/
    /*******************************************************/
    /*******************************************************/

   %macro tagsets_graph;

    %if  %substr(&sysver,1,1) = 8 %then %do;
       /* not in version 8 */
       %end;

    %else %do;

    define tagset tagsets.graph;
        notes "This is the Graph XML definition";

        %let  map =<>%nrstr(&)%str(%')%str(%");
        map="&map";
        mapsub = '/&lt;/&gt;/&amp;/&#39;/&quot;/';
        nobreakspace = ' ';
        split = '<br/>';
        output_type = 'xml';
        indent=2;

        define event GraphData;
          start:
            ndent;
            put "<Data";
            putq " Server=" @Server;
            putq " ID=" ref_id;
            putq " URL=" url;
            putq " Type=" type;
            put ">" CR;
          finish:
            put "</Data>" CR;
            xdent;
        end;



        define event VariableList;
          start:
            ndent;
            put "<VariableList>" CR;
          finish:
            put "</VariableList>" CR;
            xdent;
        end;



        define event Variable;
          start:
            ndent;
            put "<Variable";
            putq " SASFormat=" @Format;
            putq " Encoding=" @Encoding;
            putq " ID=" ref_id;
            putq " Name=" name;
            putq " Label=" label;
            putq " Type=" type;
            put "/>" CR;
            xdent;
        end;



        define event EmbeddedData;
          start:
            ndent;
            put "<EmbeddedData>" CR;
          finish:
            put "</EmbeddedData>" CR;
            xdent;
        end;



        define event ChartDataList;
          start:
            ndent;
            put "<ChartDataList>" CR;
          finish:
            put "</ChartDataList>" CR;
            xdent;
        end;



        define event ChartData;
          start:
            ndent;
            put "<ChartData";
            putq " ID=" ref_id;
            putq " DataID=" @DataID;
            put ">" CR;
          finish:
            put "</ChartData>" CR;
            xdent;
        end;



        define event RoleList;
          start:
            ndent;
            put "<RoleList>" CR;
          finish:
            put "</RoleList>" CR;
            xdent;
        end;



        define event Role;
          start:
            ndent;
            put "<Role";
            putq " VariableID=" @VariableID;
            putq " Type=" type;
            putq " Statistic=" @Statistic;
            putq " OtherEnabled=" @OtherEnabled;
            putq " OtherType=" @OtherType;
            putq " OtherValue=" @OtherValue;
            putq " OtherLabel=" @otherlabel;
            putq " SortOrder=" @SortOrder;
            putq " MissingEnabled=" @MissingEnabled;
            put ">" CR;
          finish:
            put "</Role>" CR;
            xdent;
        end;



        define event Categorization;
          start:
            ndent;
            put "<Categorization";
            putq " Type=" type;
            putq " NumberOfLevels=" @NumberOfLevels;
            putq " RangeFormat=" @RangeFormat;
            put ">" CR;
          finish:
            put "</Categorization>" CR;
            xdent;
        end;



        define event RangeList;
          start:
            ndent;
            put "<RangeList>" CR;
          finish:
            put "</RangeList>" CR;
            xdent;
        end;



        define event range;
          start:
            ndent;
            put "<Range";
            putq " Value=" value;
            putq " Low=" @Low;
            putq " High=" @High;
            put ">" CR;
          finish:
            put "</Range>" CR;
            xdent;
        end;

        define event Document;
          start:
            put "<Document>" CR;
          finish:
            put "</Document>" CR;
        end;



        define event DataList;
          start:
            ndent;
            put "<DataList>" CR;
          finish:
            put "</DataList>" CR;
            xdent;
        end;



        define event form;
          start:
            ndent;
            put "<Form";
            putq " StyleSchemeID=" @StyleSchemeID;
            put ">" CR;
          finish:
            put "</Form>" CR;
            xdent;
        end;

/***********************************************************************/
/*                   Graph appearance scheme events.                   */
/***********************************************************************/

        define event GraphLineStyles;
             break / if !exist($linestyle);
             put ' LineStyle="Solid"' / if cmp($linestyle, "1");
             put ' LineStyle="Dash1"' / if cmp($linestyle, "2");
             put ' LineStyle="Dash2"' / if cmp($linestyle, "3");
             put ' LineStyle="Dash3"' / if cmp($linestyle, "4");
             put ' LineStyle="Dash4"' / if cmp($linestyle, "5");
             put ' LineStyle="Dash5"' / if cmp($linestyle, "6");
             put ' LineStyle="Dash6"' / if cmp($linestyle, "7");
             put ' LineStyle="Dash3Dash1"' / if cmp($linestyle, "8");
             put ' LineStyle="Dash4Dash1"' / if cmp($linestyle, "9");
             put ' LineStyle="Dash5Dash1"' / if cmp($linestyle, "10");
             put ' LineStyle="Dash6Dash1"' / if cmp($linestyle, "11");
             put ' LineStyle="Dash5Dash3"' / if cmp($linestyle, "12");
             put ' LineStyle="Dash6Dash3"' / if cmp($linestyle, "13");
             put ' LineStyle="Dash3Dash1Dash1"' / if cmp($linestyle, "14");
             put ' LineStyle="Dash4Dash1Dash1"' / if cmp($linestyle, "15");
             put ' LineStyle="Dash5Dash1Dash1"' / if cmp($linestyle, "16");
             put ' LineStyle="Dash6Dash1Dash1"' / if cmp($linestyle, "17");
             put ' LineStyle="Dash5Dash3Dash3"' / if cmp($linestyle, "18");
             put ' LineStyle="Dash6Dash3Dash3"' / if cmp($linestyle, "19");
             put ' LineStyle="Dash2Space"' / if cmp($linestyle, "20");
             put ' LineStyle="Dash3Space"' / if cmp($linestyle, "21");
             put ' LineStyle="Dash4Space"' / if cmp($linestyle, "22");
             put ' LineStyle="Dash5Space"' / if cmp($linestyle, "23");
             put ' LineStyle="Dash6Space"' / if cmp($linestyle, "24");
             put ' LineStyle="Dash3Dash2"' / if cmp($linestyle, "25");
             put ' LineStyle="Dash4Dash2"' / if cmp($linestyle, "26");
             put ' LineStyle="Dash5Dash2"' / if cmp($linestyle, "27");
             put ' LineStyle="Dash6Dash2"' / if cmp($linestyle, "28");
             put ' LineStyle="Dash3Dash2Dash2"' / if cmp($linestyle, "29");
             put ' LineStyle="Dash4Dash2Dash2"' / if cmp($linestyle, "30");
             put ' LineStyle="Dash5Dash2Dash2"' / if cmp($linestyle, "31");
             put ' LineStyle="Dash6Dash2Dash2"' / if cmp($linestyle, "32");
             put ' LineStyle="Dot1"' / if cmp($linestyle, "33");
             put ' LineStyle="Dot1Space"' / if cmp($linestyle, "34");
             put ' LineStyle="Dot1Space2"' / if cmp($linestyle, "35");
             put ' LineStyle="Dot2"' / if cmp($linestyle, "36");
             put ' LineStyle="Dot3"' / if cmp($linestyle, "37");
             put ' LineStyle="Dot2Dot1"' / if cmp($linestyle, "38");
             put ' LineStyle="Dot3Dot1"' / if cmp($linestyle, "39");
             put ' LineStyle="Dot3Dot2"' / if cmp($linestyle, "40");
             put ' LineStyle="Dash3Dot1"' / if cmp($linestyle, "41");
             put ' LineStyle="Dash3Dot2"' / if cmp($linestyle, "42");
             put ' LineStyle="Dash3Dot3"' / if cmp($linestyle, "43");
             put ' LineStyle="Dash3Dot2Dash3Dot1"' / if cmp($linestyle, "44");
             put ' LineStyle="Dash3Dot3Dash3Dot1"' / if cmp($linestyle, "45");
             put ' LineStyle="Dash3Dot3Dash3Dot2"' / if cmp($linestyle, "46");
             unset $linestyle;
          end;


        define event chart_transparency;
          style="GraphCharts";
          pure_style=1;
          putq " ChartTransparency=" TRANSPARENCY;
        end;

        define event wall_transparency;
          style="GraphWalls";
          pure_style=1;
          putq " WallTransparency=" TRANSPARENCY;
        end;

        define event legend_transparency;
          style="GraphLegendBackground";
          pure_style=1;
          putq " LegendTransparency=" TRANSPARENCY;
        end;

        define event graphscheme;
          start:
            ndent;
            put "<Graph";
            putq " NumDataAppearances=" @NumDataAppearances;
            trigger chart_transparency;
            trigger wall_transparency;
            trigger legend_transparency;
            put ">" CR;
          finish:
            put "</Graph>" CR;
            xdent;
        end;


        define event AxisLineScheme;
          start:
            style="GraphAxisLines";
            pure_style=1;
            ndent;
            break / if !any(FOREGROUND, @LINESTYLE, OUTPUTWIDTH);
            put "<AxisLines";
            putq " LineColor=" FOREGROUND;
            set $linestyle LINESTYLE / if exists(LINESTYLE);
            trigger GraphLineStyles / if exists(LINESTYLE);
            putq " LineThickness=" OUTPUTWIDTH;
            put "/>" CR;
          finish:
            xdent;
        end;

        define event GridLineScheme;
          start:
            style="GraphGridLines";
            pure_style=1;
            ndent;
            break / if !any(FOREGROUND, LINESTYLE, OUTPUTWIDTH);
            put "<GridLines";
            putq " LineColor=" FOREGROUND;
            set $linestyle LINESTYLE / if exists(LINESTYLE);
            trigger GraphLineStyles / if exists(LINESTYLE);
            putq " LineThickness=" OUTPUTWIDTH;
            put "/>" CR;
          finish:
            xdent;
        end;

        define event OutlineScheme;
          start:
            style="GraphOutlines";
            pure_style=1;
            ndent;
            break / if !any(FOREGROUND, LINESTYLE, OUTPUTWIDTH);
            put "<Outlines";
            putq " LineColor=" FOREGROUND;
            set $linestyle LINESTYLE / if exists(LINESTYLE);
            trigger GraphLineStyles / if exists(LINESTYLE);
            putq " LineThickness=" OUTPUTWIDTH;
            put "/>" CR;
          finish:
            xdent;
        end;

        define event BorderLineScheme;
          start:
            style="GraphBorderLines";
            pure_style=1;
            ndent;
            break / if !any(FOREGROUND, LINESTYLE, OUTPUTWIDTH);
            put "<BorderLines";
            putq " LineColor=" FOREGROUND;
            set $linestyle LINESTYLE / if exists(LINESTYLE);
            trigger GraphLineStyles / if exists(LINESTYLE);
            putq " LineThickness=" OUTPUTWIDTH;
            put "/>" CR;
          finish:
            xdent;
        end;

        define event TitleTextScheme;
          start:
            style="GraphLabelText";
            pure_style=1;
            ndent;
            break / if !any(DROPSHADOW, @TextColor, FOREGROUND, @TextSize, FONT_SIZE, @TextFont, FONT_FACE, @TextFlags, FONT_STYLE, FONT_WEIGHT);
            put "<TitleText";
            put  ' TextDropShadowEnabled = "true"' / if exists(DROPSHADOW);
            putq " TextColor=" @TextColor;
            putq " TextColor=" FOREGROUND / if !exists(@TextColor);
            putq " TextSize=" @TextSize;
            putq " TextSize=" FONT_SIZE / if !exists(@TextSize);
            putq " TextFont=" @TextFont;
            putq " TextFont=" FONT_FACE / if !exists(@TextFont);
            putq " TextFlags=" @TextFlags;
            put "/>" CR / if exists(@TextFlags);
            break / if exists(@TextFlags);
            put  ' TextFlags="' / if any( FONT_STYLE, FONT_WEIGHT);
            put    FONT_STYLE;
            put  '|' FONT_WEIGHT;
            put  '"' / if any( FONT_STYLE, FONT_WEIGHT);
            put "/>" CR;
          finish:
            xdent;
        end;

        define event LabelTextScheme;
          start:
            style="GraphLabelText";
            pure_style=1;
            ndent;
            break / if !any(DROPSHADOW, @TextColor, FOREGROUND, @TextSize, FONT_SIZE, @TextFont, FONT_FACE, @TextFlags, FONT_STYLE, FONT_WEIGHT);
            put "<LabelText";
            put  ' TextDropShadowEnabled = "true"' / if exists(DROPSHADOW);
            putq " TextColor=" @TextColor;
            putq " TextColor=" FOREGROUND / if !exists(@TextColor);
            putq " TextSize=" @TextSize;
            putq " TextSize=" FONT_SIZE / if !exists(@TextSize);
            putq " TextFont=" @TextFont;
            putq " TextFont=" FONT_FACE / if !exists(@TextFont);
            putq " TextFlags=" @TextFlags;
            put "/>" CR / if exists(@TextFlags);
            break / if exists(@TextFlags);
            put  ' TextFlags="' / if any( FONT_STYLE, FONT_WEIGHT);
            put    FONT_STYLE;
            put  '|' FONT_WEIGHT;
            put  '"' / if any( FONT_STYLE, FONT_WEIGHT);
            put "/>" CR;
          finish:
            xdent;
        end;

        define event ValueTextScheme;
          start:
            style="GraphValueText";
            pure_style=1;
            ndent;
            break / if !any(DROPSHADOW, @TextColor, FOREGROUND, @TextSize, FONT_SIZE, @TextFont, FONT_FACE, @TextFlags, FONT_STYLE, FONT_WEIGHT);
            put "<ValueText";
            put  ' TextDropShadowEnabled = "true"' / if exists(DROPSHADOW);
            putq " TextColor=" @TextColor;
            putq " TextColor=" FOREGROUND / if !exists(@TextColor);
            putq " TextSize=" @TextSize;
            putq " TextSize=" FONT_SIZE / if !exists(@TextSize);
            putq " TextFont=" @TextFont;
            putq " TextFont=" FONT_FACE / if !exists(@TextFont);
            putq " TextFlags=" @TextFlags;
            put  "/>" CR / if exists(@TextFlags);
            break / if exists(@TextFlags);
            put  ' TextFlags="' / if any( FONT_STYLE, FONT_WEIGHT);
            put    FONT_STYLE;
            put  '|' FONT_WEIGHT;
            put  '"' / if any( FONT_STYLE, FONT_WEIGHT);
            put "/>" CR;
          finish:
            xdent;
        end;


        define event BackgroundImagePosition;
          start:
            style="GraphBackground";
            pure_style=1;
            break / if !any(JUST,VJUST);
            put ' FillImageFitStyle="';
            set $output "0";
            put 'Top' / when cmp("t", VJUST);
            set $output "1" / when cmp("t", VJUST);
            put 'Bottom' / when cmp("b", VJUST);
            set $output "1" / when cmp("b", VJUST);
            put 'Right' / when cmp("r", JUST);
            set $output "1" / when cmp("r", JUST);
            put 'Left' / when cmp("l", JUST);
            set $output "1" / when cmp("l", JUST);
            put '"' / when cmp("1", $output);
            break / when cmp("1", $output);
            put 'Center' / when cmp("c", JUST);
            put '"' / when cmp("c", JUST);
            break / when cmp("c", JUST);
            put 'Center' / when cmp("m", VJUST);
            put '"' / when cmp("m", VJUST);
            break / when cmp("m", VJUST);
          finish:
            unset $output;
        end;


        define event BackFillScheme;
          start:
            style="GraphBackground";
            pure_style=1;
            ndent;
            break /  if !any(@FillFile, @FillForeColor, IMAGE, BACKGROUND, BACKGROUNDIMAGE, STARTCOLOR, ENDCOLOR, GRADIENT_DIRECTION);
            put "<BackFill";
            putq " FillFile=" @FillFile;
            putq " FillFile=" IMAGE / if !exists(@FillFile);
            putq " FillFile=" BACKGROUNDIMAGE / if !any(@FillFile, IMAGE);
            putq ' FillImageFitStyle="Fit"' / if exists(BACKGROUNDIMAGE);
            trigger BackgroundImagePosition / if exists(IMAGE);
            putq " FillForeColor=" @FillForeColor;
            putq " FillForeColor=" BACKGROUND / if !exists(@FillForeColor);
            putq " FillGradientStartColor=" STARTCOLOR;
            putq " FillGradientEndColor=" ENDCOLOR;
            putq " FillGradientType=" GRADIENT_DIRECTION;
            put ' FillType="ImageColorBlend"' / if exists(BACKGROUND, IMAGE);
            put  "/>" CR / if exists(BACKGROUND, IMAGE);
            break / if exists(BACKGROUND, IMAGE);
            put ' FillType="ImageColorBlend"' / if exists(BACKGROUND, BACKGROUNDIMAGE);
            put  "/>" CR / if exists(BACKGROUND, BACKGROUNDIMAGE);
            break / if exists(BACKGROUND, BACKGROUNDIMAGE);
            put ' FillType="Image"' / if any(IMAGE, BACKGROUNDIMAGE, @FillFile );
            put "/>" CR / if any(IMAGE, BACKGROUNDIMAGE, @FillFile );
            break / if any(IMAGE, BACKGROUNDIMAGE, @FillFile );
            put ' FillType="Gradient"' / if any(STARTCOLOR, ENDCOLOR, GRADIENT_DIRECTION);
            put "/>" CR / if any(STARTCOLOR, ENDCOLOR, GRADIENT_DIRECTION);
            break / if any(STARTCOLOR, ENDCOLOR, GRADIENT_DIRECTION);
            put ' FillType="Pattern"' / if !any(@FillFile, IMAGE, BACKGROUNDIMAGE);
            put "/>" CR;
          finish:
            xdent;
        end;

        define event WallGradientTransparency;
            style="GraphWalls";
            pure_style=1;
            break / if !exists(TRANSPARENCY);
            break / if !any(STARTCOLOR, ENDCOLOR);
            putq ' FillGradientTransparency="Enabled"' / if exists(STARTCOLOR, ENDCOLOR);
            break / if exists(STARTCOLOR, ENDCOLOR);
            putq ' FillGradientTransparency="StartColorOnly"' / if exists(ENDCOLOR);
            break / if exists(ENDCOLOR);
            putq ' FillGradientTransparency="EndColorOnly"' / if exists(STARTCOLOR);
            break / if exists(STARTCOLOR);
        end;


        define event WallFillScheme;
          start:
            style="GraphWalls";
            pure_style=1;
            ndent;
            break /  if !any(IMAGE, BACKGROUNDIMAGE, BACKGROUND, STARTCOLOR, ENDCOLOR, GRADIENT_DIRECTION);
            put "<WallFill";
            put ' FillType="Gradient"' / if any(STARTCOLOR, ENDCOLOR, GRADIENT_DIRECTION);
            putq " FillFile=" IMAGE;
            putq " FillFile=" BACKGROUNDIMAGE / if !exists(IMAGE);
            putq ' FillImageFitStyle="Fit"' / if exists(BACKGROUNDIMAGE);
            putq " FillForeColor=" BACKGROUND;
            putq " FillGradientStartColor=" STARTCOLOR;
            putq " FillGradientEndColor=" ENDCOLOR;
            putq " FillGradientType=" GRADIENT_DIRECTION;
            trigger WallGradientTransparency / if any(TRANSPARENCY, STARTCOLOR, ENDCOLOR);
            put ' FillType="ImageColorBlend"' / if exists(BACKGROUND, IMAGE);
            put  "/>" CR / if exists(BACKGROUND, IMAGE);
            break / if exists(BACKGROUND, IMAGE);
            put ' FillType="ImageColorBlend"' / if exists(BACKGROUND, BACKGROUNDIMAGE);
            put  "/>" CR / if exists(BACKGROUND, BACKGROUNDIMAGE);
            break / if exists(BACKGROUND, BACKGROUNDIMAGE);
            put ' FillType="Image"' / if any(IMAGE, BACKGROUNDIMAGE, @FillFile );
            put "/>" CR / if any(IMAGE, BACKGROUNDIMAGE, @FillFile );
            break / if any(IMAGE, BACKGROUNDIMAGE, @FillFile );
            put ' FillType="Gradient"' / if any(STARTCOLOR, ENDCOLOR, GRADIENT_DIRECTION);
            put "/>" CR / if any(STARTCOLOR, ENDCOLOR, GRADIENT_DIRECTION);
            break / if any(STARTCOLOR, ENDCOLOR, GRADIENT_DIRECTION);
            put ' FillType="Pattern"' / if !any(@FillFile, IMAGE, BACKGROUNDIMAGE);
            put "/>" CR;
          finish:
            xdent;
        end;


        define event FloorFillScheme;
          start:
            style="GraphFloor";
            pure_style=1;
            ndent;
            break /  if !any(IMAGE, BACKGROUNDIMAGE, BACKGROUND, STARTCOLOR, ENDCOLOR, GRADIENT_DIRECTION);
            put "<FloorFill";
            put ' FillType="Gradient"' / if any(STARTCOLOR, ENDCOLOR, GRADIENT_DIRECTION);
            putq " FillFile=" IMAGE;
            putq " FillFile=" BACKGROUNDIMAGE / if !exists(IMAGE);
            putq ' FillImageFitStyle="Fit"' / if exists(BACKGROUNDIMAGE);
            putq " FillForeColor=" BACKGROUND;
            putq " FillGradientStartColor=" STARTCOLOR;
            putq " FillGradientEndColor=" ENDCOLOR;
            putq " FillGradientType=" GRADIENT_DIRECTION;
            put ' FillType="ImageColorBlend"' / if exists(BACKGROUND, IMAGE);
            put  "/>" CR / if exists(BACKGROUND, IMAGE);
            break / if exists(BACKGROUND, IMAGE);
            put ' FillType="ImageColorBlend"' / if exists(BACKGROUND, BACKGROUNDIMAGE);
            put  "/>" CR / if exists(BACKGROUND, BACKGROUNDIMAGE);
            break / if exists(BACKGROUND, BACKGROUNDIMAGE);
            put ' FillType="Image"' / if any(IMAGE, BACKGROUNDIMAGE, @FillFile );
            put "/>" CR / if any(IMAGE, BACKGROUNDIMAGE, @FillFile );
            break / if any(IMAGE, BACKGROUNDIMAGE, @FillFile );
            put ' FillType="Gradient"' / if any(STARTCOLOR, ENDCOLOR, GRADIENT_DIRECTION);
            put "/>" CR / if any(STARTCOLOR, ENDCOLOR, GRADIENT_DIRECTION);
            break / if any(STARTCOLOR, ENDCOLOR, GRADIENT_DIRECTION);
            put ' FillType="Pattern"' / if !any(@FillFile, IMAGE, BACKGROUNDIMAGE);
            put "/>" CR;
          finish:
            xdent;
        end;

        define event LegendFillScheme;
          start:
            style="GraphLegendBackground";
            pure_style=1;
            ndent;
            break / if !any(IMAGE, BACKGROUND, BACKGROUNDIMAGE);
            put "<LegendFill";
            putq " FillFile=" IMAGE;
            putq " FillFile=" BACKGROUNDIMAGE / if !exists(IMAGE);
            putq ' FillImageFitStyle="Fit"' / if exists(BACKGROUNDIMAGE);
            putq " FillForeColor=" BACKGROUND;
            put ' FillType="ImageColorBlend"' / if exists(BACKGROUND, IMAGE);
            put  "/>" CR / if exists(BACKGROUND, IMAGE);
            break / if exists(BACKGROUND, IMAGE);
            put ' FillType="ImageColorBlend"' / if exists(BACKGROUND, BACKGROUNDIMAGE);
            put  "/>" CR / if exists(BACKGROUND, BACKGROUNDIMAGE);
            break / if exists(BACKGROUND, BACKGROUNDIMAGE);
            put ' FillType="Image"' / if any(IMAGE, BACKGROUNDIMAGE, @FillFile );
            put "/>" CR / if any(IMAGE, BACKGROUNDIMAGE, @FillFile );
            break / if any(IMAGE, BACKGROUNDIMAGE, @FillFile );
            put ' FillType="Gradient"' / if any(STARTCOLOR, ENDCOLOR, GRADIENT_DIRECTION);
            put "/>" CR / if any(STARTCOLOR, ENDCOLOR, GRADIENT_DIRECTION);
            break / if any(STARTCOLOR, ENDCOLOR, GRADIENT_DIRECTION);
            put ' FillType="Pattern"' / if !any(@FillFile, IMAGE, BACKGROUNDIMAGE);
            put "/>" CR;
          finish:
            xdent;
        end;


        define event DropShadowScheme;
          start:
            style="DropShadowStyle";
            pure_style=1;
            ndent;
            break /  if !any (FOREGROUND, TRANSPARENCY);
            put "<DropShadow";
            putq " ShadowColor=" FOREGROUND;
            putq " Transparency=" TRANSPARENCY;
            put  ' Xoffset="5 %"'/if any (FOREGROUND, TRANSPARENCY);
            put  ' Yoffset="5 %"'/if any (FOREGROUND, TRANSPARENCY);
            put "/>" CR;
          finish:
            xdent;
        end;

/***********************************************************************/
/*          The end of the graph appearance scheme events.             */
/***********************************************************************/














        define event graph;
          start:
            ndent;
            put "<Graph";
            putq " ID=" @graphid;
            putq " Height=" @Height;
            putq " Width=" @Width;
            putq " ChartTips=" @ChartTips;
            putq " View2D=" @View2D;
            putq " G3DTilt=" @G3DTilt;
            putq " G3DRotate=" @G3DRotate;
            putq " ChartBorder=" @ChartBorder;
            putq " DrillDownEnabled=" @DrillDownEnabled;
            putq " DrillDownMode=" @DrillDownMode;
            putq " RotationX=" @RotateX;
            putq " RotationY=" @RotateY;
            putq " RotationZ=" @RotateZ;
            put ">" CR;
          finish:
            put "</Graph>" CR;
            xdent;
        end;

        define event ChartAreaList;
          start:
            ndent;
            put "<ChartAreaList>" CR;
          finish:
            put "</ChartAreaList>" CR;
            xdent;
        end;


        define event ChartArea;
          start:
            ndent;
            put "<ChartArea";
            putq " Orientation=" @Orientation;
            put ">" CR;
          finish:
            put "</ChartArea>" CR;
            xdent;
        end;



        define event WallList;
          start:
            ndent;
            put "<WallList>" CR;
          finish:
            put "</WallList>" CR;
            xdent;
        end;



        define event Wall;
          start:
            style="GraphWalls";
            pure_style=1;
            ndent;
            put "<Wall";
            putq " ID=" ref_id;
            putq " WallVisible=" @WallVisible / if !any(BACKGROUND, IMAGE, STARTCOLOR, ENDCOLOR);
            putq ' Transparent="true"' / if exists(TRANSPARENCY);
            put ">" CR;
          finish:
            put "</Wall>" CR;
            xdent;
        end;



        define event Background;
          start:
            ndent;
            put "<Background";
            putq " FillBackColor=" @FillBackColor;
            putq " FillVisible=" @FillVisible;
            putq " FillFile=" @FillFile;
            putq " FillType=" @FillType;
            putq " FillForeColor=" @FillForeColor;
            put "/>" NL;
            xdent;
        end;


        define event ChartList;
          start:
            ndent;
            put "<ChartList";
            putq " ReverseOrder=" @ReverseOrder;
            put ">" CR;
          finish:
            put "</ChartList>" CR;
            xdent;
        end;



        define event AxisList;
          start:
            ndent;
            put "<AxisList>" CR;
          finish:
            put "</AxisList>" CR;
            xdent;
        end;



        define event Axis;
          start:
            ndent;
            put "<Axis";
            putq " ID=" ref_id;
            putq " Role=" @Role;
            putq " Visible=" @Visible;
            putq " AxisPosition=" @AxisPosition;
            putq " AxisScale=" @AxisScale;
            putq " LogarithmicBase=" @LogarithmicBase;
            putq " LogarithmicPowerVisible=" @LogarithmicPowerVisible;
            putq " TicksBeginAtZero=" @TicksBeginAtZero;
            putq " Minimum=" @Minimum;
            putq " Maximum=" @Maximum;
            putq " MajorTickCount=" @MajorTickCount;
            putq " MinorTickCount=" @MinorTickCount;
            putq " StartOffset=" @StartOffset;
            putq " EndOffset=" @EndOffset;
            putq " ReverseAxis=" @ReverseAxis;
            putq " GridPosition=" @GridPosition;
            putq " BaseLineValue=" @BaseLineValue;
            putq " BracketGroupValues=" @BracketGroupValues;
            putq " GroupSpacing=" @GroupSpacing;
            put ">" CR;
          finish:
            put "</Axis>" CR;
            xdent;
        end;



        define event Grid;
          start:
            ndent;
            put "<Grid";
            putq " LineVisible=" @LineVisible;
            putq " LineStyle=" @LineStyle;
            putq " LineColor=" @LineColor;
            put "/>" NL;
            xdent;
        end;



        define event AxisReferenceList;
          start:
            ndent;
            put "<AxisReferenceList>" CR;
          finish:
            put "</AxisReferenceList>" CR;
            xdent;
        end;



        define event AxisReference;
          start:
            ndent;
            put "<AxisReference";
            putq " DataValue=" @DataValue;
            putq " Position=" @Position;
            put ">" CR;
          finish:
            put "</AxisReference>" CR;
            xdent;
        end;



        define event MajorTick;
          start:
            ndent;
            put "<MajorTick";
            putq " LineVisible=" @LineVisible;
            putq " LineColor=" @LineColor;
            putq " LineThickness=" @LineThickness;
            put "/>" NL;
            xdent;
        end;



        define event MinorTick;
          start:
            ndent;
            put "<MinorTick";
            putq " LineVisible=" @LineVisible;
            putq " LineColor=" @LineColor;
            putq " LineThickness=" @LineThickness;
            put "/>" NL;
            xdent;
        end;


        define event Label;
          start:
            ndent;
            put "<Label";
            putq " Index=" @Index;
            putq " TextVisible=" @TextVisible;
            putq " TextColor=" @TextColor;
            putq " TextSize=" @TextSize;
            putq " TextValue=" @TextValue;
            putq " TextBaselineAngle=" @TextBaselineAngle;
            putq " TextCharacterAngle=" @TextCharacterAngle;
            putq " TextHorizontalAlignment=" @TextHorizontalAlignment;
            putq " TextFont=" @TextFont;
            putq " TextFlags=" @TextFlags;
            put "/>" CR;
          finish:
            xdent;
        end;



        define event Labels;
          start:
            ndent;
            put "<Labels";
            putq " TextVisible=" @TextVisible;
            putq " TextColor=" @TextColor;
            putq " TextSize=" @TextSize;
            putq " TextValue=" @TextValue;
            putq " TextBaselineAngle=" @TextBaselineAngle;
            putq " TextCharacterAngle=" @TextCharacterAngle;
            putq " TextHorizontalAlignment=" @TextHorizontalAlignment;
            putq " TextFont=" @TextFont;
            putq " TextFlags=" @TextFlags;
            put "/>" CR;
            xdent;
        end;



        define event GroupLabel;
          start:
            ndent;
            put "<GroupLabel";
            putq " TextColor=" @TextColor;
            putq " TextVisible=" @TextVisible;
            putq " TextSize=" @TextSize;
            putq " TextValue=" @TextValue;
            putq " TextBaselineAngle=" @TextBaselineAngle;
            putq " TextCharacterAngle=" @TextCharacterAngle;
            putq " TextHorizontalAlignment=" @TextHorizontalAlignment;
            putq " TextFont=" @TextFont;
            putq " TextFlags=" @TextFlags;
            put "/>" CR;
            xdent;
        end;



        define event Values;
          start:
            ndent;
            put "<Values";
            putq " TextVisible=" @TextVisible;
            putq " TextColor=" @TextColor;
            putq " TextSize=" @TextSize;
            putq " TextValue=" @TextValue;
            putq " TextBaselineAngle=" @TextBaselineAngle;
            putq " TextCharacterAngle=" @TextCharacterAngle;
            putq " TextHorizontalAlignment=" @TextHorizontalAlignment;
            putq " TextFont=" @TextFont;
            putq " TextFlags=" @TextFlags;
            put "/>" CR;
            xdent;
        end;



        define event GroupValues;
          start:
            ndent;
            put "<GroupValues";
            putq " TextVisible=" @TextVisible;
            putq " TextColor=" @TextColor;
            putq " TextSize=" @TextSize;
            putq " TextValue=" @TextValue;
            putq " TextBaselineAngle=" @TextBaselineAngle;
            putq " TextCharacterAngle=" @TextCharacterAngle;
            putq " TextHorizontalAlignment=" @TextHorizontalAlignment;
            putq " TextFont=" @TextFont;
            putq " TextFlags=" @TextFlags;
            put "/>" CR;
            xdent;
        end;



        define event GroupValue;
          start:
            ndent;
            put "<GroupValue";
            putq " Index=" @Index;
            putq " TextColor=" @TextColor;
            putq " TextSize=" @TextSize;
            putq " TextBaselineAngle=" @TextBaselineAngle;
            putq " TextBaselineAngle=" @TextBaselineAngle;
            putq " TextCharacterAngle=" @TextCharacterAngle;
            putq " TextCharacterAngle=" @TextCharacterAngle;
            putq " TextHorizontalAlignment=" @TextHorizontalAlignment;
            putq " TextValue=" @TextValue;
            put "/>" CR;
            xdent;
        end;



        define event Value;
          start:
            ndent;
            put "<Value";
            putq " Index=" @Index;
            putq " Value=" value;
            putq " Missing=" missing;
            putq " TextColor=" @TextColor;
            putq " TextSize=" @TextSize;
            putq " TextBaselineAngle=" @TextBaselineAngle;
            putq " TextCharacterAngle=" @TextCharacterAngle;
            putq " TextHorizontalAlignment=" @TextHorizontalAlignment;
            putq " TextValue=" @TextValue;
            put ">" CR;
          finish:
            put "</Value>" CR;
            xdent;
        end;

        define event DataValue;
          start:
            ndent;
            put "<Value";
            putq " Missing=" missing;
            putq " Empty=" @Empty;
            put ">";
            put value;
          finish:
            put "</Value>" CR;
            xdent;
        end;

        define event LabelList;
          start:
            ndent;
            put "<LabelList";
            putq " TextFont=" @TextFont;
            putq " TextFlags=" @TextFlags;
            putq " TextColor=" @TextColor;
            putq " TextVisible=" @TextVisible;
            putq " TextValue=" @TextValue;
            putq " TextBaselineAngle=" @TextBaselineAngle;
            putq " TextCharacterAngle=" @TextCharacterAngle;
            putq " TextHorizontalAlignment=" @TextHorizontalAlignment;
            putq " TextSize=" @TextSize;
            put ">" CR;
          finish:
            put "</LabelList>" CR;
            xdent;
        end;

        define event ChartAssociationList;
          start:
            ndent;
            put "<ChartAssociationList>" CR;
          finish:
            put "</ChartAssociationList>" CR;
            xdent;
        end;

        define event EntryList;
          start:
            ndent;
            put "<EntryList>" CR;
          finish:
            put "</EntryList>" CR;
            xdent;
        end;

        define event LegendEntry;
          start:
            ndent;
            put "<Entry";
            putq " Index=" @entryindex;
            put ">" CR;
          finish:
            put "</Entry>" CR;
            xdent;
        end;

        define event GraphText;
            ndent;
            put "<Text";
            putq " TextColor=" @TextColor;
            putq " TextSize=" @TextSize;
            putq " TextVisible=" @TextVisible;
            putq " TextValue=" @TextValue;
            putq " TextFont=" @TextFont;
            putq " TextFlags=" @TextFlags;
            put "/>" CR;
            xdent;
        end;


        define event LegendList;
          start:
            ndent;
            put "<LegendList>" CR;
          finish:
            put "</LegendList>" CR;
            xdent;
        end;


        define event Legend;
          start:
            style="GraphLegendBackground";
            pure_style=1;
            ndent;
            put "<Legend";
            putq " ChartID=" @ChartID;
            putq " Visible=" @Visible;
            putq " Position=" @Position;
            putq " TitlePosition=" @TitlePosition;
            putq " Outside=" @Outside;
            putq " Border=" @Border;
            putq " Across=" @Across;
            putq " Down=" @Down;
            putq " BorderColor=" @BorderColor;
            putq " BorderShadowColor=" @BorderShadowColor;
            putq ' Transparent="true"' / if exists(TRANSPARENCY);
            putq " TextColor=" @TextColor;
            putq " TextSize=" @TextSize;
            putq " TextValue=" @TextValue;
            putq " TextVisible=" @TextVisible;
            putq " TextBaselineAngle=" @TextBaselineAngle;
            putq " TextCharacterAngle=" @TextCharacterAngle;
            putq " TextHorizontalAlignment=" @TextHorizontalAlignment;
            putq " TextFont=" @TextFont;
            putq " TextFlags=" @TextFlags;
            put ">" CR;
          finish:
            put "</Legend>" CR;
            xdent;
        end;


        define event LegendTitle;
          start:
            break / if !any(@TextFont, @TextFlags, @TextColor, @TextVisible, @TextValue,
                            @TextBaselineAngle, @TextCharacterAngle, @TextHorizontalAlignment, @TextSize);
            ndent;
            put "<Title";
            putq " TextFont=" @TextFont;
            putq " TextFlags=" @TextFlags;
            putq " TextColor=" @TextColor;
            putq " TextVisible=" @TextVisible;
            putq " TextValue=" @TextValue;
            putq " TextBaselineAngle=" @TextBaselineAngle;
            putq " TextCharacterAngle=" @TextCharacterAngle;
            putq " TextHorizontalAlignment=" @TextHorizontalAlignment;
            putq " TextSize=" @TextSize;
            put "/>" NL;
            xdent;
        end;


     /* begin annotation */
     define event AnnotationsList;
      start:
        ndent;
        put "<AnnotationsList>" CR;
      finish:
        put "</AnnotationsList>" CR;
        xdent;
    end;

     define event AnnotationAssociationList;
      start:
        ndent;
        put "<AnnotationAssociationList>" CR;
      finish:
        put "</AnnotationAssociationList>" CR;
        xdent;
    end;

    define event AnnotationAssociation;
      start:
        ndent;
        put "<AnnotationAssociation";
        putq " AnnoID=" @AnnoID;
        putq " ChartID=" @ChartID;
        put "/>" CR;
        xdent;
    end;

    define event AnnotationList;
      start:
        ndent;
        put "<AnnotationList";
        putq " ID=" ref_id;
        put ">" CR;
      finish:
        put "</AnnotationList>" CR;
        xdent;
    end;

     define event AnnotationElement;
      start:
        ndent;
        put  "<" @AnnotationElement;
        putq " ChartArea=" @ChartArea;
        putq " X=" @X;
        putq " Y=" @Y;
        putq " Z=" @Z;
        putq " Xc=" @Xc;
        putq " Yc=" @Yc;
        putq " Group=" @Group;
        putq " Category=" @Category;
        putq " Subgroup=" @Subgroup;
        putq " Xsys=" @Xsys;
        putq " Ysys=" @Ysys;
        putq " Zsys=" @Zsys;
        putq " Hsys=" @Hsys;

        putq " BaselineAngle=" @BaselineAngle;
        putq " StartAngle=" @StartAngle;
        putq " Rotate=" @Rotate;
        putq " Radius=" @Radius;
        putq " RadiusMultiplier=" @RadiusMultiplier;
        putq " MarkerShape=" @MarkerShape;
        putq " MarkerSize=" @MarkerSize;
        putq " Position=" @Position;
        putq " Text=" @Text;
        putq " TextFont=" @TextFont;
        putq " TextFlags=" @TextFlags;
        putq " TextSize=" @TextSize;
        putq " Pattern=" @Pattern;
        putq " Style=" @Style;
        putq " BarLineStyle=" @BarLineStyle;
        putq " PieLineStyle=" @PieLineStyle;
        putq " LineStyle=" @LineStyle;
        putq " LineSize=" @LineSize;
        putq " LineColor=" @LineColor;
        putq " Color=" @Color;
        putq " Cborder=" @Cborder;
        putq " Cbox=" @Cbox;
        putq " ImagePath=" @ImagePath;
        putq " Html=" @Html;
        putq " When=" @When;
        put "/>" CR;

        xdent;
    end;


    define event PolygonList;
      start:
        ndent;
        put "<PolygonList";
        putq " FillColor=" @FillColor;
        putq " Pattern=" @Pattern;
        putq " LineStyle=" @LineStyle;
        putq " LineSize=" @LineSize;
        putq " LineColor=" @LineColor;
        putq " Html=" @Html;
        putq " When=" @When;
        put ">" CR;
      finish:
        put "</PolygonList>" CR;
        xdent;
    end;


    /* end annotation */




        define event StyleList;
          start:
            ndent;
            put "<StyleList>" CR;
          finish:
            put "</StyleList>" CR;
            xdent;
        end;

        define event GraphStyle;
          start:
            ndent;
            put "<Style";
            putq " ID=" ref_id;
            put ">" CR;
          finish:
            put "</Style>" CR;
            xdent;
        end;



        define event Fill;
          start:
            ndent;
            put "<Fill";
            putq " FillVisible=" @FillVisible;
            putq " FillPattern=" @FillPattern;
            putq " FillFile=" @FillFile;
            putq " FillFile=" IMAGE / if !exists(@FillFile);
            putq " FillFile=" BACKGROUNDIMAGE / if !any(@FillFile, IMAGE);
            putq ' FillImageFitStyle="Fit"' / if exists(BACKGROUNDIMAGE);
            putq " FillForeColor=" @FillForeColor;
            putq " FillForeColor=" FOREGROUND / if !exists(@FillForeColor);
            put ' FillType="ImageColorBlend"' / if exists(FOREGROUND, IMAGE);
            put  "/>" CR / if exists(FOREGROUND, IMAGE);
            break / if exists(FOREGROUND, IMAGE);
            put ' FillType="ImageColorBlend"' / if exists(FOREGROUND, BACKGROUNDIMAGE);
            put  "/>" CR / if exists(FOREGROUND, BACKGROUNDIMAGE);
            break / if exists(FOREGROUND, BACKGROUNDIMAGE);
            put ' FillType="Image"' / if any(IMAGE, BACKGROUNDIMAGE, @FillFile);
            put "/>" CR / if any(IMAGE, BACKGROUNDIMAGE, @FillFile );
            break / if any(IMAGE, BACKGROUNDIMAGE, @FillFile );
            put ' FillType="Gradient"' / if any(STARTCOLOR, ENDCOLOR, GRADIENT_DIRECTION);
            put "/>" CR / if any(STARTCOLOR, ENDCOLOR, GRADIENT_DIRECTION);
            break / if any(STARTCOLOR, ENDCOLOR, GRADIENT_DIRECTION);
            put ' FillType="Pattern"' / if !any(@FillFile, IMAGE, BACKGROUNDIMAGE);
            put "/>" CR;

          finish:
            xdent;
        end;



        define event Marker;
          start:
            ndent;
            put "<Marker";
            putq " MarkerVisible=" @MarkerVisible;
            putq " MarkerSymbol=" @MarkerSymbol;
            putq " MarkerColor=" @MarkerColor;
            putq " MarkerColor=" FOREGROUND / if !exists(@MarkerColor);
            putq " MarkerSize=" @MarkerSize;
            put "/>" NL;
            xdent;
        end;



        define event Outline;
          start:
            ndent;
            put "<Outline";
            putq " LineVisible=" @LineVisible;
            putq " LineColor=" @LineColor;
            putq " LineThickness=" @LineThickness;
            put "/>" NL;
            xdent;
        end;



        define event JoinLine;
          start:
            ndent;
            put "<JoinLine";
            putq " LineVisible=" @LineVisible;
            putq " LineColor=" @LineColor;
            putq " LineStyle=" @LineStyle;
            putq " LineThickness=" @LineThickness;
            put "/>" CR;
            xdent;
        end;


        define event EmptyOutline;
          start:
            ndent;
            put "<EmptyOutline";
            putq " LineColor=" @LineColor;
            put "/>" NL;
            xdent;
        end;


        define event ChartBorderLine;
          start:
            ndent;
            put "<ChartBorderLine";
            putq " LineColor=" @LineColor;
            putq " LineStyle=" @LineStyle;
            putq " LineThickness=" @LineThickness;
            putq " LineVisible=" @LineVisible;
            put "/>" NL;
            xdent;
        end;



        define event LineAppearance;
          start:
            ndent;
            put "<Line";
            putq " LineStyle=" @LineStyle;
            putq " LineColor=" @LineColor;
            putq " LineColor=" FOREGROUND / if !exists(@LineColor);
            putq " LineThickness=" @LineThickness;
            putq " LineVisible=" @LineVisible;
            put "/>" NL;
            xdent;
        end;



        define event StyleSchemeList;
          start:
            ndent;
            put "<StyleSchemeList>" CR;
          finish:
            put "</StyleSchemeList>" CR;
            xdent;
        end;



        define event StyleScheme;
          start:
            ndent;
            put "<StyleScheme";
            putq " ID=" ref_id;
            put ">" CR;
          finish:
            put "</StyleScheme>" CR;
            xdent;
        end;

        define event Text;
          start:
            ndent;
            put "<Text";
            putq " TextColor=" @TextColor;
            putq " TextSize=" @TextSize;
            put ">" CR;
          finish:
            put "</Text>" CR;
            xdent;
        end;



        define event DataStyleList;
          start:
            ndent;
            put "<DataStyleList>" CR;
          finish:
            put "</DataStyleList>" CR;
            xdent;
        end;



        define event DataStyle;
          start:
            ndent;
            put "<DataStyle";
            putq " Index=" @Index;
            putq " StyleID=" @StyleID;
            put "/>" CR;
            xdent;
        end;



        define event Interpolation;
          start:
            ndent;
            put "<Interpolation";
            putq " Value=" value;
            putq " Type=" type;
            putq " Needle=" @Needle;
            putq " RegressionType=" @RegressionType;
            putq " Intercept=" @Intercept;
            putq " ConfidenceType=" @ConfidenceType;
            putq " ConfidenceLevel=" @ConfidenceLevel;
            putq " Degree=" @Degree;
            putq " Parametric=" @Parametric;
            putq " Sort=" @Sort;
            putq " Fill=" @Fill;
            putq " Join=" @Join;
            putq " StepPlacement=" @StepPlacement;
            putq " Percentage=" @Percentage;
            put "/>" NL;
            xdent;
        end;



        define event PIE;
          start:
            style="GraphCharts";
            pure_style=1;
            ndent;
            put "<Pie";
            putq " ID=" ref_id;
            putq " ChartDataID=" @ChartDataID;
            putq " StyleBy=" @StyleBy;
            putq " GroupHeading=" @GroupHeading;
            putq " JapaneseStyle=" @JapaneseStyle;
            put  ' Transparent="true"' / if exists(TRANSPARENCY);
            putq " Across=" @Across;
            putq " Down=" @Down;
            putq " Direction=" @Direction;
            putq " LabelPosition=" @LabelPosition;
            putq " SliceLabelPosition=" @SliceLabelPosition;
            putq " PercentLabelPosition=" @PercentLabelPosition;
            putq " StartAngle=" @StartAngle;
            putq " MatchColor=" @MatchColor;
            putq " OtherColor=" @OtherColor;
            putq " HoleSize=" @HoleSize;
            put ">" CR;
          finish:
            put "</Pie>" CR;
            xdent;
        end;


        define event Detail;
          start:
            ndent;
            put "<Detail";
            putq " SliceLabel=" @DetailSlice;
            putq " ValueLabel=" @DetailValue;
            putq " PercentLabel=" @DetailPercent;
            putq " Threshold=" @DetailThreshold;
            putq " Radius=" @DetailRadius;
          finish:
            put "/Detail>" CR;
            xdent;
        end;


        define event BAR;
          start:
            style="GraphCharts";
            pure_style=1;
            ndent;
            put "<Bar";
            putq " ID=" ref_id;
            putq " ChartDataID=" @ChartDataID;
            putq " StyleBy=" @StyleBy;
            putq " ShowBaseline=" @ShowBaseline;
            putq " BarShape=" @BarShape;
            put  ' Transparent="true"' / if exists(TRANSPARENCY);
            putq " IncludeZeroHeightBars=" @IncludeZeroHeightBars;
            putq " CalculatePctByGroup=" @CalculatePctByGroup;
            putq " BarWidth=" @BarWidth;
            putq " BarSpace=" @BarSpace;
            putq " ErrorBarShape=" @ErrorBarShape;
            putq " ErrorBarConfidenceLimits=" @ErrorBarConfidenceLimits;
            putq " LabelStatistic=" @LabelStatistic;
            putq " LabelPosition=" @LabelPosition;
            put ">" CR;
          finish:
            put "</Bar>" CR;
            xdent;
        end;

        define event Radar;
          start:
            ndent;
            put "<Radar";
            putq " ID=" ref_id;
            putq " ChartDataID=" @ChartDataID;
            putq " StarType=" @StarType;
            putq " StartAngle=" @StartAngle;

            putq " CellSpacing=" @CellSpacing;
            putq " NumberOfRows=" @NumberOfRows;
            putq " NumberOfColumns=" @NumberOfColumns;
            putq " TextMode=" @TextMode;
            putq " Spider=" @Spider;
            put ">" CR;
          finish:
            put "</Radar>" CR;
            xdent;
        end;


        define event TopFill;
          start:
            ndent;
            put "<TopFill" ;
            putq " FillForeColor=" @FillForeColor;
            put "/>" CR;
          finish:
            xdent;
        end;

        define event SideFill;
          start:
            ndent;
            put "<SideFill" ;
            putq " FillForeColor=" @FillForeColor;
            put "/>" CR;
          finish:
            xdent;
        end;

        define event TileFillList;
          start:
            ndent;
            put  "<TileFillList>" CR;
          finish:
            put  "</TileFillList>" CR;
            xdent;
        end;

        define event TileFill;
          start:
            ndent;
            put "<TileFill";
            putq " TileIndex=" @TileIndex;
            putq " FillForeColor=" @FillForeColor;
            put "/>" CR;
            xdent;
        end;

        define event ReferenceCircleList;
          start:
            ndent;
            put "<ReferenceCircleList>" CR;
          finish:
            put "</ReferenceCircleList>" CR;
            xdent;
        end;

        define event ReferenceCircle;
          start:
            ndent;
            put "<ReferenceCircle";
            putq " CircleRadius=" @CircleRadius;
            put "/>" CR;
            xdent;
        end;

        define event CircleLine;
          start:
            ndent;
            put "<CircleLine";
            putq " CircleLineStyle=" @LineStyle;
            putq " CircleLineThickness=" @LineThickness;
            putq " CircleColor=" @LineColor;
            putq " CircleLine=" @LineVisible;
            put "/>" CR;
            xdent;
        end;

        define event Histogram;
          start:
            ndent;
            put "<Histogram";
            putq " ID=" ref_id;
            putq " ChartDataID=" @ChartDataID;
            put ">" CR;
          finish:
            put "</Histogram>" CR;
            xdent;
        end;


        define event HighLoPlot;
          start:
            ndent;
            put "<HighLow";
            putq " ID=" ref_id;
            putq " ChartDataID=" @ChartDataID;
            putq " StyleBy=" @StyleBy;
            putq " BoxChartType=" @BoxChartType;
            putq " HighLowType=" @HighLowType;
            putq " BoxStyle=" @BoxStyle;
            putq " BoxCapStyle=" @BoxCapStyle;
            putq " BoxWidth=" @BoxWidth;
            putq " ExcludeData=" @ExcludeData;
            putq " NumberOfStandardDeviations=" @NumberOfStandardDeviations;
            putq " BoundaryPercentile=" @BoundaryPercentile;
            putq " StandardErrorOfMean=" @StandardErrorOfMean;
            putq " PooledVariances=" @PooledVariances;
            putq " LabelPosition=" @LabelPosition;
            put ">" CR;
          finish:
            put "</HighLow>" CR;
            xdent;
        end;

        define event BoxPlot;
          start:
            ndent;
            put "<Box";
            putq " ID=" ref_id;
            putq " ChartDataID=" @ChartDataID;
            putq " StyleBy=" @StyleBy;
            putq " BoxChartType=" @BoxChartType;
            putq " HighLowType=" @HighLowType;
            putq " BoxStyle=" @BoxStyle;
            putq " BoxCapStyle=" @BoxCapStyle;
            putq " BoxWidth=" @BoxWidth;
            putq " ExcludeData=" @ExcludeData;
            putq " NumberOfStandardDeviations=" @NumberOfStandardDeviations;
            putq " BoundaryPercentile=" @BoundaryPercentile;
            putq " StandardErrorOfMean=" @StandardErrorOfMean;
            putq " PooledVariances=" @PooledVariances;
            putq " LabelPosition=" @LabelPosition;
            put ">" CR;
          finish:
            put "</Box>" CR;
            xdent;
        end;

        define event PLOT;
          start:
            ndent;
            put "<Plot";
            putq " ID=" ref_id;
            putq " ChartDataID=" @ChartDataID;
            putq " StyleBy=" @StyleBy;
            putq " ResponseAxis=" @ResponseAxis;
            putq " BreaksVisible=" @BreaksVisible;
            putq " BubbleSize=" @BubbleSize;
            putq " LabelPosition=" @LabelPosition;
            putq " ExcludeData=" @ExcludeData;
            putq " DisplayInBack=" @DisplayInBack;
            put ">" CR;
          finish:
            put "</Plot>" CR;
            xdent;
        end;



        define event Contour;
          start:
            ndent;
            put "<Contour";
            putq " ID=" ref_id;
            putq " ChartDataID=" @ChartDataID;
            putq " StyleBy=" @StyleBy;
            putq " ContourStyle=" @ContourStyle;
            putq " NumberOfLevels=" @NumberOfLevels;
            put ">" CR;
          finish:
            put "</Contour>" CR;
            xdent;
        end;



        define event Scatter3d;
          start:
            ndent;
            put "<Plot";
            putq " ID=" ref_id;
            putq " ChartDataID=" @ChartDataID;
            putq " StyleBy=" @StyleBy;
            put ">" CR;
          finish:
            put "</Plot>" CR;
            xdent;
        end;



        define event MapChart;
          start:
            ndent;
            put "<Map";
            putq " ID=" ref_id;
            putq " ChartDataID=" @ChartDataID;
            putq " StyleBy=" @StyleBy;
            put ">" CR;
          finish:
            put "</Map>" CR;
            xdent;
        end;


        define event MapBar;
          start:
            ndent;
            put "<MapBar";
            putq " BarShape=" @BarShape;
            putq " BarWidth=" @BarWidth;
            put ">" CR;
          finish:
            put "</MapBar>" CR;
            xdent;
        end;


        define event Surface;
          start:
            style="GraphCharts";
            pure_style=1;
            ndent;
            put "<Surface";
            putq " ID=" ref_id;
            putq " ChartDataID=" @ChartDataID;
            putq " StyleBy=" @StyleBy;
            put  ' Transparent="true"' / if exists(TRANSPARENCY);
            putq " GridStyle=" @GridStyle;
            putq " SurfaceContourStyle=" @SurfaceContourStyle;
            putq " FillUnderSurface=" @FillUnderSurface;
            putq " TopColor=" @TopColor;
            putq " BottomColor=" @BottomColor;
            putq " SurfaceStyle=" @SurfaceStyle;
            putq " NumberOfLevels=" @NumberOfLevels;
            put ">" CR;
          finish:
            put "</Surface>" CR;
            xdent;
        end;

        define event DonutLabel;
          start:
            ndent;
            put "<DonutLabel";
            putq " TextColor=" @TextColor;
            putq " TextSize=" @TextSize;
            putq " TextValue=" @TextValue;
            putq " TextVisible=" @TextVisible;
            putq " TextBaselineAngle=" @TextBaselineAngle;
            putq " TextCharacterAngle=" @TextCharacterAngle;
            putq " TextHorizontalAlignment=" @TextHorizontalAlignment;
            putq " TextFont=" @TextFont;
            putq " TextFlags=" @TextFlags;
            put "/>" CR;
            xdent;
        end;



        define event ExplodeList;
          start:
            ndent;
            put "<ExplodeList>" CR;
          finish:
            put "</ExplodeList>" CR;
            xdent;
        end;



        define event InvisbleList;
          start:
            ndent;
            put "<InvisibleList>" CR;
          finish:
            put "</InvisibleList>" CR;
            xdent;
        end;



        define event ErrorBarFill;
          start:
            ndent;
            put "<ErrorBarFill";
            putq " FillForeColor=" @FillForeColor;
            putq " FillVisible=" @FillVisible;
            put "/>" NL;
            xdent;
        end;



        define event InterpolationList;
          start:
            ndent;
            put "<InterpolationList>" CR;
          finish:
            put "</InterpolationList>" CR;
            xdent;
        end;



        define event Area;
          start:
            ndent;
            put "<Area";
            putq " FillForeColor=" @FillForeColor;
            putq " FillFile=" @FillFile;
            putq " FillType=" @FillType;
            put ">" CR;
          finish:
            put "</Area>" CR;
            xdent;
        end;



        define event OutlierSymbol;
          start:
            ndent;
            put "<OutlierSymbol";
            putq " MarkerSymbol=" @MarkerSymbol;
            putq " MarkerVisible=" @MarkerVisible;
            putq " MarkerSize=" @MarkerSize;
            putq " MarkerColor=" @MarkerColor;
            put "/>" NL;
            xdent;
        end;



        define event Needle;
          start:
            ndent;
            put "<Needle";
            putq " LineVisible=" @LineVisible;
            putq " LineStyle=" @LineStyle;
            putq " LineColor=" @LineColor;
            putq " LineColor=" FOREGROUND / if !exists(@LineColor);
            putq " LineThickness=" @LineThickness;
            put "/>" NL;
            xdent;
        end;



        define event LevelList;
          start:
            ndent;
            put "<LevelList>" CR;
          finish:
            put "</LevelList>" CR;
            xdent;
        end;



        define event Level;
          start:
            ndent;
            put "<Level>";
            put  value;
          finish:
            put "</Level>" CR;
            xdent;
        end;



        define event GroupValueList;
          start:
            ndent;
            put "<GroupValueList>" CR;
          finish:
            put "</GroupValueList>" CR;
            xdent;
        end;



        define event ValueList;
          start:
            ndent;
            put "<ValueList>" CR;
          finish:
            put "</ValueList>" CR;
            xdent;
        end;

        define event GraphTitleList;
          start:
            ndent;
            put "<TitleList>" CR;
          finish:
            put "</TitleList>" CR;
            xdent;
        end;

        define event GraphTitle;
            ndent;
            put "<Title";
            putq " TextValue=" @textvalue;
            put "/>" CR;
            xdent;
        end;

        define event MapWKB;
          start:
            ndent;
            put "<MapWKB>";
            put value;
          finish:
            put "</MapWKB>" CR;
            xdent;
        end;

        define event graph_fxd_attributes;
            putq " WIDTH=" OUTPUTWIDTH CR;
            putq " HEIGHT=" OUTPUTHEIGHT CR;
            putq " CLASS=" HTMLCLASS CR;
            put  ' ALIGN="top">' CR;
        end;

        define event graph_attribute;
            put " " NAME;
            putq "=" VALUE CR;
        end;

        define event graph_parameter;
            putq "<Param name=" NAME;
            putq " value=" VALUE;
            put ">" CR;
        end;

        define event metacode_parameter;
            start:
               put '<Param name="MetaCodes"';
               put ' value="';
            finish:
               put ' ">' CR;
        end;

        define event graph_onload;
        end;

        define event graph_fillin_block;
        end;


        define event graph_fxd_parameters;
            start:
               putq '<param name="BackColor" value=' BACKGROUND;
               put ">" CR / exists(BACKGROUND );
               putq '<param name="XML" value=' CR;
               put "'" CR;
            finish:
               put "'" CR;
               put ">" CR;
        end;

        define event html3_center;
            start:
               put "<CENTER>" CR;
            finish:
               put "</CENTER>" CR;
        end;

        define event java_unsupported;
            put "Sorry, your browser does not support the applet tag" CR;
        end;

        define event activex_unsupported;
            put "Sorry, there was a problem displaying the control or plugin in your browser." CR;
        end;

        define event activex_graph;
            start:
                put "<OBJECT " CR;
                putq " ID=" ref_id CR;

            finish:
                put "</OBJECT> " CR;
        end;

        define event java2_parameters;
                put  '<PARAM NAME="type" VALUE="application/x-java-applet;jpi-version=1.3.1">' CR;
                put  '<PARAM NAME="scriptable" VALUE="true">' CR;
        end;


        define event java2_graph;
            start:
                put  '<OBJECT' CR;
/* Clsid for 1.3.0.1
                put  '    classid="clsid:8AD9C840-044E-11D1-B3E9-00805F499D93"' CR;
*/
                put  '    classid="clsid:CAFEEFAC-0013-0001-0000-ABCDEFFEDCBA"' CR;
                putq '    width=' OUTPUTWIDTH CR;
                putq '    height=' OUTPUTHEIGHT CR;
                put  '    align="baseline"' CR;
                put  '    codebase="http://java.sun.com/products/plugin/1.3.1/jinstall-131-win32.cab#Version=1,3,1">' CR;
                put  '<COMMENT>' CR;
                putq '    <APPLET code=' CODE CR;
                putq '        codebase=' CODEBASE CR;
                putq '        archive=' ARCHIVE CR;
                put  '        align="baseline"' CR;
                putq '        width=' OUTPUTWIDTH CR;
                putq '        height=' OUTPUTHEIGHT;
                put  '>' CR;
                put  '   </COMMENT>' CR;

            finish:
                put  '  </APPLET>' CR;
                put  '  </OBJECT>' CR;
            end;


        define event java_graph;
            start:
                put  "<APPLET " CR;
                putq " ID=" ref_id CR;
                put  " MAYSCRIPT" CR;

            finish:
                put "</APPLET> " CR;
        end;

    end;
    %end;  %mend;
    %tagsets_graph;


    /******************************************************/
    /******************************************************/
    /******************************************************/
    /*  HTML with template names and style names          */
    /******************************************************/
    /******************************************************/
    /******************************************************/

    define tagset tagsets.namedhtml;
        notes "This is HTML with full CSS support";
        parent=tagsets.style_popup;

       define event stylesheet;
           finish:
                putl '.obj_label{font-family:obj_label}';
                putl '.obj_label{font-family:Courier;font-weight:normal}';
                putl '.obj_name{font-family:obj_name}';
                putl '.obj_name{font-family:Courier;font-weight:bold}';
                putl '.label{font-family:label}';
                putl '.label{font-family:Courier;font-weight:normal}';
                putl '.label_value{font-family:label_value}';
                putl '.label_value{font-family:Courier;font-weight:bold}';
                putl '.name_label{font-family:name_label}';
                putl '.name_label{font-family:Courier;font-weight:normal}';
                putl '.name_value{font-family:name_value}';
                putl '.name_value{font-family:Courier;font-weight:bold}';
        end;

        define event output;
            start:
                put "<table";
                put ' class="Table"';
                put ' border="1"';
                put ' frame="all"';
                put ">" CR;
                put "<tr>";
                put "<td";
                putq ' class="Data"';
                put ">";
                put '<span class="obj_label">';
                put 'Output Object:&nbsp;';
                put '</span>';
                put '<span class="obj_name">' name '</span>';
                put '<span class="label">';
                put '<br>Label:&nbsp;';
                put '</span>';
                put '<span class="label_value">' label '</span>';
                put '</span>';
                put "</td>" CR;
                put "</tr>";
                put "</table>" CR;
                put "<br>" CR;
        end;

        define event head1;
            trigger pre_post start;
            put "<h1";
            putq " class=" HTMLCLASS;
            trigger align;
            trigger style_inline;
            put ">";
            trigger do_value;
            put "</h1>" CR;
            trigger pre_post finish;
           end;

        define event head2;
            trigger pre_post start;
            put "<h2";
            putq " class=" HTMLCLASS;
            trigger align;
            trigger style_inline;
            put ">";
            trigger do_value;
            put "</h2>" CR;
            trigger pre_post finish;
           end;

        define event head3;
            trigger pre_post start;
            put "<h3";
            putq " class=" HTMLCLASS;
            trigger align;
            trigger style_inline;
            put ">";
            trigger do_value;
            put "</h3>" CR;
            trigger pre_post finish;
           end;


        define event header;
            start:
                put "<th";
                trigger pre_post;
                putq " class=" HTMLCLASS;
                trigger headalign;
                trigger style_inline;
                trigger rowcol;
                put ">";
                trigger do_value;
            finish:
                trigger pre_post;
                put "</th>" CR;
        end;

        define event data;
            put "<td";
            trigger pre_post;
            putq " class=" HTMLCLASS;
            trigger align;
            trigger style_inline;
            trigger rowcol;
            put ">";
            put '<pre>' /if exists(asis);
            trigger do_value;
        finish:
            trigger pre_post;
            put '</pre>' /if exists(asis);
            put "</td>" CR;
        end;

        define event contents_title;
            trigger pre_post start;
            trigger do_value;
            trigger pre_post finish;
        end;

        define event list_entry;
            put "<li";
            putq " class=" HTMLCLASS;
            put ">" CR;
            trigger do_value;
            put "</li>" CR;
        end;


        define event caption;
            put "<td>";
            put '<span class="name_label"> name:&nbsp;</span>' /if exists(name);
            put '<span class="name_value">Name "<br></span>' /if exists(name);
            put TEXT;
        finish:
            put "</td>" CR;
            put "</tr><tr><td>" / if cmp(TYPE, "T");
            put "</td><td>" / if cmp(TYPE, "L");
        end;

        define event contents_branch;
            file=CONTENTS;
        start:
            put "<li";
            putq " class=" HTMLCLASS;
            put ">" CR;
            trigger hyperlink / if any(URL, ANCHOR);
            trigger do_value / if !any(URL, ANCHOR);
            put "</li>" CR;
            put "<ul>";
        finish:
            put "</ul>";
        end;

        define event hyperlink;
            put '<a href="' URL;
            put '"';
            putq " target=" HREFTARGET;
            put ">" ;
            trigger do_value;
            put "</a>" CR;
        end;

        define event contents_leaf;
            file=CONTENTS;
            put "<li";
            putq " class=" HTMLCLASS;
            put ">" CR;
            trigger hyperlink / if any(URL, ANCHOR);
            trigger do_value / if !any(URL, ANCHOR);
            put "</li>" CR;
        end;

        define event do_value;
            put '<span class="name_label">name:&nbsp;</span>' /if exists(name);
            put '<span class="name_value">' name '</span>' /if exists(name);
            put "<br>" /if exists(name);
            put VALUE CR;
        end;

    end;

    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    /* tpl_style Map.  Shows all events generated...                       */
    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    define tagset tagsets.tpl_style_map;
        notes "This is the Template and style map definition";
        map = '<>&';
        mapsub = '/&lt;/&gt;/&amp;/';
        nobreakspace = ' ';
        split = ' ';
        indent=2;
        default_event = 'basic';
        stacked_columns = yes;
        output_type = 'xml';

        define event doc;
            start:
                put '<?xml version="1.0"';
                putq " encoding=" encoding;
                put "?>" CR CR;
                put "<" EVENT_NAME ;
                putq " date="         DATE;
                putq " time="         TIME;
                trigger attr_out;
                put ">" CR;
                ndent;
            finish:
                xdent;
                put "</" EVENT_NAME ">" CR;
        end;

        define event basic;
            start:
                put "<" EVENT_NAME ;
                trigger attr_out;
                put "/" / if exists(empty);
                put ">" CR;
                break / if exists(empty);
                ndent;
            finish:
                break / if exists(empty);
                xdent;
                put "</" EVENT_NAME ">" CR;
        end;

        define event attr_out;
            putq " class="        HTMLCLASS;
            putq " name="         name;
            putq " label="        LABEL;
            putq " value="        VALUE;
        end;

        define event colspecsep;
        end;
        define event colspec;
        end;
        define event cellspecspan;
        end;
        define event rowspecspan;
        end;
        define event rowspec;
        end;
        define event cellspec;
        end;
        define event cellspecsep;
        end;
        define event colspecs;
        end;
        define event colgroup;
        end;
        define event colspec_entry;
        end;
        define event colspanfillsep;
        end;
        define event colspanfill;
        end;
    end;

    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    /* tpl_style list.  Shows all events generated using an html list  */
    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    define tagset tagsets.tpl_style_list;
        notes "This is the Template and style map definition";
        map = '<>&';
        mapsub = '/&lt;/&gt;/&amp;/';
        nobreakspace = '&nbsp;';
        split = '<br>';
        indent=2;
        default_event = 'basic';
        stacked_columns = yes;
        output_type = 'html';

        define event doc;
            start:
                put '<html>';
                put '<body background="#E0E0E0">';
                put "<ul>" CR;
                put '<li><b><font size="+1" color="blue">';
                put EVENT_NAME "</font></b><br>" CR;
                trigger attr_out;
                put '&nbsp;&nbsp;<b> date:</b>' DATE "<br>";
                put '&nbsp;&nbsp;<b> time:</b>' TIME "<br>";
                put "</li>" CR;
                ndent;
                put "<ul>";
            finish:
                put "</ul>";
                xdent;
                put '</body>' CR;
                put '</html>' CR;
        end;

        define event basic;
            start:
                put '<li><b><font size="+1" color="blue">' ;
                put EVENT_NAME "</font></b><br>CR";
                trigger attr_out;
                put "</li>" CR;
                break / if exists(empty);
                put "<ul>" CR;
                ndent;
            finish:
                break / if exists(empty);
                put "</ul>" CR;
                xdent;
        end;

        define event attr_out;
            put '&nbsp;&nbsp;<font color="green"><b>class:</b></font>' htmlclass ;
            put "<br>" / when exists(htmlclass);
            put '&nbsp;&nbsp;<font color="green"><b>name:</b></font>'  name ;
            put "<br>" / when exists(name);
            put '&nbsp;&nbsp;<font color="green"><b>label:</b></font>' label ;
            put "<br>" / when exists(label);
            put '&nbsp;&nbsp;<font color="green"><b>value:</b></font>' value ;
            put "<br>" / when exists(value);
        end;

        define event colspecsep;
        end;
        define event colspec;
        end;
        define event cellspecspan;
        end;
        define event rowspecspan;
        end;
        define event rowspec;
        end;
        define event cellspec;
        end;
        define event cellspecsep;
        end;
        define event colspecs;
        end;
        define event colgroup;
        end;
        define event colspec_entry;
        end;
        define event colspanfillsep;
        end;
        define event colspanfill;
        end;
    end;


    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    /* odsstyle.  creates a proc template of the current style chosen  */
    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    define tagset tagsets.odsstyle;
        indent=4;

        define event stylesheet;
           putl "/*************************************************************************************/";
           putl "/* This is approximate proc template code for an ods style.                          */";
           putl "/* It is a flattened representation of the style chosen on the ods markup            */";
           putl "/* statement.  There is no inheritance, no list elements.  Everything is             */";
           putl "/* repeated as necessary.  Verbose, repetitive and simple...                         */";
           putl "/* there are a few known errors with it.                                             */";
           putl "/* 1. The quoting isn't too smart so anything that has ' in it might cause problems  */";
           putl "/* 2. I don't know the style name so I can't give it a proper name.                  */";
           putl "/*************************************************************************************/" CR;
           putl "proc template;";
           ndent;
           putl "define style styles.mystyle;";
           ndent;
           finish:
           xdent;
           putl "end;";
           xdent;
           putl "run;";
        end;

        define event style_class;
            put "style " HTMLCLASS '/' CR;
            ndent;
            trigger style_template;
            xdent;
            put ';' CR CR;
        end;


        define event style_template;
            putq 'PreText = ' PRETEXT CR;
            putq 'PostText = ' POSTTEXT CR;
            put 'PreImage = ' PREIMAGE CR;
            put 'PostImage = ' POSTIMAGE CR;
            put "PreHTML = '" PREHTML "'" CR /if exists(prehtml);
            put "PostHTML = '" POSTHTML "'" CR /if exists(posthtml);
            put "PageBreakHTML = '" PAGEBREAKHTML "'" CR /if exists(PAGEBREAKHTML);
            putq 'HTMLContentType = ' HTMLCONTENTTYPE CR;
            put "HTMLDocType = '" HTMLDOCTYPE "'" CR /if exists(HTMLDOCTYPE);
            put 'Frame = ' FRAME CR;
            put 'Rules = ' RULES CR;
            put 'Bullet = ' BULLET CR;
            put 'BackgroundImage = ' BACKGROUNDIMAGE CR;
            put 'Flyover = ' FLYOVER CR;
            put 'HTMLId = ' HTMLID CR;
            put 'HTMLStyle = ' HTMLSTYLE CR;
            put 'CSSText = ' CSSTEXT CR;
            put 'CSSStylE = ' CSSSTYLE CR;
            put "TagAttr = '" TAGATTR "'" CR /if exists(tagattr);
            put 'URL = ' URL CR;
            put 'HrefTarget = ' HREFTARGET CR;
            %not8(put 'Gradient_Direction = ' GRADIENT_DIRECTION CR;)
            %not8(put 'Description = ' DESCRIPTION CR;)
            %not8(put 'Image = ' IMAGE CR;)
            %not8(put 'ImageStyle = ' IMAGESTYLE CR;)
            /*-------------------------------------------------------------*/
            /*-- DATP types. Group them all together please.             --*/
            /*-----------------------------------------------------26Feb99-*/
            put 'Borderwidth = ' BORDERWIDTH CR;
            put 'CellWidth = ' CELLWIDTH CR;
            put 'CellHeight = ' CELLHEIGHT CR;
            put 'CellSpacing = ' CELLSPACING CR;
            put 'CellPadding = ' CELLPADDING CR;
            put 'OutputWidth = ' OUTPUTWIDTH CR;
            put 'FrameBorderWidth = ' FRAMEBORDERWIDTH CR;
            put 'FrameSpacing = ' FRAMESPACING CR;
            put 'ContentSize = ' CONTENTSIZE CR;
            put 'BodySize = ' BODYSIZE CR;
            put 'OutputHeight = ' OUTPUTHEIGHT CR;
            put 'LeftMargin = ' LEFTMARGIN CR;
            put 'RightMargin = ' RIGHTMARGIN CR;
            put 'TopMargin = ' TOPMARGIN CR;
            put 'BottomMargin = ' BOTTOMMARGIN CR;
            put 'OverHangFactor = ' OVERHANGFACTOR CR;
            put 'FillRuleWidth = ' FILLRULEWIDTH CR;
            %not8(put 'LineStyle = ' LINESTYLE CR;)
            %not8(put 'Indent = ' INDENT CR;)
            %not8(put 'Transparency = ' TRANSPARENCY CR;)
            put 'LinkColor = ' LINKCOLOR CR;
            put 'VisitedLinkColor = ' VISITEDLINKCOLOR CR;
            put 'Background = ' BACKGROUND CR;
            put 'Foreground = ' FOREGROUND CR;
            put 'BorderColor = ' BORDERCOLOR CR;
            put 'BorderColorDark = ' BORDERCOLORDARK CR;
            put 'BorderColorLight = ' BORDERCOLORLIGHT CR;
            %not8(put 'StartColor = ' STARTCOLOR CR;)
            %not8(put 'EndColor = ' ENDCOLOR CR;)
            /*-------------------------------------------------------------*/
            /*-- TCHR types. Group them all together please.             --*/
            /*-----------------------------------------------------26Feb99-*/
            put 'Just = ' JUST CR;
            /*put 'Default_Just = ' DEFAULT_JUST CR;*/
            put 'VJust = ' Vjust CR;
            /*put 'Default_VJust = ' DEFAULT_VJUST CR;*/
            put 'ContentPosition = left' nl /if cmp(CONTENTPOSITION, 'l');
            put 'ContentPosition = right' nl /if cmp(CONTENTPOSITION, 'r');
            put 'ContentPosition = top' nl /if cmp(CONTENTPOSITION, 't');
            put 'ContentPosition = bottom' nl /if cmp(CONTENTPOSITION, 'b');
            /*-------------------------------------------------------------*/
            /*-- INT types. Group them all together please.              --*/
            /*-----------------------------------------------------26Feb99-*/
            trigger do_font;
            put 'ListEntryAnchor = yes' nl /if cmp(LISTENTRYANCHOR, "1");
            put 'FrameBorder = ' FRAMEBORDER CR /if !cmp(frameborder, "auto");
            put 'ContentScrollbar = ' CONTENTSCROLLBAR CR;
            put 'BodyScrollbar = ' BODYSCROLLBAR CR;
            put 'ProtectSpecialChars = auto' CR /if cmp(PROTECTSPECIALCHARS, "1");
            put 'ProtectSpecialChars = no' CR /if cmp(PROTECTSPECIALCHARS, "2");
            put 'ProtectSpecialChars = yes' CR /if cmp(PROTECTSPECIALCHARS, "3");
            put 'ListEntryDblSpace = ' LISTENTRYDBLSPACE CR;
            put 'AsIs = yes' nl / if cmp(ASIS, "1");
            putq 'NoBreakSpace = ' NOBREAKSPACE CR;
            put 'Watermark = yes' nl /if cmp(WATERMARK, "1");
            /*%not8(put 'Font_Underline = ' FONT_UNDERLINE CR;)*/
            %not8(put 'DropShadow = ' DROPSHADOW CR;)
        end;

        define event do_font;
            break /if !any(font_face, font_size, font_weight, font_style);
            put 'Font = ("';
            put FONT_FACE;
            put '", ';
            %not8(set $num_font_size '1' /if cmp(FONT_SIZE, "xx-small");)
            %not8(set $num_font_size '2' /if cmp(FONT_SIZE, "x-small");)
            %not8(set $num_font_size '3' /if cmp(FONT_SIZE, "small");)
            %not8(set $num_font_size '4' /if cmp(FONT_SIZE, "medium");)
            %not8(set $num_font_size '5' /if cmp(FONT_SIZE, "large");)
            %not8(set $num_font_size '6' /if cmp(FONT_SIZE, "x-large");)
            %not8(set $num_font_size '7' /if cmp(FONT_SIZE, "xx-large");)
            %not8(put $num_font_size;)
            %not8(put FONT_SIZE /if !exists($num_font_size);)
            %not8(unset $num_font_size;)
            %not9(put FONT_SIZE;)
            put ',';
            put ' ' FONT_WEIGHT;
            put ' ' FONT_STYLE;
            put ')' CR;
       end;
    end;

    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    /* Textual Event Map.  Shows all events generated...               */
    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    define tagset tagsets.text_map;
        notes "This is the textual event map definition";
        nobreakspace = ' ';
        split = ' ';
        indent=2;
        default_event = 'basic';
        stacked_columns = yes;
        output_type = 'text';

        define event doc;
            start:
                put "/*------------------------------------------------------------*/" CR;
                put "/*-- before we do anything we've got to write out the       --*/" CR;
                put "/*-- beginning of the doc.                                  --*/" CR;
                put "/*------------------------------------------------------------*/" CR;
                trigger dumpall;
            finish:
                xdent;
                put CR;
                put "/*------------------------------------------------------------*/" CR;
                put "/*-- The end of the doc.  All done.                         --*/" CR;
                put "/*--                                                        --*/" CR;
                put "/*-- Except my indention is wrong.  I'll have to            --*/" CR;
                put "/*-- take a look at that.                                   --*/" CR;
                put "/*------------------------------------------------------------*/" CR;
                trigger dumpall;
        end;

        define event dumpall;
            start:
                trigger dumpit;
                putq " title          "        TITLE CR;
                putq " author         "       AUTHOR CR;
                putq " operator       "     OPERATOR CR;
                putq " sasversion     "   SASVERSION CR;
                putq " saslongversion "   SASLONGVERSION CR;
                putq " date           "         DATE CR;
                putq " time           "         TIME CR;
                putq " encoding       "     ENCODING CR;
                putq " language       "    LANGUAGE CR;
                putq " trantab        "      TRANTAB CR;
                trigger attr_out;
                trigger dumpit finish;
                ndent;
            finish:
                xdent;
                trigger dumpit start;
                trigger attr_out;
                trigger dumpit finish;
        end;

        define event dumpit;
            start:
                put CR;
                put "Event Name is: " EVENT_NAME CR;
                put "    Arguments:" CR;
                ndent;
                ndent;
                ndent;
            finish:
                xdent;
                xdent;
                xdent;
        end;

        define event basic;
            start:
                trigger dumpit;
                trigger attr_out;
                trigger dumpit finish;
                break / if cmp("ColSpecSep", event_name);
                break / if exists(empty);
                ndent;
            finish:
                break / if cmp("ColSpecSep", event_name);
                break / if exists(empty);
                xdent;
                trigger dumpit start;
                trigger attr_out;
                trigger dumpit finish;
        end;

        define event attr_out;
            putq " state:           "        STATE CR;
            putq " empty:           "        EMPTY CR;
            putq " trigger_name     " TRIGGER_NAME CR;
            %not8(putq " output_name      "  OUTPUT_NAME CR;)
            %not8(putq " output_label     "  OUTPUT_LABEL CR;)
            %not8(putq " total_page_count "  total_page_count CR;)
            %not8(putq " page_count       "  page_count CR;)
            %not8(putq " proc_count       "  proc_count CR;)
            %not8(putq " total_proc_count "  total_proc_count CR;)
            %not8(putq " proc_name        "  proc_name CR;)
            %not8(putq " hidden=          "  hidden CR;)
            putq " section          "      SECTION CR;
            putq " class            "        HTMLCLASS CR;
            putq " id               "           HTMLID CR;
            putq " text             "         TEXT CR;
            putq " value            "        VALUE CR;
            putq " rowspan          "      ROWSPAN CR;
            putq " colspan          "      COLSPAN CR;
            putq " row              "          ROW CR;
            putq " colcount         "     COLCOUNT CR;
            putq " col              "          COLSTART CR;
            putq " col_id           "       COL_ID CR;
            putq " ref_id           "       REF_ID CR;
            putq " name             "         NAME CR;
            putq " label            "        LABEL CR;
            putq " clabel           "       CLABEL CR;
            putq " type             "         TYPE CR;
            putq " rawvalue         "     RAWVALUE CR;
            putq " missing          "      MISSING CR;
            putq " path             "         PATH CR;
            putq " flyover          "      FLYOVER CR;
            putq " index            "        ANCHOR CR;
            putq ' just             '         JUST CR;
            putq ' vjust            '        VJUST CR;
            putq " font-face        "    FONT_FACE CR;
            putq " font-size        "    FONT_SIZE CR;
            putq " font-weight      "  FONT_WEIGHT CR;
            putq " font-style       "   FONT_STYLE CR;
            putq " foreground       "   FOREGROUND CR;
            putq " background       "   BACKGROUND CR;
            putq " backgroundImage  " BACKGROUNDIMAGE CR;
            putq " leftmargin       "    LEFTMARGIN CR;
            putq " rightmargin      "   RIGHTMARGIN CR;
            putq " topmargin        "     TOPMARGIN CR;
            putq " bottommargin     "  BOTTOMMARGIN CR;
            putq " BorderColorDark  " BORDERCOLORDARK CR;
            putq " BorderColorLight " BORDERCOLORLIGHT CR;
            putq " bullet           "       BULLET CR;
            putq " outputheight     " OUTPUTHEIGHT CR;
            putq " outputwidth      "  OUTPUTWIDTH CR;
            putq " tagattr          "      TAGATTR CR;
            putq " htmlstyle        "    HTMLSTYLE CR;
            putq " width            "        WIDTH CR;
            putq " scale            "        SCALE CR;
            putq " precision        "    PRECISION CR;
            putq " url              "          URL CR;
            putq " hreftarget       "   HREFTARGET CR;
        end;

        define event doc_head;
          start:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- The document head section.  A place for general        --*/" CR;
             put "/*-- definitions.                                           --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
          finish:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- The end of the document's head section.                --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
        end;

        define event doc_meta;
          start:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- the meta event is for meta data on the doc             --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
          finish:
             trigger basic;
        end;

        define event auth_oper;
          start:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- Author/operator This is sort of superfluous since the  --*/" CR;
             put "/*-- author and operator are always available but sometimes --*/" CR;
             put "/*-- the extra granularity is nice to have.                 --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
          finish:
             trigger basic;
        end;

        define event doc_title;
          start:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- The doc title.  I didn't set a title here though.      --*/" CR;
             put "/*-- it is set on the ods statement with a title=           --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
          finish:
             trigger basic;
        end;

        define event doc_body;
          start:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- The start of the document body.  Now we are looking    --*/" CR;
             put "/*-- for output from a proc.                                --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
          finish:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- The end of the doc body...                             --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
        end;

        define event proc;
          start:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- A proc has established contact with ODS.               --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
          finish:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- The proc is closing down...                            --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
        end;

        define event output;
          start:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- The proc has informed ods it has output for us.        --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
          finish:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- the proc is telling us this the end of that output     --*/" CR;
             put "/*-- object...                                              --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
        end;

        define event anchor;
          start:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- We are going to generate an anchor to link to for the  --*/" CR;
             put "/*-- upcoming output.                                       --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
          finish:
             trigger basic;
        end;

        define event system_title;
          start:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- Here come the system titles...                         --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
          finish:
             trigger basic;
        end;

        define event system_footer;
          start:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- Here come the system footers...                        --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
          finish:
             trigger basic;
        end;

        define event proc_title;
          start:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- The proc sent us a title too.                          --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
          finish:
             trigger basic;
        end;

        define event byline;
          start:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- And we got a byline too.                               --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
          finish:
             trigger basic;
        end;

        define event proc_branch;
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- Here comes the output hierarchy.  This corresponds to  --*/" CR;
             put "/*-- what you see in the results window.  It's a hierarchy  --*/" CR;
             put "/*-- of folders which hold the output from the proc.  A     --*/" CR;
             put "/*-- branch event is a folder, a leaf event is a piece of   --*/" CR;
             put "/*-- output - usually a table.  This first branch is for    --*/" CR;
             put "/*-- the proc it's self.                                    --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
        end;

        define event byline_branch;
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- The proc has requested a sub-folder.                   --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
        end;

        define event folder_branch;
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- The proc has requested a sub-folder.                   --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
        end;

        define event branch;
          start:
             trigger proc_branch /when cmp("ContentProcName", htmlclass);
             trigger byline_branch /when cmp("ByContentFolder", htmlclass);
             trigger folder_branch /when cmp("ContentFolder", htmlclass);
             trigger basic;
          finish:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- The proc is closing the folder/branch.                 --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
        end;


        define event leaf;
          start:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- This is the leaf. It corresponds directly to the       --*/" CR;
             put "/*-- upcoming piece of output.                              --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
          finish:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- This is the end of the leaf.  Each leaf corresponds to --*/" CR;
             put "/*-- one piece of output.  or in ods terms, one output      --*/" CR;
             put "/*-- object.  In html we don't use the finish on the leaf   --*/" CR;
             put "/*-- but in xml it's quite useful.                          --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
        end;

        define event table;
          start:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- Surprise, Surprise it's a table.                       --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
             put CR CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- This next set of events is pretty nasty.  They are     --*/" CR;
             put "/*-- used by latex and troff and probably no one else. at   --*/" CR;
             put "/*-- least not yet.  They are used to create column and row --*/" CR;
             put "/*-- specifications to describe the table.  The easiest way --*/" CR;
             put "/*-- to see what they are used for is to run a              --*/" CR;
             put "/*-- tagsets.latex and tagsets.troff and look at what's there.--*/" CR;
             put "/*------------------------------------------------------------*/" CR;
          finish:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- The end of the table.                                  --*/" CR;
             put "/*-- Foot sections are sortof rare.  Not sure why.          --*/" CR;
             put "/*-- It just doesn't seem to be used much.  sort of         --*/" CR;
             put "/*-- like system footers.                                   --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
        end;

        define event colspecs;
          start:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- These events are a little bit more useful and are used --*/" CR;
             put "/*-- by html and xml quite a bit.  Colspecs....             --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
          finish:
             trigger basic;
        end;

        define event table_head;
          start:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- The table specs are finally done and now we are        --*/" CR;
             put "/*-- starting the head section of the table.                --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
          finish:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- The end of the table's head section.                   --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
        end;

        define event row;
          start:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- Got to have rows.  so, here is the start of one.       --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
          finish:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- A row has to end sometime.                     .       --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
        end;

        define event header;
          start:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- here is a header cell.                                 --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
          finish:
             trigger basic;
        end;

        define event table_body;
          start:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- This is the start of Table body, see the value of      --*/" CR;
             put "/*-- section change....                                     --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
          finish:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- The endis the start of Table body, see the value of      --*/" CR;
             put "/*-- section change....                                     --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
        end;

        define event data_comment;
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- Here comes a data cell.                                --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
        end;

        define event data_header_comment;
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- Here comes a data cell.  This one is a Row header.     --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
        end;

        define event data;
          start:
             trigger data_comment /when cmp("data", htmlclass);
             trigger data_header_comment /when cmp("RowHeader", htmlclass);
             trigger basic;
          finish:
             trigger basic;
        end;

        define event pagebreak;
          start:
             put CR;
             put "/*------------------------------------------------------------*/" CR;
             put "/*-- The proc has requested a pagebreak.  They do that to   --*/" CR;
             put "/*-- keep their output organized.  in html we do an <hr>    --*/" CR;
             put "/*-- here. In latex and troff we force a hard break.        --*/" CR;
             put "/*------------------------------------------------------------*/" CR;
             trigger basic;
          finish:
             trigger basic;
        end;

    end;


    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    /* A tagset for use with Graph's GTableApplet                      */
    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    define tagset tagsets.GTableApplet;

       define event doc;
          start:
             put "<html>" nl;
          finish:
             put "</html>" nl;
       end;

       define event doc_head;
          start:
             put "<head>" nl;
          finish:
             put "</head>" nl;
       end;

       define event doc_title;
          start:
             put "<title>" value "</title>" nl /if exists(value);
       end;

       define event table;
          start:
             put "<object " ;
             put 'classid="clsid:8AD9C840-044E-11D1-B3E9-00805F499D93"';
             put 'codebase="http://java.sun.com/products/plugin/1.3/jinstall-13-win32.cab#Version=1,3,0,0"';
             putq 'width=' outputwidth;
             putq 'height=' outputheight;
             put '>' nl;
             put '<param name="type" value="application/x-java-applet;version=1.3">' nl;
             put '<param name="scriptable" value="false">' nl;
             put '<param name="mayscript" value="true">' nl;
             put '<param name="archive" value="GTableApplet.jar, SASFormats.jar">' nl;
             put '<param name="codebase" value="jars">' nl;
             put '<param name="CODE" value = "GTableApplet">' nl;
          finish:
             put "</object>"  nl;
       end;

       define event data;
          trigger columnName /if cmp(section, "head");
          trigger data_value /if cmp(section, "body");
          trigger cell_link /if exists(url);
          trigger cell_color /if exists(foreground);
          trigger cell_backcolor /if exists(background);
       end;

       define event colspecs;
          put '<param name="ColumnCount" value="' colcount '">' nl;
       end;

       define event colspec_entry;
          trigger columntype;
          put '<param name="columnWidth' colstart '" value="' width '">' nl;
          put '<param name="columnJustification' colstart '" value="' just '">' nl;
          put '<param name="columnMode' colstart '" value="text">' nl;
       end;

       define event columntype;
          put '<param name="columnClass' colstart '"';
          put ' value="';
          put 'Integer' /if cmp(type, "int");
          put 'Double' /if cmp(type, "double");
          put 'String' /if cmp(type, "string");
          put 'Boolean' /if cmp(type, "bool");
          put 'String' /if cmp(type, "char");
          put '">' nl;
       end;

       define event header;
          trigger data /if cmp(section, "body");
          break /if cmp(section, "body");
          trigger columnName;
       end;

       define event columnName;
          put '<param name="columnName' colstart '" value="' value '">' nl;
       end;

       define event cell_link;
          put '<param name="link_' row '_' colstart '" value="' url '">' nl;
       end;

       define event data_value;
          put '<param name="data_' row '_' colstart '" value="' value '">' nl;
       end;

       define event cell_color;
          put '<param name="foreColor' row '_' colstart '" value="' foreground '">' nl;
       end;

       define event cell_backcolor;
          put '<param name="backColor' row '_' colstart '" value="' background '">' nl;
       end;

    end;

    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    /* Short Event Map.  A not so verbose event map                    */
    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    define tagset tagsets.short_map;
    parent=tagsets.event_map;

       define event attr_out;
          putq " name=" name;
          putq " value=" value;
       end;
    end;

    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    /* A fix for 8.2 Latex.  Work around for broken stylesheet         */
    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    define tagset tagsets.latex2;
        parent=tagsets.latex;

        define event doc;
           start:
               put CR '\documentclass[10pt]{article}' CR CR;
               put '%    Generated by SAS' CR;
               put '%    http://www.sas.com' CR;
           trigger inline_style;
           finish:
               put '\end{document}' CR;
        end;

    define event inline_style;
        putl "\usepackage{times}";
        put CR;
        putl "\usepackage{array}";
        put CR;
        putl "\def\ContentTitle{\small\it\sffamily}";
        putl "\def\Output{\small\sffamily}";
        putl "\def\HeaderEmphasis{\small\it\sffamily}";
        putl "\def\NoteContent{\small\sffamily}";
        putl "\def\FatalContent{\small\sffamily}";
        putl "\def\Graph{\small\sffamily}";
        putl "\def\WarnContentFixed{\footnotesize\tt}";
        putl "\def\NoteBanner{\small\sffamily}";
        putl "\def\DataStrong{\normalsize\bf\sffamily}";
        putl "\def\Document{\small\sffamily}";
        putl "\def\BeforeCaption{\normalsize\bf\sffamily}";
        putl "\def\ContentsDate{\small\sffamily}";
        putl "\def\Pages{\small\sffamily}";
        putl "\def\TitlesAndFooters{\normalsize\bf\it\sffamily}";
        putl "\def\IndexProcName{\small\sffamily}";
        putl "\def\ProcTitle{\normalsize\bf\it\sffamily}";
        putl "\def\IndexAction{\small\sffamily}";
        putl "\def\Data{\small\sffamily}";
        putl "\def\Table{\small\sffamily}";
        putl "\def\FooterEmpty{\normalsize\bf\sffamily}";
        putl "\def\SysTitleAndFooterContainer{\small\sffamily}";
        putl "\def\RowFooterEmpty{\normalsize\bf\sffamily}";
        putl "\def\ExtendedPage{\small\it\sffamily}";
        putl "\def\FooterFixed{\footnotesize\tt}";
        putl "\def\RowFooterStrongFixed{\footnotesize\bf\tt}";
        putl "\def\RowFooterEmphasis{\small\it\sffamily}";
        putl "\def\ContentFolder{\small\sffamily}";
        putl "\def\Container{\small\sffamily}";
        putl "\def\Date{\small\sffamily}";
        putl "\def\RowFooterFixed{\footnotesize\tt}";
        putl "\def\Caption{\normalsize\bf\sffamily}";
        putl "\def\WarnBanner{\small\sffamily}";
        putl "\def\Frame{\small\sffamily}";
        putl "\def\HeaderStrongFixed{\footnotesize\bf\tt}";
        putl "\def\IndexTitle{\small\it\sffamily}";
        putl "\def\NoteContentFixed{\footnotesize\tt}";
        putl "\def\DataEmphasisFixed{\footnotesize\it\tt}";
        putl "\def\Note{\small\sffamily}";
        putl "\def\Byline{\normalsize\bf\sffamily}";
        putl "\def\FatalBanner{\small\sffamily}";
        putl "\def\ProcTitleFixed{\footnotesize\bf\tt}";
        putl "\def\ByContentFolder{\small\sffamily}";
        putl "\def\PagesProcLabel{\small\sffamily}";
        putl "\def\RowHeaderFixed{\footnotesize\tt}";
        putl "\def\RowFooterEmphasisFixed{\footnotesize\it\tt}";
        putl "\def\WarnContent{\small\sffamily}";
        putl "\def\DataEmpty{\small\sffamily}";
        putl "\def\Cell{\small\sffamily}";
        putl "\def\Header{\normalsize\bf\sffamily}";
        putl "\def\PageNo{\normalsize\bf\sffamily}";
        putl "\def\ContentProcLabel{\small\sffamily}";
        putl "\def\HeaderFixed{\footnotesize\tt}";
        putl "\def\PagesTitle{\small\it\sffamily}";
        putl "\def\RowHeaderEmpty{\normalsize\bf\sffamily}";
        putl "\def\PagesProcName{\small\sffamily}";
        putl "\def\Batch{\footnotesize\tt}";
        putl "\def\ContentItem{\small\sffamily}";
        putl "\def\Body{\small\sffamily}";
        putl "\def\PagesDate{\small\sffamily}";
        putl "\def\Index{\small\sffamily}";
        putl "\def\HeaderEmpty{\normalsize\bf\sffamily}";
        putl "\def\FooterStrong{\normalsize\bf\sffamily}";
        putl "\def\FooterEmphasis{\small\it\sffamily}";
        putl "\def\ErrorContent{\small\sffamily}";
        putl "\def\DataFixed{\footnotesize\tt}";
        putl "\def\HeaderStrong{\normalsize\bf\sffamily}";
        putl "\def\GraphBackground{}";
        putl "\def\DataEmphasis{\small\it\sffamily}";
        putl "\def\TitleAndNoteContainer{\small\sffamily}";
        putl "\def\RowFooter{\normalsize\bf\sffamily}";
        putl "\def\IndexItem{\small\sffamily}";
        putl "\def\BylineContainer{\small\sffamily}";
        putl "\def\FatalContentFixed{\footnotesize\tt}";
        putl "\def\BodyDate{\small\sffamily}";
        putl "\def\RowFooterStrong{\normalsize\bf\sffamily}";
        putl "\def\UserText{\small\sffamily}";
        putl "\def\HeadersAndFooters{\normalsize\bf\sffamily}";
        putl "\def\RowHeaderEmphasisFixed{\footnotesize\it\tt}";
        putl "\def\ErrorBanner{\small\sffamily}";
        putl "\def\ContentProcName{\small\sffamily}";
        putl "\def\RowHeaderStrong{\normalsize\bf\sffamily}";
        putl "\def\FooterEmphasisFixed{\footnotesize\it\tt}";
        putl "\def\Contents{\small\sffamily}";
        putl "\def\FooterStrongFixed{\footnotesize\bf\tt}";
        putl "\def\PagesItem{\small\sffamily}";
        putl "\def\RowHeader{\normalsize\bf\sffamily}";
        putl "\def\AfterCaption{\normalsize\bf\sffamily}";
        putl "\def\RowHeaderStrongFixed{\footnotesize\bf\tt}";
        putl "\def\RowHeaderEmphasis{\small\it\sffamily}";
        putl "\def\DataStrongFixed{\footnotesize\bf\tt}";
        putl "\def\Footer{\normalsize\bf\sffamily}";
        putl "\def\FolderAction{\small\sffamily}";
        putl "\def\HeaderEmphasisFixed{\footnotesize\it\tt}";
        putl "\def\SystemTitle{\large\bf\it\sffamily}";
        putl "\def\ErrorContentFixed{\footnotesize\tt}";
        putl "\def\SystemFooter{\large\bf\it\sffamily}";
        put CR;
        putl "% Set cell padding";
        putl "\renewcommand{\arraystretch}{1.3}";
        put CR;
        putl "% Headings";
        putl "\newcommand{\sasheading}[2]{\csname#1\endcsname #2}";
        putl "\newcommand{\proctitle}[2]{\csname#1\endcsname #2}";
        put CR;
        putl "% Declare new column type";
        putl "\newcolumntype{S}[2]{>{\csname#1\endcsname}#2}";
        put CR;
        putl "% Set warning box style";
        putl "\newcommand{\msg}[2]{\fbox{%";
        putl "   \begin{minipage}{\textwidth}#2\end{minipage}}%";
        putl "}";
        end;

   end;

    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    /* SASReport.  Shows all events relevant to SAS Report XML         */
    /* Support:    Eric Gebhart (saseag)                               */
    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
   %macro tagsets_sasreport;

    %if  %substr(&sysver,1,1) = 8 %then %do;
       /* not in version 8 */
       %end;

    %else %do;

    define tagset tagsets.SASReport;
        parent = tagsets.graph;
        notes "This is the SAS Report XML event map definition";

        map = '<>&';
        mapsub = '/&lt;/&gt;/&amp;/';
        nobreakspace = ' ';
        split = '&amp;#xa;';
        indent=2;
        stacked_columns = no;
        output_type = 'xml';

        define event inline_style;
           trigger stylename;
           trigger page_break_before;
           trigger text_align;
        end;

        define event stylename;
           putq ' style:style=' htmlclass;
        end;

        define event page_break_before;
           unset $breakpage;
        end;

        define event text_align;
        put  ' style:textAlign=';
            put  '"center"' / if cmp(just, 'c');
            put  '"left"' / if cmp(just, 'l');
            put  '"right"' / if cmp(just, 'r');
            put  '"right"' / if cmp(just, 'd');
        end;

      define event doc;
         start:
            put '<SASReport Version="1.0" xmlns:style="http://www.sas.com/sasreportmodel/styles">' nl;
            ndent;
         finish:
            xdent;
            put '</SASReport>' nl;
      end;

      define event doc_body;
         start:
            put '<Data>' nl;
            ndent;
            put '<DataList>' nl;
            ndent;
         finish:
            xdent;
            put '</DataList>' nl;
            xdent;
            put '</Data>' nl;
      end;

      define event row;
         start:
            put '<ValueList>' nl;
            ndent;
         finish:
            xdent;
            put '</ValueList>' nl;
      end;

      define event header;
         start:
            trigger data;
         finish:
            trigger data;
      end;

      define event data;
         start:
            put '<Value>';
            put value;
         finish:
            put '</Value>' nl;
      end;

      define event table_body;
         start:
            put '<DataValues';
            putq ' ValueListCount=' $valuecount;
            put '>' nl;
            ndent;
         finish:
            xdent;
            put '</DataValues>' nl;
      end;

      define event view_table;
         file=contents;
         start:
           put "<Table";
           putq ' data=' anchor;
           trigger inline_style;
           put '>' nl;
           ndent;
         finish:
           xdent;
           put "</Table>" nl;
      end;

      define event table;
         start:
           trigger view_table;
           put "<IQDataList>" nl;
           ndent;
           put "<IQData" ;
           putq ' id=' anchor ' type="EmbeddedData">' nl;
           ndent;
           put "<EmbeddedData>" nl;
           ndent;
         finish:
           trigger view_table;
           xdent;
           put "</EmbeddedData>" nl;
           xdent;
           put "</IQData>" nl;
           xdent;
           put "</IQDataList>" nl;
      end;

      define event colspecs;
         start:
           trigger view_columns;
           put "<VariableList> " nl;
           set $valuecount colcount;
           ndent;
         finish:
           trigger view_columns;
           xdent;
           put "</VariableList> " nl;
      end;

      define event view_columns;
         file=contents;
         start:
           put "<Columns> " nl;
           ndent;
         finish:
           xdent;
           put "</Columns> " nl;
      end;

      define event colspec_entry;
        start:
           put '<Variable';
           put  ' id="var' col_id '"';
           putq ' name=' name;
           putq ' label=' value;
           putq ' type=' type;
           put  ' encoding="Text">' nl;
           trigger view_column;
        finish:
           put '</Variable>' nl;
           trigger view_column;
      end;

      define event span_group;
        file=contents;
        start:
           put '<LabelGroup';
           put ' isStacked="True"' /if exists(is_stacked);
           put '>' nl;
           ndent;
           put  '<Label';
           trigger stylename;
           trigger text_align;
           put '>';
           put value;
           put '</Label>' nl;
        finish:
           xdent;
           put '</LabelGroup>' nl;
      end;

      define event span_header_colspec;
        file=contents;
        start:
           put  '<Variable';
           put  ' id="var' col_id '"';
           putq ' label=' value;
           putq ' type=' type;
           /* putq ' Name=' name;*/
           put  ' Encoding="Text">' nl;
        finish:
           put '</Variable>' nl;
      end;

      define event view_column;
        file=contents;
        start:
           put '<Column';
           put ' variable="var' col_id '"';
           trigger stylename;
           trigger text_align;
           /*putq ' Name=' name;*/
           put  '>' nl;
           ndent;
        finish:
           xdent;
           put '</Column>' nl;
      end;

      define event sub_colspec_header;
        file=contents;
        start:
           put  '<Label';
           trigger stylename;
           trigger text_align;
           put '>';
           put value;
        finish:
           put '</Label>' nl;
      end;

      define event table_head;
         start:
            block data;
            block row;
            block header;
         finish:
            unblock data;
            unblock row;
            unblock header;
      end;

      define event textheader;
            file=contents;
            put '<Text';
            trigger inline_style;
            put '>' nl;
            put value nl;
            put '</Text>' nl;
      end;

        define event system_title_group;
            file=contents;
          start:
            put '<Header';
            put '>' nl;
            ndent;
          finish:
            xdent;
            put '</Header>' nl;
        end;

/*

        define event system_footer_group;
            file=contents;
          start:
            put "<Footer>" nl;
            ndent;
          finish:
            xdent;
            put "</Footer>" nl;
        end;
*/

/*
        define event page_setup;
            file=contents;
          start:
            put "<PageSetup>" nl;
            ndent;
          finish:
            xdent;
            put "</PageSetup>" nl;
        end;
*/

        define event proc_title_group;
      file=contents;
          start:
            trigger innersection finish;
            trigger page_headers;
          finish:
            trigger page_headers;
            trigger bodysection start;
        end;

/*
        define event system_title_setup_group;
            file=contents;
          start:
            put '<Header';
            put '>' nl;
            ndent;
          finish:
            xdent;
            put '</Header>' nl;
        end;
*/

/*
        define event system_footer_setup_group;
            file=contents;
          start:
            put '<PageFooter';
            trigger inline_style;
            put '>' nl;
            ndent;
          finish:
            xdent;
            put '</PageFooter>' nl;
        end;
*/

        define event innersection;
            start:
              break /if exists($innersection);
              trigger section;
              set $innersection "true";
            finish:
              break /if !exists($innersection);
              trigger section;
              unset $innersection;
        end;

        define event leaf;
            file=contents;
            start:
              trigger page_headers finish;
              trigger innersection;
              trigger bodysection start;
        end;

        define event bodysection;
           start:
                break /if exists($inbody);
                set $inbody "True";
                put "<Body>" nl;
                ndent;
           finish:
                break /if !exists($inbody);
                xdent;
                put "<Body>" nl;
                unset $inbody;
        end;

        define event page_headers;
           file=contents;
           start:
              trigger innersection;
              break /if exists($in_page_headers);
              put '<Header>' nl;
              ndent;
              set $in_page_headers 'true';
           finish:
              break /if !exists($in_page_headers);
              xdent;
              put '</Header>' nl;
              unset $in_page_headers;
        end;

        define event proc;
            file=contents;
            start:
                trigger section;
                trigger pagebreak_section start;
            finish:
                trigger pagebreak_section finish;
                trigger section;
        end;

        define event pagebreak_section;
            start:
               put '<Section name="newpage" breakAfter="true">' nl;
               ndent;
            finish:
               xdent;
               put '</Section>' nl;
        end;


        define event pagebreak;
            file=contents;
            trigger bodysection finish;
            trigger innersection finish;
            trigger pagebreak_section finish;
            trigger pagebreak_section start;
        end;

        define event system_title;
            file=contents;
            trigger textheader;
        end;

        define event system_footer_group;
            file=contents;
          start:
            trigger bodysection finish;
            trigger innersection finish;
            put '<Footer';
            trigger inline_style;
            put '>' nl;
            ndent;
          finish:
            xdent;
            put '</Footer>' nl;
        end;

        define event system_footer;
            file=contents;
            put '<text';
            trigger inline_style;
            put '>' nl;
            put value nl;
            put '</text>' nl;
        end;

        define event byline;
            trigger system_title;
        end;

        define event proc_title;
            trigger system_title;
        end;

        define event proc_title_redef;
            file=contents;
            put '<Text';
            trigger inline_style;
            putq ' topOfPage="True"';
            put '>' nl;
            put value nl;
            put '</Text>' nl;
        end;

        define event note;
            trigger textheader;
        end;
        define event error;
            trigger textheader;
        end;
        define event fatal;
            trigger textheader;
        end;
        define event warning;
            trigger textheader;
        end;


        define event bygroup;
           start:
           trigger section;
           finish:
           trigger section;
        end;

/*
        define event branch;
           start:
           trigger section;
           finish:
           trigger section;
        end;

        define event leaf;
           file=contents;
           start:
               trigger section;
               set $inleaf 'true';
               put "<Body>" nl;
               ndent;
               put '<GriddedLayout Columns="1"/>' nl;
           finish:
               xdent;
               put "</Body>" nl;
               unset $inleaf;
               trigger section;
        end;
*/

        define event section;
           file=contents;
           start:
               put "<Section";
               putq " name=" value;
               putq " name=" name /if !exists(value);
               put ">" nl;
               ndent;
               put '<GriddedLayout Columns="1"/>' nl;
           finish:
               xdent;
               put "</Section>" nl;
        end;

/*
        define event contents_body;
           start:
           trigger section;
           finish:
           trigger section;
        end;
*/

        define event contents;;
           file=contents;
           start:
               put '<SASReport Version="1.0" xmlns:style="http://www.sas.com/sasreportmodel/styles">' nl;
               ndent;
               put "<View>" nl;
               ndent;
           finish:
               xdent;
               put "</View>" nl;
               xdent;
               put '</SASReport>' nl;
        end;

  end;

 %end;  %mend;
 %tagsets_sasreport;


run;
